2016-06-16  Werner Koch  <wk@gnupg.org>

	Release 2.1.13.

2016-06-16  Yuri Chornoivan  <yurchor@ukr.net>

	po: Update Ukrainian translation.

2016-06-16  Ineiev  <ineiev@gnu.org>

	po: Update Russian translation.

2016-06-16  Werner Koch  <wk@gnupg.org>

	po: Update German translation.

	Add missing files so that make distcheck works again,
	* tests/openpgp/Makefile.am (CLEANFILES): Add created file
	"passphrases".
	* tools/Makefile.am (EXTRA_DIST): Add no-libgcrypt.c.

	tools: Fix typo in function name of symcryptrun.
	* tools/symcryptrun.c (main): Fix typo.

2016-06-14  Werner Koch  <wk@gnupg.org>

	gpg: Print the subkey's curve and not the primary key curve.
	* g10/keylist.c (list_keyblock_colon): Use PK2 for the subkey's curve.

	ldap: Improve info output for v3 fallback.
	* dirmngr/dirmngr_ldap.c (fetch_ldap): Do not use log_debug in an
	unprotected section.  Replace log_debug by log_info in verbose mode.

2016-06-14  Andre Heinecke  <aheinecke@intevation.de>

	dirmngr: Try ldap protocol V3 as fallback.
	* dirmngr/dirmngr_ldap.c (fetch_ldap): Try V3 Protocol in case
	default Protocol gives error.

	dirmngr: Print ldap error if bind fails.
	* dirmngr/dirmngr_ldap.c (fetch_ldap): Use ldap_err2string on bind
	return.

2016-06-14  Werner Koch  <wk@gnupg.org>

	gpgsm: Allow ciphers AES192 and SERPENT256.
	* sm/gpgsm.c (main): Add AES192 cipher.  Allow SERPENT256.

	doc: Add files and envvars to a new index.
	* doc/gnupg.texi: Define new index "ef".
	(Environment Index): New.

	gpg: Avoid endless loop in a tofu error case.
	* g10/tofu.c (get_trust): Do not jump to out.

	gpg: Split tofu's get_trust function into several smaller ones.
	* g10/tofu.c (get_trust): Factor code out to ...
	(format_conflict_msg_part1): new and to ...
	(ask_about_binding): new.

2016-06-13  Werner Koch  <wk@gnupg.org>

	gpg: Un-deprecate option --auto-key-retrieve.
	* g10/gpg.c (main): Remove deprecation warning.

	gpg: New option --disable-signer-uid, create Signer's UID sub-packet.
	* g10/gpg.c (oDisableSignerUID): New.
	(opts): New option '--disable-signer-uid'.
	(main): Set option.
	* g10/options.h (opt): Add field flags.disable_signer_uid.
	* g10/sign.c: Include mbox-util.h.
	(mk_notation_policy_etc): Embed the signer's uid.
	* g10/mainproc.c (check_sig_and_print): Do not use WKD for auto key
	retrieval if --disable-signer-uid is used.

	gpg: Try Signer's User ID sub-packet with --auto-key-retrieve.
	* g10/packet.h (PKT_signature): Add field 'signers_uid'.
	* g10/parse-packet.c (parse_signature): Set this field.
	* g10/free-packet.c (free_seckey_enc): Free field.
	(copy_signature): Copy field.
	* g10/mainproc.c (akl_has_wkd_method): New.
	(check_sig_and_print): Extend NEWSIG status.  If WKD is enabled try to
	locate a missing key via the signature's Signer's User ID sub-packet.
	Do this right before trying a keyserver lookup.

2016-06-11  Werner Koch  <wk@gnupg.org>

	gpg: Remove C-99ism, re-indent, and simplify one function.
	* g10/call-agent.c (struct keyinfo_data): Rename to
	keyinfo_data_parm_s.
	(agent_get_keyinfo): Replace C-99 style init.
	(keyinfo_status_cb): Use new fucntion split_fields.
	* g10/export.c (match_curve_skey_pk): Add missings returns error
	cases.
	(cleartext_secret_key_to_openpgp): Better clear PK->PKEY first.

	common: New function split_fields.
	* common/stringhelp.c (split_fields): New.
	* common/t-stringhelp.c: Include assert.h.
	(test_split_fields): New.
	(main): Call test.

2016-06-11  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	g10: Export cleartext keys as cleartext.
	* g10/export.c (do_export_stream): If a key is stored by the agent in
	cleartext, then try to export it as cleartext.
	* tests/openpgp/export.test: For secret keys that are stored in
	cleartext, test should try to export without pinentry interaction.

	g10: Allow receiving cleartext secret keys from agent.
	* g10/export.c (match_curve_skey_pk): New function, testing whether an
	OpenPGP public key and an S-expression use the same curve.
	* g10/export.c (cleartext_secret_key_to_openpgp): New function,
	filling in the secret key parameters of a PKT_public_key object from
	a corresponding cleartext S-expression.
	* g10/export.c, g10/main.h (receive_seckey_from_agent): Add cleartext
	parameter, enabling retrieval of the secret key, unlocked.
	* g10/export.c (do_export_stream): Send cleartext as 0, keeping current
	behavior.
	* g10/keygen.c (card_store_key_with_backup): Use cleartext=0 to ensure
	that smartcard backups are all passphrase-locked.

	g10: Add openpgp_protected flag to agent secret key export functions.
	* g10/call-agent.c, g10/call-agent.h (agent_export_key): Add
	openpgp_protected flag.
	* g10/export.c (receive_seckey_from_agent): Request openpgp_protected
	secret keys from agent.
	* agent/command.c (hlp_export_key): EXPORT_KEY help text: add a
	brief description of the effect of --openpgp.

	g10: report whether key in agent is passphrase-protected or not.
	* g10/call-agent.c, g10/call-agent.h (agent_get_keyinfo): add
	  r_cleartext parameter to report whether a key is stored without
	  passphrase protection.
	* g10/gpgv.c, g10/test-stubs.c: augment dummy agent_get_keyinfo to
	  match new API.
	* g10/export.c, g10/keyedit.c, g10/keygen.c, g10/keylist.c,
	  g10/sign.c: pass NULL to agent_get_keyinfo since we do not yet
	  need to know whether agent is passphrase-protected.

2016-06-08  Werner Koch  <wk@gnupg.org>

	Explicitly restrict socket permissions.
	* agent/gpg-agent.c (create_server_socket): Call chmod before listen.
	* scd/scdaemon.c (create_server_socket): Ditto.
	* dirmngr/dirmngr.c (main): Ditto.

	w32: Fix recent build regression.
	* common/homedir.c (_gnupg_socketdir_internal) [W32]: Add definition
	for NAME.
	* g10/gpg.c (main) [W32]:  Fix use og gnupg_homedir.

	* agent/gpg-agent.c (remove_socket): Remove unused var P.
	* scd/scdaemon.c (cleanup): Ditto.

	gpgconf: New commands --create-socketdir and --remove-socketdir.
	* tools/gpgconf.c: Include unistd.h.
	(aCreateSocketDir, aRemoveSocketDir): New.
	(opts): Add --create-socketdir and --remove-socketdir.
	(main): Implement them.

	Implement /run/user/UID/gnupg based sockets.
	* common/homedir.c: Include sys/stat.h and zb32.h.
	(w32_portable_app, w32_bin_is_bin): Change type from int to byte.
	(non_default_homedir): New.
	(is_gnupg_default_homedir): New.
	(default_homedir): Set non_default_homedir.
	(gnupg_set_homedir): Set non_default_homedir and make
	the_gnupg_homedir and absolute directory name.
	(gnupg_homedir): Return an absolute directory name.
	(_gnupg_socketdir_internal): New.
	(gnupg_socketdir): Implement /run/user/ based sockets.
	* tools/gpg-connect-agent.c (get_var_ext): Replace now obsolete
	make_filename by xstrdup.
	* tools/gpgconf.c (main): Sue gnupg_homedir for the "homedir:" output.

	gpgconf: Add option --homedir.
	* tools/gpgconf.c (opts): Add --homedir.
	(main): Set homedir.

	Do not use no-libgcrypt dummy for tools.
	* tools/Makefile.am (gpgconf_SOURCES): Remove no-libgcrypt.c.
	(gpgconf_LDADD): Add LIBGCRYPT_LIBS.
	(gpg_connect_agent_LDADD): Ditto.
	(gpgtar_LDADD): Ditto.
	* dirmngr/Makefile.am (dirmngr_client_LDADD): Ditto.
	(t_common_ldadd): Ditto.  Remove no-libgcrypt.o.

	Do not try to remove the enclosing directory of sockets.
	* agent/gpg-agent.c (remove_socket): Do not remove the enclosing
	directory.
	* scd/scdaemon.c (cleanup): Ditto.

2016-06-07  Werner Koch  <wk@gnupg.org>

	common: New function gnupg_socketdir.
	* common/homedir.c (gnupg_socketdir): New.
	* agent/gpg-agent.c (create_socket_name): Use new function instead of
	gnupg_homedir.
	(check_own_socket): Ditto.
	(check_for_running_agent): Ditto.
	* agent/preset-passphrase.c (main): Ditto.
	* common/asshelp.c (start_new_gpg_agent): Ditto.
	* scd/scdaemon.c (create_socket_name): Ditto.
	* tools/gpgconf.c (main): Ditto.
	* tools/symcryptrun.c (main): Ditto.

	common: Remove homedir arg from start_new_{dirmngr,gpg_agent}.
	* common/asshelp.c (start_new_gpg_agent): Remove arg 'homedir' in
	favor of gnupg_homedir ().  Change all callers.
	(start_new_dirmngr): Ditto.
	* common/get-passphrase.c (gnupg_prepare_get_passphrase): Remove arg
	'homedir'.

	Replace use of opt.homedir by accessor functions.
	* common/homedir.c (the_gnupg_homedir): New var.
	(gnupg_set_homedir): New.
	(gnupg_homedir): New.
	* g10/options.h (struct opt): Remove 'homedir' and replace all users
	by the new accessor functions.
	* g13/g13-common.h (struct opt): Ditto.
	* scd/scdaemon.h (struct opt): Ditto.
	* sm/gpgsm.h (struct opt): Ditto.
	* dirmngr/dirmngr.h (struct opt): Ditto.
	* agent/preset-passphrase.c (opt_homedir): Ditto.
	* agent/protect-tool.c (opt_homedir): Ditto.

2016-06-07  NIIBE Yutaka  <gniibe@fsij.org>

	po: Update Japanese translation.

	gpg: Fix command line parsing of --quick-addkey and --quick-gen-key.
	* g10/gpg.c (main): Compose a block by curly braces.

2016-06-06  Werner Koch  <wk@gnupg.org>

	gpg: Use --keyid-format=none by default.
	* g10/gpg.c (main): Init keyid_format to KF_NONE.
	* g10/keyid.c (format_keyid): Ditto.
	(keystrlen): Ditto.

	gpg: Add option --with-subkey-fingerprint.
	* g10/gpg.c (oWithSubkeyFingerprint): New.
	(opts): Add --with-subkey-fingerprint[s].
	(main): Set that option.
	* g10/options.h (struct opt): Add 'with_subkey_fingerprint'.
	* g10/keylist.c (list_keyblock_print): Print subkey fingerprint.
	(print_fingerprint): Tweak printing to use compact format if
	desirable.

	gpg: Implement --keyid-format=none.
	* g10/gpg.c (main): Add option "none" to --keyid-format.
	* g10/options.h (KF_NONE): New.
	* g10/keyid.c (format_keyid): Implement that.
	(keystr): Use format "long" is KF_NONE is in use.
	(keystr_with_sub): Ditto.
	* g10/keylist.c (list_keyblock_print): Adjust indentaion for KF_NONE.
	Factor some code out to ...
	(print_key_line): new.
	(print_fingerprint): Add mode 20.
	* g10/mainproc.c (list_node): Use print_key_line.  Replace MAINKEY by
	flags.primary in the PK.  Fix putting a " revoked..." string into the
	colons format.
	* g10/pkclist.c (do_edit_ownertrust): Use print_key_line.  This
	slightly changes the putput format.
	* g10/revoke.c (gen_standard_revoke): Use print_key_line.  This may
	also put "expires: " into the output.

2016-06-04  Werner Koch  <wk@gnupg.org>

	w32: Require --enable-build-timestamp for the BUILD_HOSTNAME.
	* configure.ac (BUILD_HOSTNAME): Set to "<anon>" bey default.
	* build-aux/speedo.mk (speedo_pkg_gnupg_configure): Add
	  --enable-build-timestamp.

2016-06-02  Werner Koch  <wk@gnupg.org>

	gpg: Add the fingerprint to KEY_CREATED for subkeys.
	* g10/keygen.c (print_status_key_created): Make more robust by
	allowing a NULL for PK.
	(generate_subkeypair): Use print_status_key_created.
	(generate_card_subkeypair): Ditto.

	gpg: Try to use the passphrase from the primary for --quick-addkey.
	* agent/command.c (cmd_genkey): Add option --passwd-nonce.
	(cmd_passwd): Return a PASSWD_NONCE in verify mode.
	* g10/call-agent.c (agent_genkey): Add arg 'passwd_nonce_addr' and do
	not send a RESET if given.
	(agent_passwd): Add arg 'verify'.
	* g10/keygen.c (common_gen): Add optional arg 'passwd_nonce_addr'.
	(gen_elg, gen_dsa, gen_ecc, gen_rsa, do_create): Ditto.
	(generate_subkeypair): Use sepeare hexgrip var for the to be created
	for hexgrip feature.  Verify primary key first.  Make use of the
	passwd nonce.  Allow for a static passphrase.

	gpg: Extend the --quick-gen-key command.
	* g10/keygen.c (quickgen_set_para): Add arg 'use'.
	(quick_generate_keypair): Add args 'algostr', 'usagestr', and
	'expirestr'.  Implement primary only key mode.
	(parse_algo_usage_expire): Set NBITS for the default algo.
	* g10/gpg.c (main): Extend --quick-gen-key command.

	gpg: Improve the new parse_subkey_algostr_usagestr fucntion.
	* g10/keygen.c (parse_usagestr): Allow "cert".
	(generate_subkeypair): Factor expire parsing out to ...
	(parse_subkey_algostr_usagestr): here.  Rename to ...
	(parse_algo_usage_expire): this.  Add arg 'for_subkey'.  Set CERT for
	primary key and check that it is not set for subkeys.

	gpg: New command --quick-addkey.
	* g10/keygen.c (DEFAULT_STD_SUBKEYUSE): New.
	(ask_keysize): Factor code out to ...
	(get_keysize_range, fixup_keysize): new.
	(parse_parameter_usage): Factor parsing out to  ...
	(parse_usagestr): new.  Allow use of "encr" as alias for "encrypt".
	(parse_subkey_algostr_usagestr): New.
	(generate_subkeypair): Add new args.  Implement unattended mode.

	* g10/keyedit.c (keyedit_quick_sign): Factor some code out to ...
	(find_by_primary_fpr): new.
	(keyedit_quick_addkey): New.
	* g10/gpg.c (aQuickAddKey): New.
	(opts): Add --quick-addkey.
	(main): Implement.

	gpg: Do not abort on certain invalid packets.
	* g10/build-packet.c (write_fake_data): Check for non-opaque data.
	* g10/seskey.c (do_encode_md): Return NULL instead of abort.

	common: New function openpgp_is_curve_supported.
	* common/openpgp-oid.c: Include openpgpdefs.h.
	(oidtable): Add field pubkey_algo.
	(openpgp_is_curve_supported): New.

2016-06-01  NIIBE Yutaka  <gniibe@fsij.org>

	g10: Allow User ID length >= 256.
	* build-packet.c (do_user_id): Call write_header2 with HDRLEN not set.

2016-05-31  Werner Koch  <wk@gnupg.org>

	gpg: New status code NOTATION_FLAGS.
	* common/status.h (STATUS_NOTATION_FLAGS: New.
	* g10/packet.h (struct notation): Add flags.human.
	(notation_t): New typedef.
	* g10/build-packet.c (sig_to_notation): Set flags.human.
	* g10/keylist.c (show_notation): Write STATUS_NOTATION_FLAGS.

2016-05-28  Werner Koch  <wk@gnupg.org>

	common: Add a status callback to gnupg_exec_tool_stream.
	* common/exectool.h (exec_tool_status_cb_t): New.
	* common/exectool.c: Include missing exectool.h.
	(read_and_log_buffer_t): Replace array by pointer.
	(gnupg_exec_tool_stream): Add args 'status_cb' and 'status_cb_value'.
	Change all callers to pass NULL for them.  Malloc buffer for
	FDERRSTATE.
	(read_and_log_stderr): Implement status_fd feature.

2016-05-27  Werner Koch  <wk@gnupg.org>

	common: Allow a second input stream for gnupg_exec_tool_stream.
	* common/exechelp-posix.c (do_exec): Add arg 'except' and pass to
	close_all_fds.
	(gnupg_spawn_process): Add arg 'except'.  Change callers to pass NULL
	for it.
	* common/exechelp-w32.c (gnupg_spawn_process): Add dummy arg 'except'.
	* common/exechelp-w32ce.c (gnupg_spawn_process): Ditto.
	* common/exectool.c (copy_buffer_do_copy): Allow NULL for SINK.
	(gnupg_exec_tool_stream): Add arg 'inextra'. Change callers to pass
	NULL for it.  Allow NULL for OUTPUT.

	common: Simplify the fd closing patch 512c56a.
	* common/exechelp-posix.c (get_max_fds): Use /proc/self.

	common: Speedup closing fds before an exec.
	* common/exechelp-posix.c [__linux__]: Include dirent.h.
	(get_max_fds) [__linux__]: Return the actual used highest fd.

	tools: Improve debug output of rfc822parse.
	* tools/rfc822parse.c (show_event): Add missing events.

	build: Remove obsolete tests for funopen and fopencookie.
	* configure.ac (AC_CHECK_FUNCS): Remove tests for funopen.

	common: Extend gnupg_create_inbound_pipe et al.
	* common/exechelp-posix.c (gnupg_create_inbound_pipe): Add args 'r_fp'
	and 'nonblock'.
	(gnupg_create_outbound_pipe): Ditto.
	* common/exechelp-w32.c (gnupg_create_inbound_pipe): Add non yet
	functional args 'r_fp' and 'nonblock'.
	(gnupg_create_outbound_pipe): Ditto.
	* common/exechelp-w32ce.c (gnupg_create_inbound_pipe): Ditto.
	(gnupg_create_outbound_pipe): Ditto.

	common: Make use of default_errsource in exechelp.
	* common/exechelp-posix.c (my_error_from_syserror, my_error): New.
	Use them instead of gpg_error and gpg_error_from_syserror.
	(create_pipe_and_estream): Remove arg ERRSOURCE and fix use of
	OUTBOUND which has a wrong name.  Adjust callers.
	(gnupg_spawn_process): Remove arg ERRSOURCE and replace by use of
	DEFAULT_ERRSOURCE.
	* common/exechelp-w32.c (gnupg_spawn_process): Ditto.
	* common/exechelp-w32ce.c (gnupg_spawn_process): Ditto.
	* common/exectool.c (gnupg_exec_tool_stream):  Do not pass
	GPG_ERROR_FROM_SYSERROR.
	* tools/gpgconf-comp.c (gc_component_check_options): Ditto.
	(retrieve_options_from_program): Ditto.

	gpg: Keep current and total of PROGESS status lines small enough.
	* g10/progress.c (progress_filter): Factor status wrote out to...
	(write_status_progress): New.  Scale values down.

2016-05-27  NIIBE Yutaka  <gniibe@fsij.org>

	configure: Detection of libusb on FreeBSD.
	* configure.ac (LIBUSB_LIBS): Use LIBUSB_NAME for AC_CHECK_LIB.

2016-05-25  Werner Koch  <wk@gnupg.org>

	build: Switch to new URL for swdb.lst.

2016-05-24  Werner Koch  <wk@gnupg.org>

	gpgtar: Simplify code by using ccparray.
	* tools/gpgtar-create.c (gpgtar_create): Use ccparray functions.
	* tools/gpgtar-extract.c (gpgtar_extract): Ditto.
	* tools/gpgtar-list.c (gpgtar_list): Ditto.

	common: Add simple dynamic array function.
	* common/ccparray.c: New.
	* common/ccparray.h: New.
	* common/t-ccparray.c: New.
	* common/Makefile.am (common_sources): Add files.
	(module_tests): Add test file.
	(t_ccparray_LDADD): New.

2016-05-23  Justus Winter  <justus@g10code.com>

	tests: Test the pinentry interactions when exporting keys.
	* tests/openpgp/export.test: Test pinentry interactions.

	tests: Add support for a passphrase queue to fake pinentry.
	* tests/openpgp/fake-pinentry.c (get_passphrase): New function.
	(main): Add option --passphrasefile and read passphrases from it.

	tests: Add logging to fake pinentry.
	* tests/openpgp/fake-pinentry.c (log_stream): New variable.
	(reply): New function.
	(spacep,skip_options,option_value): Copy from common.
	(main): Parse arguments, add --logfile option, write logfile.

	tests: Add export test.
	* tests/openpgp/Makefile.am (TESTS): Add new file.
	* tests/openpgp/export.test: New file.

2016-05-21  Werner Koch  <wk@gnupg.org>

	gpg: Speed up key listing in Tofu mode.
	* g10/tofu.c (get_trust): Add arg PK.  Uses this instead of a an extra
	lookup of the public key by fingerrpint.
	(tofu_register): Pass PK to get_trust.
	(tofu_get_validity): Ditto.

	*g10/tofu.c (tofu_register): Remove unused FINGERPRINT_PP.

	gpg: Avoid name spaces clash with future sqlite versions.
	* g10/sqlite.c: Rename to gpgsql.c.  Change function prefixes to
	gpgsql_.
	* g10/sqlite.h: Rename to gpgsql.h.
	* g10/tofu.c: Adjust for changes.

	gpg: Explicitly close a combined Tofu DB.
	* g10/tofu.c (tofu_closedbs): Close combined DB.

	gpg: Store the Tofu meta handle for databases in CTRL.
	* g10/gpg.h (struct tofu_dbs_s, tofu_dbs_t): New declarations.
	(struct server_control_s): Add field tofu.dbs.
	* g10/tofu.c (struct dbs): Rename to tofu_dbs_s.  Replace all users by
	by tofu_dbs_t.
	(opendbs):  Add arg CTRL.  Cache the DBS in CTRL.
	(closedbs): Rename to tofu_closedbs and make global.  Add arg CTRL.
	(tofu_register): Add arg CTRL.  Change all callers.  Do not call
	closedbs.
	(tofu_get_validity): Ditto.
	(tofu_set_policy): Ditto.
	(tofu_get_policy): Ditto.
	(tofu_set_policy_by_keyid): Add arg CTRL.
	* g10/gpg.c (gpg_deinit_default_ctrl): Call tofu_closedbs.

	gpg: Pass CTRL object down to the trust functions.

	gpg: Fix the TOFU_STATS_LONG status.
	* g10/tofu.c (show_statistics): Print TOFU STATS with formatting
	characters.

2016-05-19  Werner Koch  <wk@gnupg.org>

	gpg: Print "[  never ]" instead of err for validity.
	* g10/trust.c (uid_trust_string_fixed): Handle NEVER.

2016-05-18  Werner Koch  <wk@gnupg.org>

	dirmngr: Adjust the WKD lookup to specs version -01.
	* dirmngr/server.c (cmd_wkd_get): Remove second occurrence of the
	domain part.

2016-05-17  Werner Koch  <wk@gnupg.org>

	gpg: Emit new status line KEY_CONSIDERED.
	* common/status.h (STATUS_KEY_CONSIDERED): New.
	* g10/getkey.c: Include status.h.
	(LOOKUP_NOT_SELECTED, LOOKUP_ALL_SUBKEYS_EXPIRED): New.
	(finish_lookup): Add arg R_FLAGS.  Count expired and revoked keys and
	set flag.  Check a requested usage before checking for expiraion or
	revocation.
	(print_status_key_considered): New.
	(lookup): Print new status.

2016-05-11  NIIBE Yutaka  <gniibe@fsij.org>

	g10: Fix signature checking.
	* g10/sig-check.c (check_signature_over_key_or_uid): Fix call to
	walk_kbnode.

2016-05-10  Werner Koch  <wk@gnupg.org>

	gpg: Allow unattended deletion of secret keys.
	* agent/command.c (cmd_delete_key): Make the --force option depend on
	--disallow-loopback-passphrase.
	* g10/call-agent.c (agent_delete_key): Add arg FORCE.
	* g10/delkey.c (do_delete_key): Pass opt.answer_yes to
	agent_delete_key.

2016-05-09  Werner Koch  <wk@gnupg.org>

	gpg: Fix buglet in the check_all_keysigs function.
	* g10/keyedit.c (sig_comparison): Actually compare the pubkey
	algorithms.

	gpg: Request a "save" after cmd "check" fixed something.
	* g10/keyedit.c (keyedit_menu) <cmdCHECK>: Set modified.

2016-05-09  NIIBE Yutaka  <gniibe@fsij.org>

	po: Update Japanese translation.

2016-05-04  Werner Koch  <wk@gnupg.org>

	Release 2.1.12.

	speedo,w32: Remove the installation directory page.
	* build-aux/speedo/w32/inst.nsi (MUI_PAGE_DIRECTORY): Remove.

	gpg: Fix const char pointer mismatch with gettext.
	* g10/tofu.c (get_trust): Use const char *.

	speedo: Build sqlite with static-libgcc.
	* build-aux/speedo/patches/sqlite.patch: New.
	* Makefile.am (EXTRA_DIST): Add file.

	speedo: Also try patch files w/o version number.
	* build-aux/speedo.mk (SPKG_template): Try such a patch file.

2016-05-04  Andre Heinecke  <aheinecke@intevation.de>

	speedo,w32: Install sqlite.
	* build-aux/speedo/w32/inst.nsi (-sqlite, -un.sqlite): New.

	speedo,w32: Fix uninstallation.
	* build-aux/speedo/w32/inst.nsi (-un.gnupg): Delete distsigkey and
	dirmngr-conf.skel

	speedo,w32: Install localisation.
	* build-aux/speedo/w32/inst.nsi (-libgpg-error, GnuPG): Install l10n.
	(-un.libgpg-error, -un.gnupg): Uninstall l10n files.

2016-05-04  Werner Koch  <wk@gnupg.org>

	tests: Disable the migrations tests.
	* tests/Makefile.am (SUBDIRS): Remove migrations.
	* configure.ac (AC_CONFIG_FILES): Remove migrations Makefile.

2016-05-04  Ineiev  <ineiev@gnu.org>

	po: Update Russian translation.

2016-05-04  Werner Koch  <wk@gnupg.org>

	po: Update German translation.

	Some minor string changes and fixed a printf format.
	* g10/build-packet.c (notation_value_to_human_readable_string): Use
	%zu for size_t.

	build: Update config.{guess,sub} to 2016-04-02 and 2016-03-30.
	* build-aux/config.guess: Update.
	* build-aux/config.sub: Update.

	agent: Make --allow-loopback-pinentry the default.
	* agent/gpg-agent.c (oNoAllowLoopbackPinentry): New.
	(opts): Add --no-allow-loopback-pinentry.  Hide
	description of --allow-loopback-pinentry.
	(parse_rereadable_options): Set opt.allow_loopback_pinentry by
	default.
	(main): Replace allow-loopback-pinentry by no-allow-loopback-pinentry
	in the gpgconf list.
	* tools/gpgconf-comp.c (gc_options_gpg_agent): Ditto.

2016-05-03  Werner Koch  <wk@gnupg.org>

	common: Print https URLs in help messages.
	* common/argparse.c (strusage): Print https URLS.

	tests: Silence output of some tests.
	* common/t-exechelp.c (print_open_fds): Silence non-verbose output.
	(test_close_all_fds): Ditto.
	* common/t-session-env.c (show_stdnames): Indent output.
	* g10/test.c (TEST): Silence non-verbose okay output.
	(exit_tests): Ditto.
	* tools/gpg-zip.in (tar_verbose_opt): Add option --quiet.
	* tests/openpgp/gpgtar.test (GPGZIP): Pass option --quiet.
	* tests/openpgp/mds.test: Indent MD5 notice.
	* tests/openpgp/version.test: Indent --version output.

	gpg: Emit status lines TOFU_STATS and TOFU_STATS_LONG.
	* g10/tofu.c (NO_WARNING_THRESHOLD): Rename to BASIC_TRUST_THRESHOLD.
	(FULL_TRUST_THRESHOLD): New.
	(write_stats_status): New.
	(show_statistics): Call new function.  Print TOFU_STATS_LONG.

2016-05-02  Werner Koch  <wk@gnupg.org>

	gpg: Extend TRUST_foo status lines with the trust model.
	* g10/trustdb.h (TRUST_FLAG_TOFU_BASED): New.
	* g10/trustdb.c (trust_model_string): Lowercase the strings.  Add arg
	"model" and change callers to call with OPT.TRUST_MODEL.
	* g10/tofu.c (tofu_wot_trust_combine): Set TRUST_FLAG_TOFU_BASED.
	* g10/pkclist.c (write_trust_status): New.
	(check_signatures_trust): Call new function.

	gpg: Improve line wrapping for a tofu message.
	* g10/tofu.c (time_ago_str): Mark non-breakable spaces.
	(show_statistics): Remove marks.

	gpg: Re-format some tofu messages.
	* common/status.h (STATUS_TOFU_USER, STATUS_TOFU_STATS)
	(STATUS_TOFU_STATS_SHORT, STATUS_TOFU_STATS_LONG): New.
	* g10/tofu.c (NO_WARNING_THRESHOLD): New.
	(record_binding, tofu_register): Take care of --dry-run.
	(show_statistics): Print STATUS_TOFU_USER.  Reformat some messages.
	Fix the ngettext/strcmp thing.  Use log_string instead of log_info.
	Use NO_WARNING_THRESHOLD constant.
	(get_trust): Use format_text and print a compact fingerprint.

2016-05-02  NIIBE Yutaka  <gniibe@fsij.org>

	scd: More fix of error return path.
	* scd/command.c (open_card): Return GPG_ERR_ENODEV on the failure of
	apdu_connect.

2016-04-29  Werner Koch  <wk@gnupg.org>

	common: Extend log_string to indent lines.
	* common/logging.c (do_logv): Add indentation when called via
	log_string.

	gpg: Factor some code code out of tofu.c.
	* g10/tofu.c (string_to_long): New.
	(string_to_ulong): New.
	(get_single_unsigned_long_cb): Replace strtol/strtoul by new function.
	(get_single_long_cb): Ditto.
	(signature_stats_collect_cb):  Ditto.
	(get_policy): Ditto.
	(show_statistics): Ditto.  Uese es_free instead of free.

	gpg: Remove all assert.h and s/assert/log_assert/.

	common: Improve log_assert.
	* common/logging.c (bug_at): Do not i18n the string.
	(_log_assert): New.
	* common/logging.h (log_assert): Use new function and pass line
	information.

2016-04-28  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix error return path.
	* scd/ccid-driver.c (bulk_in): Remove EAGAIN handling.
	Handle LIBUSB_ERROR_NO_DEVICE to return CCID_DRIVER_ERR_NO_READER.

2016-04-27  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix memory leaks.
	* scd/ccid-driver.c (scan_or_find_usb_device): Return on
	LIBUSB_ERROR_NO_MEM.  Free CONFIG before return except on error.
	(scan_or_find_devices): Free device list.

2016-04-27  Werner Koch  <wk@gnupg.org>

	gpg: Add experimental AKL method "wkd" and option --with-wkd-hash.
	* g10/getkey.c (parse_auto_key_locate): Add method "wkd".
	(get_pubkey_byname): Implement that method.  Also rename a variable.
	* g10/call-dirmngr.c (gpg_dirmngr_wkd_get): New.
	* g10/keyserver.c (keyserver_import_wkd): New.
	* g10/test-stubs.c (keyserver_import_wkd): Add stub.
	* g10/gpgv.c (keyserver_import_wkd): Ditto.
	* g10/options.h (opt):  Add field 'with_wkd_hash'.
	(AKL_WKD): New.

	* g10/gpg.c (oWithWKDHash): New.
	(opts): Add option --with-wkd-hash.
	(main): Set that option.
	* g10/keylist.c (list_keyblock_print): Implement that option.

	dirmngr: Add experimental command WKD_GET.
	* dirmngr/server.c (cmd_wkd_get): New.
	(register_commands): Add command WKD_GET.

	dirmngr: Use system provided root CAs with KS_FETCH.
	* dirmngr/ks-engine-http.c (ks_http_fetch): Use HTTP_FLAG_TRUST_SYS.

2016-04-26  Werner Koch  <wk@gnupg.org>

	http: Allow to request system defined CAs for TLS.
	* dirmngr/http.h (HTTP_FLAG_TRUST_DEF, HTTP_FLAG_TRUST_SYS): New.
	* dirmngr/http.c (http_session_new): Add arg "flags".
	* dirmngr/ks-engine-hkp.c (send_request): Use new flag
	HTTP_FLAG_TRUST_DEF for the new arg of http_session_new.
	* dirmngr/ks-engine-http.c (ks_http_fetch): Ditto.
	* dirmngr/t-http.c (main): Ditto.

2016-04-25  Werner Koch  <wk@gnupg.org>

	common: Minor fixes for the new private-keys.c.
	* common/private-keys.c (my_error_from_syserror): New.  Use it in
	place of gpg_error_from_syserror.
	(_pkc_add, pkc_lookup, pke_next_value): Use ascii_strcasecmp.
	(pkc_parse): Use xtrystrdup and append_to_strlist_try as intended.

	(_pkc_add): Add braces around if-statement.

	common: Use new function to print a failure of xtrymalloc.
	* common/miscellaneous.c (xoutofcore): New.
	* common/strlist.c (append_to_strlist): Use instead of abort.
	(append_to_strlist_try): Use xtrymalloc instead of xmalloc.

2016-04-21  Justus Winter  <justus@g10code.com>

	common: Add support for the new extended private key format.
	* agent/findkey.c (write_extended_private_key): New function.
	(agent_write_private_key): Detect if an existing file is in extended
	format and update the key within if it is.
	(read_key_file): Handle the new format.
	* agent/keyformat.txt: Document the new format.
	* common/Makefile.am: Add the new files.
	* common/private-keys.c: New file.
	* common/private-keys.h: Likewise.
	* common/t-private-keys.c: Likewise.
	* common/util.h (alphap, alnump): New macros.
	* tests/migrations: Add test demonstrating that we can cope with the
	new format.

	common: Add 'free_strlist_wipe' which wipes memory.
	* common/strlist.c (free_strlist_wipe): New function.
	* common/strlist.h (free_strlist_wipe): New prototype.

	common: Add 'append_to_strlist_try' which can fail.
	* common/strlist.c (append_to_strlist): Use the new function.
	(append_to_strlist_try): New function.
	* common/strlist.h (append_to_strlist_try): New prototype.

	agent: Convert key format document to org.
	* agent/keyformat.txt: Convert to org mode.

	tests: Make migration test more robust and silent.
	* tests/migrations/from-classic.test: Fix in-tree build, silence test.

	Fixes-commit: defbc70b

2016-04-21  Werner Koch  <wk@gnupg.org>

	w32: Use --enable-gpg2-is-gpg by default.
	* autogen.rc: Add option also for plain Windows.

	w32: Replace libiconv DLL by iconv feature of libgpg-error.
	* configure.ac: Do nor require libiconv for W32.
	* common/utf8conv.c [W32]: Do not incluce iconv.h.  Request
	libgpg-error iconv macros.
	(jnlib_iconv): Use ICONV_CONST macro.
	* build-aux/speedo/w32/inst.nsi [!WITH_GUI]: Do not install libiconv.
	* build-aux/speedo.mk (speedo_spkgs) [!WITH_GUI]: Likewise.

2016-04-20  Justus Winter  <justus@g10code.com>

	agent: Sanitize permissions of the private key directory.
	* agent/gpg-agent.c (create_private_keys_directory): Set permissions.
	* common/sysutils.c (modestr_to_mode): New function.
	(gnupg_mkdir): Use new function.
	(gnupg_chmod): New function.
	* common/sysutils.h (gnupg_chmod): New prototype.
	* tests/migrations/from-classic.test: Test migration with existing
	directory.

	GnuPG-bug-id: 2312

	tests: Test the migration from a classic GnuPG home directory.
	* configure.ac: Add new directory.
	* tests/Makefile.am (SUBDIRS): Likewise.
	* tests/migrations/Makefile.am: New file.
	* tests/migrations/from-classic.gpghome/pubring.gpg.asc: Likewise.
	* tests/migrations/from-classic.gpghome/secring.gpg.asc: Likewise.
	* tests/migrations/from-classic.gpghome/trustdb.gpg.asc: Likewise.
	* tests/migrations/from-classic.test: Likewise.

2016-04-20  Werner Koch  <wk@gnupg.org>

	speedo: Use swdb.lst to define the SQLite version.
	* build-aux/speedo.mk: Change sqlite to use our mirror and the
	swdb.lst file.
	* build-aux/speedo/w32/inst.nsi: gpg is now build and installed as
	gpg.

2016-04-19  Werner Koch  <wk@gnupg.org>

	gpg: Improve UID selction of --quick-sign-key.
	* g10/keyedit.c (keyedit_quick_sign): Improve UID selection and print
	error for non-found userids.

	gpg: Avoid debug like output at start of --edit-key.
	* g10/keyedit.c (check_all_keysigs): Print info only after something
	has been modified.

2016-04-15  Andre Heinecke  <aheinecke@intevation.de>

	dirmngr: Fix https never reported in general help.
	* dirmngr/ks-engine-http.c (ks_hkp_help): Also print https
	when supported and no uri provided.

	dirmngr: Fix https incorrectly reported in help.
	* dirmngr/ks-engine-http.c (ks_hkp_help): Only print https if tls
	is supported.

2016-04-14  Werner Koch  <wk@gnupg.org>

	agent: Fix regression due to recent commit 4159567.
	* agent/protect.c (do_encryption): Fix CBC hashing.

	agent: Allow gpg-protect-tool to handle openpgp-native protection.
	* agent/protect-tool.c (read_and_unprotect): Add arg ctrl and pass to
	agent_unprotect.
	(main): Allocate a simple CTRL object and pass it to
	read_and_unprotect.
	(convert_from_openpgp_native): Remove stub.
	(agent_key_available, agent_get_cache): New stubs.
	(agent_askpin): New emulation for the one in call-pinentry.c.
	(agent_write_private_key): New to dump key.
	* agent/Makefile.am (gpg_protect_tool_SOURCES): Add cvt-openpgp.c

	tests: Set fake-pinentry's stdout and stdin to _IOLBF.
	* tests/openpgp/fake-pinentry.c (main): Call setvbuf.  Show passphrase
	at startup.  Increase buffer.

2016-04-12  Werner Koch  <wk@gnupg.org>

	agent: Implement new protection mode openpgp-s2k3-ocb-aes.
	* agent/protect.c (agent_protect): Add arg use_ocb.  Change all caller
	to pass -1 for default.
	* agent/protect-tool.c: New option --debug-use-ocb.
	(oDebugUseOCB): New.
	(opt_debug_use_ocb): New.
	(main): Set option.
	(read_and_protect): Implement option.

	* agent/protect.c (OCB_MODE_SUPPORTED): New macro.
	(PROT_DEFAULT_TO_OCB): New macro.
	(do_encryption): Add args use_ocb, hashbegin, hashlen, timestamp_exp,
	and timestamp_exp_len.  Implement OCB.
	(agent_protect): Change to support OCB.
	(do_decryption): Add new args is_ocb, aadhole_begin, and aadhole_len.
	Implement OCB.
	(merge_lists): Allow NULL for sha1hash.
	(agent_unprotect): Change to support OCB.
	(agent_private_key_type): Remove debug output.

	indent: Help Emacs not to get confused by conditional compilation.
	* agent/protect.c (calibrate_get_time) [W32]: Use separate function
	calls for W32 and W32CE.

2016-04-07  Justus Winter  <justus@g10code.com>

	g10: Fix exporting secret keys of certain sizes.
	* g10/build-packet.c (do_key): Do not use the header length specified
	by the public key packet from the keyring, but let 'write_header2'
	compute the required length.

2016-04-06  Justus Winter  <justus@g10code.com>

	Revert "g10: Support armored keyrings in gpgv."
	This reverts commit abb352de51bc964c06007fce43ed6f6caea87c15.

2016-04-05  Justus Winter  <justus@g10code.com>

	dirmngr: Autodetect PEM format in dirmngr-client.
	* dirmngr/dirmngr-client.c (init_asctobin): New function.
	(main): Move the initialization code to the new function.
	(read_pem_certificate): Initialize base64 table.
	(read_certificate): Try to decode certificates given in files as PEM
	first.

	GnuPG-bug-id: 1844

2016-04-05  Werner Koch  <wk@gnupg.org>

	build: Fix for: Build gpgcompose only in maintainer mode.
	* g10/Makefile.am (noinst_PROGRAMS): Always add module_tests.

	doc: Install gpg and gpgv man pages under the correct name.
	* doc/mkdefsinc.c (main): Add double include guard.  Set variable
	gpgtwohack. Define macros gpgname and gpgvname.
	* doc/gpg.texi: Remove macro definition for gpgname.  Use Texinfo var
	gpgtwohack to prepare the man pages.  Use @gpgname everywhere.
	* doc/gpgv.texi: Likewise.
	* doc/Makefile.am (myman_pages): Remove gpg2.1 and gpgv2.1 but add
	them depending on USE_GPG2_HACK.

	build: Build gpgcompose only in maintainer mode.
	* g10/Makefile.am (noinst_PROGRAMS): Add gpgcompose only in maintainer
	mode.

	gpg: Replace use of "gpg2" by GPG_NAME.

2016-04-04  Werner Koch  <wk@gnupg.org>

	Now build "gpg" binary but install as "gpg2"
	* configure.ac (USE_GPG2_HACK): New ac_define am_conditional.
	* common/homedir.c (gnupg_module_name): Replace use of macro
	NAME_OF_INSTALLED_GPG.
	* g10/keygen.c (generate_keypair): Ditto.
	* g10/Makefile.am (bin_PROGRAMS): Remove.
	(noinst_PROGRAMS): Add gpg or gpg2 and gpgv or gpg2.
	(gpg2_hack_list): New.
	(use_gpg2_hack): New.
	(gpg2_SOURCES): Rename to gpg_SOURCES.
	(gpgv2_SOURCES): Rename to gpgv_SOURCES.
	(gpg2_LDADD): Rename to gpg_LDADD.
	(gpgv2_LDADD): Rename to gpgv_LDADD.
	(gpg2_LDFLAGS): Rename to gpg_LDFLAGS.
	(gpgv2_LDFLAGS): Rename to gpgv2_LDFLAGS.
	(install-exec-hook): Remove WinCE specific rules and add new rules.
	(uninstall-local): Uninstall gpg/gpg2 and gpgv/gpgv2.
	* tests/openpgp/Makefile.am (required_pgms): s/gpg2/gpg/.
	* tests/openpgp/defs.inc: Ditto.
	* tests/openpgp/gpgtar.test: Ditto.
	* tests/openpgp/mkdemodirs: Ditto.
	* tests/openpgp/signdemokey: Ditto.

	* Makefile.am (DISTCHECK_CONFIGURE_FLAGS): Remove obsolete
	--enable-mailto, add --enable-gpg2-is-gpg.

	tests: Add missing file.
	* tests/openpgp/Makefile.am (TEST_FILES): Add plain-largeo.asc.

2016-04-04  Justus Winter  <justus@g10code.com>

	g10: Support armored keyrings in gpgv.
	* doc/gpgv.texi: Document the feature.
	* g10/Makefile.am (gpgv2_SOURCES): Add dearmor.c.
	* g10/dearmor.c (dearmor_file): Add sink argument.
	* g10/gpg.c (main): Adapt accordingly.
	* g10/gpgv.c (make_temp_dir): New function.
	(main): De-armor keyrings.
	* g10/main.h (dearmor_file): Adapt prototype.

	GnuPG-bug-id: 2290

	tests: Fix default key test.
	* tests/openpgp/default-key.test: Avoid using the option
	'--trust-model' unconditionally.

2016-04-01  Justus Winter  <justus@g10code.com>

	build: Check for conflicting trust model options.
	* configure.ac: Disable TOFU if configured without trust models, and
	check for conflicting options.

	g10: Remove option --always-trust if compiled without trust models.
	* g10/gpg.c (opts): Remove option --always-trust if compiled without
	trust models.

2016-03-31  Justus Winter  <justus@g10code.com>

	speedo,w32: Build libsqlite3.
	* build-aux/speedo.mk (speedo_spkgs): Add libsqlite3 on w32.
	(libsqlite3_ver): New variable.
	(speedo_pkg_libsqlite3_tar): Likewise.

	g10: Use gpg-error abstraction of sched_yield.
	* g10/tofu.c (begin_transaction): Use 'gpgrt_yield'.

2016-03-29  Werner Koch  <wk@gnupg.org>

	gpg: Fix NULL-segv for missing tofu DB.
	* g10/tofu.c (opendb): Guard call to timeout function.

2016-03-22  Werner Koch  <wk@gnupg.org>

	gpg: Improve message when asking for key capabilities.
	* g10/keygen.c (ask_key_flags): Improve message.

	gpg: Remove the extra prompt for Curve25519.
	* g10/keygen.c (MY_USE_ECDSADH): New macro local to ask_curve.
	(ask_curve): Use a fixed table of curve names and reserve a slot for
	Curve448.  Simplify CurveNNNN/EdNNNN switching.
	(ask_curve): Remove the Curve25519 is non-standard prompt.

2016-03-19  Werner Koch  <wk@gnupg.org>

	gpg: Silence trustdb computation with --quiet.
	* g10/trustdb.c (validate_keys): Do not print log_info stuff in quiet
	mode.

2016-03-17  Werner Koch  <wk@gnupg.org>

	sm: Always create a keybox header when creating a new keybox.
	* sm/keydb.c (maybe_create_keybox): Create the header blob.

2016-03-17  Neal H. Walfield  <neal@g10code.com>

	doc: Improve documentation of --enable-large-rsa.
	* doc/gpg.texi (--enable-large-rsa): Improve text.

2016-03-17  NIIBE Yutaka  <gniibe@fsij.org>

	agent: allow removal of the shadowed key.
	* agent/findkey.c (agent_delete_key): Remove the key when asked.

2016-03-16  NIIBE Yutaka  <gniibe@fsij.org>

	g10: Add const qualifier.
	* g10/gpgcompose.c (show_help): Those are strings not to be modified.

2016-03-15  Werner Koch  <wk@gnupg.org>

	gpg: Do not rely on a certain evaluation order.
	* g10/keyedit.c (print_and_check_one_sig): Call check_key_signature
	before derefing IS_SELFSIG.

2016-03-14  Werner Koch  <wk@gnupg.org>

	scd: Add manufacturer id 0x000a.
	* g10/card-util.c (get_manufacturer): Add it.

2016-03-10  Kevin J. McCarthy  <kevin@8t8.us>

	g10: Silence message if --quiet is given.
	* g10/getkey.c (parse_def_secret_key): Silence message if --quiet is
	given.

2016-03-08  Neal H. Walfield  <neal@g10code.com>

	gpg: Add a new test.
	* g10/Makefile.am (EXTRA_DIST): Add t-stutter-data.asc.
	(module_tests): Add t-stutter.
	(t_stutter_SOURCES): New variable.
	(t_stutter_LDADD): New variable.

2016-03-07  Justus Winter  <justus@g10code.com>

	sm: Implement pinentry loopback and reading passphrases from fd.
	* doc/gpgsm.texi: Document '--pinentry-mode' and '--passphrase-fd'.
	* sm/Makefile.am (gpgsm_SOURCES): Add new files
	* sm/call-agent.c (struct default_inq_parm_s): New definition.
	(start_agent): Pass in the pinentry mode.
	(default_inq_cb): Handle 'PASSPHRASE' and 'NEW_PASSPHRASE' inquiries.
	Adapt all call sites to the new callback cookie.
	* sm/gpgsm.c (cmd_and_opt_values): Add new values.
	(opts): Add new options.
	(main): Handle new options.
	* sm/gpgsm.h (struct opt): Add field 'pinentry_mode'.
	* sm/passphrase.c: New file.
	* sm/passphrase.h: Likewise.

	GnuPG-bug-id: 1970

	sm: Remove unused argument '--fixed-passphrase'.
	* doc/gpgsm.texi: Drop description.
	* sm/gpgsm.c (cmd_and_opt_values): Drop enum value.
	(opts): Drop argument.
	(main): Drop argument handling.
	* sm/gpgsm.h (struct opt): Drop field 'fixed_passphrase'.

	kbx: Avoid undefined behavior.
	* kbx/keybox-file.c (_keybox_read_blob2): Cast to unsigned int before
	shifting.

2016-03-07  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Bug fix for a device with multiple interfaces.
	* scd/ccid-driver.c (scan_or_find_usb_device): Use IFC_NO when
	accessing interface information.

2016-03-04  Justus Winter  <justus@g10code.com>

	build: Make libusb a hard requirement if the ccid driver is requested.
	* configure.ac: Print an error message and die if the internal ccid
	driver is requested but no suitable libusb is found.

	g10: Drop superfluous declaration.
	* g10/main.h (disable_core_dumps): Drop declaration.

	g10: Guard code against errors.
	* g10/keygen.c (do_generate_keypair): Check for errors, in which case
	'pri_psk' is NULL.

	Fixes-commit: bf9d1248

2016-03-03  Justus Winter  <justus@g10code.com>

	dirmngr: Add more missing CFLAGS.
	* dirmngr/Makefile.am (t_ldap_parse_uri_CFLAGS): Add
	'GCRYPT_CFLAGS'.
	(t_dns_stuff_CFLAGS): Likewise.

	GnuPG-bug-id: 2235

	tests/openpgp: Skip gpgtar test if it has not been built.
	* tests/openpgp/gpgtar.test: Check if executable exists.

	GnuPG-bug-id: 2261

2016-03-02  Neal H. Walfield  <neal@g10code.com>

	gpg: Add new program gpgcompose.
	* g10/packet.h: Include "util.h".
	* g10/encrypt.c (encrypt_seskey): Don't mark as static.
	* g10/gpgcompose.c: New file.
	* g10/Makefile.am (noinst_PROGRAMS): Add gpgcompose.
	(gpg2_SOURCES): Split everything but gpg.c into...
	(gpg_sources): ... this new variable.
	(gpgcompose_SOURCES): New variable.
	(gpgcompose_LDADD): Likewise.
	(gpgcompose_LDFLAGS): Likewise.

	gpg: More robustly detect valid non-armored OpenPGP messages.
	* g10/armor.c (is_armored): More robustly detect valid non-armored
	OpenPGP messages.

	common: Provide a function for mapping packet types to strings.
	* common/openpgpdefs.h (pkttype_str): New function.

	gpg: Rename pop_filter to iobuf_pop_filter and export it.
	* common/iobuf.c (pop_filter): Rename from this...
	(iobuf_pop_filter): ... to this.  Don't mark it as static.

	gpg: Split write_pubkey_enc_from_list.
	* g10/encrypt.c (write_pubkey_enc_from_list): Split the body of this
	function out into...
	(write_pubkey_enc): ... this new function.

	gpg: Allow the caller to write the contents of a plaintext packet.
	* g10/build-packet.c (do_plaintext): Change the semantics such that if
	PT->BUF is NULL, it is the caller's responsibility to write the
	content (and disable partial body length mode, if appropriate).

	gpg: Add a new function for creating binary notations.
	* g10/build-packet.c (blob_to_notation): New function.

	gpg: Refactor the printing of binary notations.
	* g10/build-packet.c (sig_to_notation): Break printing of binary
	notations into...
	(notation_value_to_human_readable_string): ... this new function.
	Provide a small preview of the binary data substituting non-printable
	characters with '?'.

2016-03-02  Uldis Anšmits  <uldis.ansmits@tieto.com>

	tests/openpgp: Make tests more portable.
	* tests/openpgp/default-key.test: Avoid 'grep -q'.
	* tests/openpgp/gpgtar.test: Avoid 'grep -qe' and 'diff -q'.
	* tests/openpgp/use-exact-key.test: Avoid 'grep -q'.

	GnuPG-bug-id: 2262

2016-03-02  Justus Winter  <justus@g10code.com>

	common: Consolidate Assuan server argument handling.
	* common/Makefile.am (common_sources): Add new files.
	* common/server-help.c: New file.
	* common/server-help.h: Likewise.
	* agent/command.c: Drop argument handling primitives in favor of using
	the consolidated ones.
	* dirmngr/server.c: Likewise.
	* g10/server.c: Likewise.
	* g13/server.c: Likewise.
	* scd/command.c: Likewise.
	* sm/server.c: Likewise.

2016-03-01  Justus Winter  <justus@g10code.com>

	dirmngr: Add missing CFLAGS.
	* dirmngr/Makefile.am (t_ldap_parse_uri_CFLAGS): Add
	'GPG_ERROR_CFLAGS'.
	(t_dns_stuff_CFLAGS): Likewise.

	tools: Drop superfluous include.
	* tools/gpgtar.c: Do not include unused 'npth.h'.

2016-02-26  Werner Koch  <wk@gnupg.org>

	gpg: Prettify a 2 octet hex output.
	* g10/sig-check.c (check_key_signature2): Wrap line and use %02x.

2016-02-25  Neal H. Walfield  <neal@g10code.com>

	gpg: Show debugging info if a sig with an unsupported sig class is used.
	* g10/sig-check.c (check_key_signature2): If SIG->CLASS is
	unsupported, show some debugging information.  Don't use BUG to fail.
	Just return GPG_ERR_BAD_SIGNATURE.

	gpg: More carefully encode a packet's length.
	* g10/build-packet.c (write_header2): Make sure the length bits are
	cleared.  Fail if HDRLEN is set and the specified length can't be
	encoded in the available space.

	gpg: Avoid directly twiddling bits.
	* g10/build-packet.c (do_plaintext): Use ctb_new_format_p to check the
	packet's format.
	(write_header2): Likewise.

	gpg: Add some asserts.
	* g10/build-packet.c (ctb_new_format_p): New function.
	(ctb_pkttype): New function.
	(do_user_id): Add some asserts.
	(do_key): Likewise.
	(do_symkey_enc): Likewise.
	(do_pubkey_enc): Likewise.
	(do_plaintext): Likewise.
	(do_encrypted): Likewise.
	(do_encrypted_mdc): Likewise.
	(do_compressed): Likewise.
	(do_signature): Likewise.
	(do_signature): Likewise.
	(write_header2): Likewise.

	gpg: Avoid an unnecessary copy.
	* g10/build-packet.c (sig_to_notation): Avoid an unnecessary copy of
	the data: the size of the packet is fixed.

2016-02-23  Neal H. Walfield  <neal@g10code.com>

	common: Reduce buffer size.
	* common/iobuf.c (iobuf_copy): Change buffer size from 1 MB to 32 KB.

	common: Improve a function's documentation and comments.
	* common/iobuf.c (iobuf_set_partial_body_length_mode): Fix
	documentation and comment.  Add an assert.

	common: Add log_assert.
	* common/logging.h (log_assert): New macro.

	gpg: Use higher-level functions.
	* g10/build-packet.c (do_symkey_enc): Use iobuf_write instead of
	iobuf_put in a loop.  Use iobuf_copy instead of iobuf_read and
	iobuf_write in a loop.  Move the memory wiping from here...
	* common/iobuf.c (iobuf_copy): ... to here.

	common: Check for an error before reading.
	* common/iobuf.c (iobuf_copy): If DEST has a pending error, don't
	start copying.

	common: More accurately name function.
	* common/iobuf.c (iobuf_set_partial_block_mode): Rename from this...
	(iobuf_set_partial_body_length_mode): ... to this.  Update callers.

2016-02-23  Werner Koch  <wk@gnupg.org>

	g13: Add commands --suspend and --remove.
	* g13/g13.c (aSuspend, aResume): New.
	(opts): Add commands --suspend and --resume.
	(main): Implement dummy command aUmount.  Implement commands aResume
	and aSuspend.
	* g13/sh-cmd.c (cmd_suspend): New.
	(cmd_resume): New.
	(register_commands): Add commands RESUME and SUSPEND.
	* g13/server.c (cmd_suspend): New.
	(cmd_resume): New.
	(register_commands): Add commands RESUME and SUSPEND.
	* g13/be-dmcrypt.c (be_dmcrypt_suspend_container): New.
	(be_dmcrypt_resume_container): New.
	* g13/backend.c (be_suspend_container): New.
	(be_resume_container): New.
	* g13/suspend.c, g13/suspend.h: New.
	* g13/mount.c (parse_header, read_keyblob_prefix, read_keyblob)
	(decrypt_keyblob, g13_is_container): Move to ...
	* g13/keyblob.c: new file.
	(keyblob_read): Rename to g13_keyblob_read and make global.
	(keyblob_decrypt): Rename to g13_keyblob_decrypt and make global.
	* g13/sh-dmcrypt.c (check_blockdev): Add arg expect_busy.
	(sh_dmcrypt_suspend_container): New.
	(sh_dmcrypt_resume_container): New.
	* g13/call-syshelp.c (call_syshelp_run_suspend): New.
	(call_syshelp_run_resume): New.

	g13: Run mount after dmsetup.
	* g13/g13-syshelp.c (main): Reject userids with a slash.
	* g13/sh-dmcrypt.c (sh_dmcrypt_mount_container): Run mount if a
	mountpoint is known.

2016-02-23  Justus Winter  <justus@g10code.com>

	tests/openpgp: Qualify executables with extension.
	* tests/openpgp/Makefile.am (required_pgms): Qualify executables with
	'$EXEEXT'.

	tests/openpgp: Reimplement 'pinentry.sh' in c.
	* tests/openpgp/Makefile.am: Build new program.
	* tests/openpgp/defs.inc: Use the new program.
	* tests/openpgp/fake-pinentry.c: New file.

	tests/openpgp: Avoid dependency on source files.
	* tests/openpgp/plain-largeo.asc: New file.
	* tests/openpgp/version.test: Dearmor the new file instead of relying
	on the source being present.

	tests/openpgp: Fix file removal.
	* tests/openpgp/version.test: Fix file removal.

	common/exechelp: Provide a way to wait for multiple processes.
	* common/exechelp-posix.c (gnupg_wait_process): Generalize to
	'gnupg_wait_processes'.
	* common/exechelp-w32.c (gnupg_wait_process): Likewise.
	* common/exechelp-w32ce.c (gnupg_wait_process): New function stub.
	* common/exechelp.h (gnupg_wait_process): New prototype.

	common/exechelp: Add general pipe function.
	* common/exechelp-posix.c (gnupg_create_pipe): New function.
	* common/exechelp-w32.c (INHERIT_{READ,WRITE,BOTH}): New macros.
	(create_inheritable_pipe): Generalize so that both ends can be
	inherited.
	(do_create_pipe): Rename argument accordingly.
	(gnupg_create_{in,out}bound_pipe): Use new flags.
	(gnupg_create_pipe): New function.
	(gnupg_spawn_process): Use new flags.
	* common/exechelp-w32ce.c (gnupg_create_pipe): New stub.
	* common/exechelp.h (gnupg_create_pipe): New prototype.

	common/exechelp: Mute the Windows version.
	* common/exechelp-w32.c (gnupg_wait_process): Do not print an error if
	the exit code can be returned.  This makes the Windows version behave
	like the POSIX version.

	common/exechelp: Avoid magic numbers.
	* common/exechelp-w32.c (do_create_pipe): Use symbolic names.

	common/exechelp: Disable debugging by default.
	* common/exechelp-w32.c (DEBUG_W32_SPAWN): Set to 0.

	common/exechelp: Fix handle leak.
	* common/exechelp-w32.c (gnupg_spawn_process_detached): Close process
	handle.

	common/exechelp: Fix opening the 'nul' device.
	* common/exechelp-w32.c (gnupg_spawn_process): Fix opening the 'nul'
	device.

	common/exechelp: Fix error handling.
	* common/exechelp-w32.c (gnupg_spawn_process): Close the right handle.

	common/exechelp: Fix pipe creation.
	* common/exechelp-w32.c (gnupg_spawn_process): Fix the creation of the
	input pipe.

	tools/mk-tdata: Fix data generation on Windows.
	* tools/mk-tdata.c (main): Set stdout to binary mode to avoid newline
	conversion.

2016-02-19  Neal H. Walfield  <neal@g10code.com>

	gpg: Systematically detect and fix signatures that are out of order.
	* g10/keyedit.c (sig_comparison): New function.
	(fix_key_signature_order): Merge functionality into...
	(check_all_keysigs): ... this function.  Rewrite to eliminate
	duplicates and use a systematic approach to detecting and moving
	signatures that are out of order instead of a heuristic.
	(fix_keyblock): Don't call fix_key_signature_order.  Call
	check_all_keysigs instead after collapsing the uids.

	gpg: Split check_key_signature2.
	* g10/sig-check.c (hash_uid_node): Rename from this...
	(hash_uid_packet): ... to this.  Take a PKT_user_id instead of a
	KBNODE.
	(check_key_signature2): Split the basic signature checking
	functionality into...
	(check_signature_over_key_or_uid): ... this new function.

	gpg: Split print_and_check_one_sig.
	* g10/keyedit.c (print_and_check_one_sig): Split the print
	functionality into...
	(print_one_sig): ... this new function.

	gpg: Split the function check_signature_end.
	* g10/sig-check.c (check_signature_end): Break the basic signature
	check into...
	(check_signature_end_simple): ... this new function.

	gpg: Use format_keyid rather than manually formatting the keyid.
	* g10/keyedit.c (menu_addrevoker): Use format_keyid rather than
	manually formatting the keyid.
	* g10/keygen.c (card_write_key_to_backup_file): Likewise.

	gpg: Initialize the primary key when generating a key.
	* g10/keygen.c (do_generate_keypair): Initialize
	pri_psk->flags.primary, pri_psk->keyid and pri_psk->main_keyid.

	gpg: Add accessor & utility functions for pk->keyid and pk->main_keyid.
	* g10/keydb.h (keyid_cmp): New function.
	* g10/keyid.c (pk_keyid): New function.
	(pk_main_keyid): New function.
	(keyid_copy): New function.
	(pk_keyid_str): New function.
	* g10/packet.h (PKT_public_key): Update comments for main_keyid and
	keyid.

2016-02-18  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	gpgparsemail: Allow weirdly-mixed pkcs7 signatures.
	* tools/gpgparsemail.c: Add and check info->signing_protocol_2.

	gpg: Clean up dangling agent_open and agent_closed declarations.
	* g10/keydb.h: Remove agent_open, agent_close declarations/
	* g10/migrate.c: #include <unistd.h> for access()

2016-02-16  Werner Koch  <wk@gnupg.org>

	w32: Make scdaemon build again due to libusb problem.
	* configure.ac: Add hack to disable libusb for Windows.  Also use
	$host instead of $target in the switch
	 --

	The new test for libusb does not support cross-compiling.  As a quick
	workaround we disable libusb for Windows because we can't use it anyway.

	w32: Do not error out if gpgconf is not installed.
	* common/homedir.c (check_portable_app): Remove error message.

2016-02-16  Neal H. Walfield  <neal@g10code.com>

	gpg: Make ASCII armor decoding more robust to encoding errors.
	* g10/armor.c (radix64_read): If the = is followed by the string "3D",
	check if the following four characters are valid radix 64 and are
	followed by a new line.  If so, warn and ignore the '3D'.

2016-02-16  Werner Koch  <wk@gnupg.org>

	doc: Add a gnupg-module-overview picture.
	* doc/gnupg-module-overview.svg: New.
	* doc/debugging.texi (Component interaction): New.
	* doc/Makefile.am (EXTRA_DIST): Add PNG and PDF versions of
	gnupg-module-overview.svg.  Remove two eps files.
	(BUILT_SOURCES): Add gnupg-module-overview.pdf and .png.  Remove
	gnupg-card-architecture.epsl
	(gnupg_TEXINFOS): Add gnupg-module-overview.svg
	(gnupg.dvi): New.
	(DISTCLEANFILES): Remove build eps files.

2016-02-15  NIIBE Yutaka  <gniibe@fsij.org>

	common, g10: Fix indentation to silence GCC-6.
	* common/iobuf.c (iobuf_ioctl): Fix.
	* g10/encrypt.c (encrypt_filter): Likewise.
	* g10/keyring.c (prepare_search): Likewise.

	dirmngr: fix for memory alignment.
	* dirmngr/dns-stuff.c (get_dns_cert): Cast through void *.
	(getsrv, get_dns_cname): Make sure it's aligned for HEADER.

2016-02-14  Werner Koch  <wk@gnupg.org>

	gpg: Add hidden key-edit subcommand "change-usage".
	* g10/keyedit.c (cmdCHANGEUSAGE): New.
	(cmds): Add command "change-usage".
	(keyedit_menu): Handle that command.
	(menu_changeusage): New.
	* g10/keygen.c (keygen_add_key_flags): New.
	(ask_key_flags): Add optional arg current.

2016-02-14  Neal H. Walfield  <neal@g10code.com>

	gpg: Improve API documentation.
	* g10/seskey.c (make_session_key): Improve documentation.
	(encode_session_key): Improve documentation.
	* g10/encrypt.c (encrypt_seskey): Remove gratuitous initialization.
	* g10/dek.h (DEK): Improve documenation.

	gpg: Fix calc_header_length when LEN is 0 and improve documentation.
	* g10/build-packet.c (calc_header_length): Return the correct haeder
	size when LEN is 0.  Fix documentation.

	gpg: Fix format_keyid when dynamically allocating the buffer.
	* g10/keyid.c (format_keyid): Return a char *, not a const char *.  If
	BUFFER is NULL, then set LEN to the static buffer's size.

	common: Fix comment.
	* common/iobuf.c (iobuf_flush_temp): Fix comment.

2016-02-13  Werner Koch  <wk@gnupg.org>

	g13: Require a confirmation before g13 is used for DM-Crypt.
	* g13/g13-syshelp.c (g13_syshelp_i_know_what_i_am_doing):
	* g13/sh-dmcrypt.c (sh_dmcrypt_create_container): Call it.
	(sh_dmcrypt_mount_container): Call it.

	g13: Second chunk of code to support dm-crypt.
	* g13/be-dmcrypt.c, g13/be-dmcrypt.h: New.
	* g13/Makefile.am (g13_SOURCES): Add them.
	* g13/backend.c: Include be-dmcrypt.h and call-syshelp.h.
	(no_such_backend): Rename to _no_such_backend and provide replacement
	macro.
	(be_is_supported_conttype): Support DM-Crypt.
	(be_take_lock_for_create): Call set_segvice for DM-Crypt.
	(be_create_new_keys): Make it a dummy for DM-Crypt.
	(be_create_container): Call be_dmcrypt_create_container.
	(be_mount_container): call be_dmcrypt_mount_container.
	* g13/g13-syshelp.c (main): Enable verbose mode.
	* g13/g13tuple.c (get_tupledesc_data): New.
	* g13/g13tuple.h (unref_tupledesc): New.
	* g13/g13.h (server_control_): Add field "recipients".
	* g13/g13.c (main): Fix setting of recipients via cmdline.
	(g13_deinit_default_ctrl): Release recipients list.
	(g13_request_shutdown): New.  Replace all direct update of
	shutdown_pending by calls this function.
	* g13/server.c (server_local_s): Remove field recipients which is now
	part of CTRL.
	(reset_notify, cmd_recipient, cmd_create): Adjust for this change.
	* g13/create.c (encrypt_keyblob): Rename to g13_encrypt_keyblob.
	(g13_create_container): Support DM-Crypt.
	* g13/mount.c (parse_header): Allow for meta data copies.
	(g13_mount_container): Support DM-Crypt.
	* g13/sh-cmd.c (cmd_create): Make it work.
	(cmd_mount): New.
	* g13/sh-dmcrypt.c (sh_dmcrypt_create_container): Make it work.
	(sh_dmcrypt_mount_container): New.

	g13: Improve dump_keyblob.
	* g13/g13tuple.c: Include keyblob.h.
	(find_tuple_uint): Factor code out to ...
	(convert_uint): new.
	(all_printable): New.
	* g13/mount.c (dump_keyblob: Move and rename to ...
	* g13/g13tuple.c (dump_tupledesc): here.  Revamp and pretyy print uint
	values.

	g13: Define 3 new tags.
	* g13/keyblob.h (KEYBLOB_TAG_CONT_NSEC): New.
	(KEYBLOB_TAG_ENC_NSEC): New.
	(KEYBLOB_TAG_ENC_OFF): New.

	g13: Rename utils.c to g13tuple.c.
	* g13/utils.c: Rename to g13tuple.c.
	* g13/utils.h: Rename to g13tuple.h.  Change all users.
	* g13/Makefile.am: Adjust accordingly

	g13: Add functions to handle uint in a keyblob.
	* g13/utils.c (append_tuple_uint): New.
	(find_tuple_uint): New.
	* g13/t-utils.c: New.
	* g13/Makefile.am (noinst_PROGRAMS, TESTS): New.
	(module_tests, t_common_ldadd): New.
	(t_utils_SOURCES, t_utils_LDADD): New.

	g13: Re-factor high level create code.
	* g13/create.c (g13_create_container): Factor some code out to ...
	* g13/backend.c (be_take_lock_for_create): new.

	g13: Return an error for non-existing device.
	* g13/sh-cmd.c (cmd_device): Set ERR.

	g13: Fix releasing of a syshelp context.
	* g13/call-syshelp.c (call_syshelp_release): Allow a NULL arg.

	g13: Switch over to common/exectool.c.
	* g13/sh-exectool.c: Remove.  It has been replaced by common/exectool.c.
	* g13/Makefile.am (g13_syshelp_SOURCES): Remove sh-exectool.c
	* g13/sh-blockdev.c: Include exectool.h.  Change sh_exec_tool to
	gnupg_exec-tool.
	* g13/sh-dmcrypt.c: Ditto.

	common: Make gnupg_exec_tool conform to spec.
	* common/exectool.c (gnupg_exec_tool): Allocate extra byte.  Allow
	zero length read.  Append hidden byte.  Release memory on error.

	g13: First chunk of code to support dm-crypt.
	* g13/call-syshelp.c, g13/call-syshelp.h: New.
	* g13/g13-syshelp.c, g13/g13-syshelp.h: New.
	* g13/sh-cmd.c: New.
	* g13/sh-blockdev.c: New.
	* g13/sh-exectool.c: New.
	* g13/sh-dmcrypt.c: New.
	* g13/Makefile.am (sbin_PROGRAMS): Add g13-syshelp.c
	(g13_syshelp_SOURCES): New.
	(g13_syshelp_LDADD): New.

	* g13/g13.c (opts): Add option --type.
	(g13_deinit_default_ctrl): New.
	(main): Implement that option.  Call g13_deinit_default_ctrl.
	* g13/g13.h (struct call_syshelp_s): New declaration.
	(server_control_s): Add field syshelp_local.
	* g13/keyblob.h (KEYBLOB_TAG_CREATED): New.
	(KEYBLOB_TAG_ALGOSTR): New.
	(KEYBLOB_TAG_HDRCOPY): New.
	* g13/backend.c (be_parse_conttype_name): New.
	(be_get_detached_name): Add CONTTYPE_DM_CRYPT.

	tests: Remove some harmless warnings in regression tests.
	* tests/openpgp/gpg-agent.conf.tmpl: Remove --use-standard-socket.

2016-02-12  Neal H. Walfield  <neal@g10code.com>

	common: Change simple_query to ignore status messages.
	* common/simple-pwquery.c (simple_query): Ignore status messages.

2016-02-12  NIIBE Yutaka  <gniibe@fsij.org>

	g10: Make sure to have the directory for trustdb.
	* g10/tdbio.c (tdbio_set_dbname): Return earlier if !CREATE.  Check
	the directory and create it if none before calling take_write_lock.

2016-02-02  Neal H. Walfield  <neal@g10code.com>

	doc: Note that rngd can also be used to quickly generate insecure keys.
	* doc/gpg-agent.texi (Agent Options): Add comment to the description
	of --debug-quick-random that rngd can also be used to quickly generate
	key.

2016-01-27  Werner Koch  <wk@gnupg.org>

	scd: Fix size_t/int mismatch in libusb.
	* scd/ccid-driver.c (bulk_in, abort_cmd, ccid_poll): Change msglen to
	int.

	scd: Fix detection of libusb.
	* configure.ac (HAVE_LIBUSB): Clear if no header file was found.
	(LIBUSB_LIBS): Ditto.

	dirmngr: Build fix for FreeBSD (EAI macros)
	* dirmngr/dns-stuff.c (map_eai_to_gpg_error): Map EAI_NODATA and
	EAI_ADDRFAMILY only if defined.

2016-01-27  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Migrate to new API of libusb 1.0.
	* configure.ac (LIBUSB_CPPFLAGS): New.
	* scd/Makefile.am (AM_CPPFLAGS): Add LIBUSB_CPPFLAGS.
	* scd/ccid-driver.c: Use libusb 1.0 API.

2016-01-26  Werner Koch  <wk@gnupg.org>

	Release 2.1.11.

2016-01-26  Andre Heinecke  <aheinecke@intevation.de>

	gpgtar,w32: Fix gpgtar 8 bit encoding handling on W32.
	* common/utf8conv.c (wchar_to_utf8): Factor code out to ...
	(wchar_to_cp): new.
	(utf8_to_wchar): Factor code out to ...
	(cp_to_wchar): new.
	(wchar_to_native): New.
	(native_to_wchar): New.
	* tools/gpgtar-create.c (fillup_entry_w32): Use native_to_wchar.
	(scan_directory): Use wchar_to_native.

2016-01-26  NIIBE Yutaka  <gniibe@fsij.org>

	g10: Fix segfault on unsupported curve.
	* g10/call-agent.c (learn_status_cb): Don't use NULL for strcmp.

	sm: small fix for GCC 6.
	* sm/export.c (insert_duptable): Use unsigned 0.

2016-01-25  Werner Koch  <wk@gnupg.org>
	    Daiki Ueno  <ueno@gnu.org>

	gpg: Print PROGRESS status lines during key generation.
	* g10/call-agent.c (cache_nonce_status_cb): Rewrite by using
	has_leading_keyword.  Handle PROGRESS lines.

2016-01-25  Werner Koch  <wk@gnupg.org>

	agent: Send PROGRESS status lines to the client.
	* agent/gpg-agent.c (struct progress_dispatch_s): New.
	(progress_dispatch_list): New.
	(main): Register libgcrypt pogress handler.
	(agent_libgcrypt_progress_cb): New.
	(agent_set_progress_cb): New.
	(unregister_progress_cb): New.
	(agent_deinit_default_ctrl): Call unregister.
	* agent/command.c (progress_cb): New.
	(start_command_handler): Register progress callback.

	speedo: Allow use of SHA-256 checksums.
	* build-aux/getswdb.sh: Add option --find-sha256sum.
	* build-aux/speedo.mk (libgpg_error_sha2): New var.  Also for all
	other packages.
	(SHA2SUM): New.
	(SETVARS, SETVARS_W64): Prefer sha256sum over sha1sum.
	(installer-from-source): Create swdb fragment.

2016-01-22  Werner Koch  <wk@gnupg.org>

	dirmngr: Indicate that serial numbers are hexadecimal.
	* dirmngr/misc.c (hexify_data): Add arg with_prefix.  Adjust all
	callers.
	* dirmngr/crlcache.c (cache_isvalid): Print "0x" in front of the S/N.

	dirmngr: Provide the keyserver pool name even if there is no CNAME.
	* dirmngr/ks-engine-hkp.c (map_host): Fix setting of r_poolname.

2016-01-22  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>
	    wk@gnupg.org

	dirmngr: Use sks-keyservers CA by default for the hkps pool.
	* dirmngr/Makefile.am (dist_pkgdata_DATA): Add sks-keyservers.netCA.pem.
	* dirmngr/http.c (http_session_new): Add optional arg
	intended_hostname and set a default cert.
	* dirmngr/ks-engine-hkp.c (send_request): Pass httphost to
	http_session_new.

2016-01-22  Werner Koch  <wk@gnupg.org>

	gpg: Allow new user ids with only the mail address.
	* g10/keygen.c (ask_user_id): Allow empty name.

2016-01-21  Werner Koch  <wk@gnupg.org>

	gpg: Improve header text of the auto-created revocations.
	* g10/revoke.c (gen_standard_revoke): Improve header text for the
	file.  Add info output.

	gpg: Make --auto-key-retrieve work with dirmngr configured server.
	* g10/call-dirmngr.c (gpg_dirmngr_ks_list): Make R_KEYSERVER optional.
	* g10/keyserver.c (keyserver_any_configured): New.
	(keyserver_put): Remove arg keyserver because this will always receive
	opt.keyserver which is anyway used when connecting dirmngr.  Do not
	check opt.keyserver.
	(keyserver_import_cert): Replace opt.keyserver by
	keyserver_any_configured.
	* g10/mainproc.c (check_sig_and_print): Ditto.
	* g10/import.c (revocation_present): Ditto.
	* g10/getkey.c (get_pubkey_byname): Ditto.
	* g10/gpgv.c (keyserver_any_configured): Add stub.
	* g10/test-stubs.c (keyserver_any_configured): Add stub.

2016-01-20  Werner Koch  <wk@gnupg.org>

	gpg: Silence message about ignoring revoked user ids.
	* g10/trustdb.c (tdb_get_validity_core): Print message only in debug
	mode.

	agent: New option --pinentry-timeout.
	* agent/gpg-agent.c (oPinentryTimeout): New.
	(opts): Add new option.
	(parse_rereadable_options): PArse that option.
	(main): Tell gpgconf about this option.
	* agent/call-pinentry.c (start_pinentry): Send option to Pinentry.
	* tools/gpgconf-comp.c (gc_options_gpg_agent): Add Option.

2016-01-19  Werner Koch  <wk@gnupg.org>

	gpg: Streamline use of error messages in tofu.c.
	* g10/tofu.c: Make use of print_further_info to reduce the number of
	different error messages to be translated.  Also streamline some
	messages.

	common: Add substitute code for libgpg-error < 1.22.
	* common/util.h (GPG_ERR_DB_CORRUPTED): New.

	gpg: Add function print_further_info.
	* g10/misc.c (print_further_info): New.

2016-01-18  Werner Koch  <wk@gnupg.org>

	g10: Improve strings printed by tofu.c.
	* g10/tofu.c: Include ttyio.h.  Change many strings to help
	translating.  Make use of ngettext wehere needed.
	(CONTROL_L): New.
	(TIME_AGO_UNIT_SMALL_NAME): Remove this and all similar *_NAME macros.
	(time_ago_unit): Remove.
	(get_trust): Use tty_prints and cpr_get only for the actual prompt.
	Add Ctrl-L hack.
	(show_statistics): Use two English strings for singular and plural.

	* po/POTFILES.in: Add tofu.c.

	gpg: Use "days" in "...newer than..." diagnostics.
	* g10/sig-check.c (check_signature_metadata_validity): Use days if
	useful.

	Use ngettext for some strings.
	* scd/app-openpgp.c (build_enter_admin_pin_prompt): Use ngettext for
	some diagnostics.
	(do_genkey): Ditto.
	* g10/keyedit.c (check_all_keysigs, menu_delsig, menu_clean): Ditto.
	* g10/keylist.c (print_signature_stats): Ditto.
	* g10/keyserver.c (keyserver_refresh): Ditto.
	* g10/sig-check.c (check_signature_metadata_validity): Ditto.
	* g10/sign.c (do_sign): Ditto.
	* g10/trustdb.c (reset_trust_records): Ditto.
	(validate_keys): Use a table like diagnostic output.

2016-01-15  Werner Koch  <wk@gnupg.org>

	kbx,w32: Use shorter retry intervals for keybox_file_rename.
	* kbx/keybox-util.c (keybox_file_rename): Restart retry intervals
	after 800ms.

2016-01-14  Werner Koch  <wk@gnupg.org>

	w32: Fix deadlock introduced by keybox_file_rename.
	* g10/keyring.c (keyring_lock) [W32]: Flush the close cache before
	locking.
	* kbx/keybox-init.c (keybox_lock) [W32]: Close the file before
	locking.

	gpg: Detect race between pubring.gpg and pubring.kbx use.
	* g10/keydb.c (maybe_create_keyring_or_box): Detect race condition.

	kbx: New function keybox_file_rename to replace rename.
	* kbx/keybox-util.c: Include windows.h.
	(keybox_file_rename): New.
	* kbx/keybox-update.c (rename_tmp_file): Replace remove+rename by
	keybox_file_rename.
	* g10/keyring.c (rename_tmp_file): Ditto.

	kbx: Add function keybox_tmp_names to avoid code duplication.
	* kbx/keybox-update.c (create_tmp_file): Move some code to...
	* kbx/keybox-util.c (keybox_tmp_names): new.
	* g10/keyring.c: Include keybox.h.
	(create_tmp_file): Replace parts by keybox_tmp_names.

	gpg: Make --list-options show-usage the default.
	* g10/gpg.c (main): Add LIST_SHOW_USAGE.

2016-01-13  Werner Koch  <wk@gnupg.org>

	kbx: Change return type of search functions to gpg_error_t.
	* kbx/keybox-search.c (keybox_search_reset): Change return type to
	gpg_error_t.
	(keybox_search): Ditto.  Also handle GPG_ERR_EOF.
	* sm/keydb.c (keydb_search_reset): Ditto.

	gpg: Improve error code from lock_all.
	* g10/keydb.c (lock_all): Do not clobber RC during failur cleanup.

	kbx: Improve and fix keybox_lock.
	* kbx/keybox-init.c (keybox_lock): Make sure ERR is initialized.  Get
	error codes from dotlock functions.

	common: Make sure dotlock functions set a proper ERRNO.
	* common/dotlock.c (map_w32_to_errno): New.
	(read_lockfile): Return a proper ERRNO.
	(dotlock_create_unix): Do not let log functions clobber ERRNO.
	(dotlock_take_unix): Ditto.
	(dotlock_release_unix): Ditto.
	(dotlock_create_w32): Set proper ERRNO.
	(dotlock_take_w32): Ditto.
	(dotlock_release_w32): Ditto.

	kbx: Implement keybox_lock for use by gpg.
	* kbx/keybox-defs.h: Include dotlock.h and logging.h.
	(CONST_KB_NAME): Remove.  Replace usage by KB_NAME.
	(struct keybox_name): Add field "lockhd".
	* kbx/keybox-init.c (keybox_register_file): Init LOCKHD.
	(keybox_lock): Chnage to return gpg_error_t.  Implement locking.

	gpg: Make sure to mark a duplicate registered keybox as primary.
	* kbx/keybox-init.c (keybox_register_file): Change interface to return
	the token even if the file has already been registered.
	* g10/keydb.c (primary_keyring): Rename to primary_keydb.
	(maybe_create_keyring_or_box): Change return type to gpg_error_t.
	(keydb_add_resource): Ditto. s/rc/err/.
	(keydb_add_resource): Mark an already registered as primary.
	* sm/keydb.c (maybe_create_keybox): Change return type to gpg_error_t.
	(keydb_add_resource): Ditto. s/rc/err/.
	(keydb_add_resource): Adjust for changed keybox_register_file.

2016-01-13  NIIBE Yutaka  <gniibe@fsij.org>

	Fix to support git worktree.
	* autogen.sh, Makefile.am, doc/Makefile.am: Use -e for testing .git.

2016-01-12  Werner Koch  <wk@gnupg.org>

	ssh: Accept OpenSSH *cert-v01 key variants.
	* agent/command-ssh.c (SPEC_FLAG_WITH_CERT): New.
	(ssh_key_types): Add OpenSSH cert types.
	(stream_read_string): Allow a dummy read.
	(ssh_receive_mpint_list): Pass SPEC by reference.
	(ssh_receive_mpint_list): New arg CERT and use it.
	(ssh_receive_key): Read certificate into an estream object and modify
	parser to make use of that object.

2016-01-12  NIIBE Yutaka  <gniibe@fsij.org>

	common: Fix iobuf API of filter function for alignment.
	* common/iobuf.h: Fix comment.

	common: Fix iobuf API of filter function for alignment.
	* common/iobuf.h (IOBUFCTRL_DESC): Change the call semantics.
	* common/iobuf.c (iobuf_desc): Add the second argument DESC.
	(print_chain, iobuf_close, do_open, iobuf_sockopen, iobuf_ioctl)
	(iobuf_push_filter2, pop_filter, iobuf_write_temp): Change calls
	of iobuf_desc.
	(file_filter, file_es_filter, sock_filter, block_filter): Fill the
	description.
	* common/t-iobuf.c (every_other_filter, double_filter): Likewise.
	* g10/armor.c, g10/cipher.c, g10/compress-bz2.c, g10/compress.c,
	g10/decrypt-data.c, g10/encrypt.c, g10/mdfilter.c, g10/progress.c,
	g10/textfilter.c: Likewise.

2016-01-11  Werner Koch  <wk@gnupg.org>

	gpg: Fix NULL de-ref for ambiguous key check in --export-ssh-keys.
	* g10/getkey.c: Allow arg RET_KEYBLOCK to be NULL.

2016-01-09  Werner Koch  <wk@gnupg.org>

	tools: Remove gpgkey2ssh.
	* tools/gpgkey2ssh.c: Remove.
	* tools/Makefile.am (bin_PROGRAMS): Ditto.

2016-01-08  Werner Koch  <wk@gnupg.org>

	gpg: Support ECDSA keys with --export-ssh-key.
	* g10/export.c (key_to_sshblob): Add hack for ECDSA.

	gpg: New command --export-ssh-key.
	* g10/export.c: Include membuf.h and host2net.h.
	(key_to_sshblob): New.
	(export_ssh_key): New.
	* g10/gpg.c (aExportSshKey): New.
	(opts): Add command.
	(main): Implement that command.

	gpg: Add an exact search flag to the PK struct.
	* g10/getkey.c (merge_selfsigs_subkey): Clear exact flag.
	(finish_lookup): Set exact flag.
	* g10/packet.h (PKT_public_key): Add field flags.exact.

	Print warnings if old daemon versions are used.
	* common/status.h (STATUS_WARNING): New.
	* g10/call-agent.c (warn_version_mismatch): New.
	(start_agent): Call warn function.
	* g10/call-dirmngr.c: Include status.h.
	(warn_version_mismatch): New.
	(create_context): Call warn function.
	* sm/call-agent.c (warn_version_mismatch): New.
	(start_agent): Call warn function.
	(gpgsm_agent_learn): Call warn function.
	* sm/call-dirmngr.c (warn_version_mismatch): New.
	(prepare_dirmngr): Call warn function.

	common: New function compare_version_strings.
	* common/stringhelp.c (parse_version_number): New.
	(parse_version_string): New.
	(compare_version_strings): New.
	* common/t-stringhelp.c (test_compare_version_strings): New.
	(main): Call test.  Return ERRCOUNT instead of 0.

	common: New function get_assuan_server_version.
	* common/asshelp.c: Include membuf.h.
	(get_assuan_server_version): New.
	* g10/call-agent.c (agent_get_version): Use new function.

	common: New put_membuf_cb to replace static membuf_data_cb.
	* common/membuf.c (put_membuf_cb): New.
	* agent/call-scd.c (membuf_data_cb): Remove.  Change callers to use
	put_membuf_cb.
	* common/get-passphrase.c (membuf_data_cb): Ditto.
	* g10/call-agent.c (membuf_data_cb): Ditto.
	* sm/call-agent.c (membuf_data_cb): Ditto.

2016-01-07  Werner Koch  <wk@gnupg.org>

	gpg: Return an error code from keygrip_from_pk.
	* g10/keyid.c (keygrip_from_pk): Return an error code.

	gpg: Avoid warnings about possible NULL deref.
	* g10/getkey.c (cache_public_key): Protect deref of CE which actually
	can't happen.
	* g10/keygen.c (quickgen_set_para): s/sprintf/snprintf/.
	* g10/tofu.c (end_transaction, rollback_transaction): Allow NULL for
	DB.
	* g10/trustdb.c (update_min_ownertrust): Remove useless clearling of
	ERR.

	gpg: Fix warnings about useless assignments.
	* g10/armor.c (parse_hash_header): Remove duplicate var assignment.
	* g10/getkey.c (cache_user_id): Ditto.
	* g10/keygen.c (ask_curve): Ditto.  This also fixes a small memory
	leak.

	* g10/keygen.c (proc_parameter_file): Remove useless assignment or
	pointer increment.
	(generate_keypair): Ditto.
	* g10/getkey.c (finish_lookup, lookup): Ditto.
	* g10/card-util.c (change_pin): Ditto.
	* g10/gpg.c (main) <aVerify>: Ditto.
	* g10/import.c (import): Ditto.
	(print_import_check): Ditto
	* g10/keyring.c (do_copy): Ditto.
	* g10/tdbio.c (tdbio_read_record): Ditto.
	* g10/trustdb.c (tdb_update_ownertrust): Ditto.
	(update_validity): Ditto.

	* g10/server.c (cmd_passwd): Remove useless call to skip_options.

	sm: Avoid warnings about useless assignments.
	* sm/call-dirmngr.c (prepare_dirmngr): Remove setting of ERR.
	(unhexify_fpr): Remove useless computation on N.
	* sm/certchain.c (do_validate_chain): Remove clearing of RC.  Remove
	useless setting of RC.
	* sm/fingerprint.c (gpgsm_get_keygrip): Remove setting of RC.
	* sm/gpgsm.c (build_list): Replace final stpcpy by strcpy.
	* sm/keydb.c (keydb_clear_some_cert_flags): Remove clearing of RC.
	* sm/server.c (cmd_getauditlog): Comment unused skip_options.

	kbx: Avoid warnings about useless assignments.
	* kbx/keybox-dump.c (_keybox_dump_blob): Remove setting of IN_RANGE
	and the last increment of P.

	gpg: Fix DNS cert lookup returning an URL.
	* g10/call-dirmngr.c (dns_cert_status_cb): Store URL status in the URL
	param.  The old code was entirely buggy (c+p error).

2016-01-06  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	Fix keystrlen to work when OPT.KEYID_FORMAT is KF_DEFAULT.
	* g10/keyid.c (keystrlen): If opt.keyid_format is KF_DEFAULT unset,
	default to KF_SHORT.
	(format_keyid): Default to KF_SHORT, not KF_0xLONG.

2016-01-06  Werner Koch  <wk@gnupg.org>

	gpg: Silence some regression tests.
	* g10/test.c (TEST): Print diagnostics only in verbose mode.

	gpg: Avoid using an uninitialized SALT on premature EOF.
	* g10/parse-packet.c (parse_key): Check for premature end of salt.

	gpg: Silence warnings found by static analyzer.
	* g10/keyedit.c (change_passphrase): Remove useless init of ANY.
	(keyedit_quick_adduid): Remove useless setting of ERR.
	* g10/parse-packet.c (parse_key): Remove PKTLEN from condition because
	it has been checked before the loop.
	(parse_plaintext): Remove useless init of PKTLEN.

	kbx: Avoid faulty fclose in an error case.
	* kbx/keybox-update.c (blob_filecopy): Do not close an uninitialized
	file pointer after a failure to create a temp file.
	* kbx/keybox-openpgp.c (next_packet): Remove duplicate assignment of
	PKTLEN.

	dirmngr: Silence one regression test.
	* dirmngr/t-dns-stuff.c (main): Do not print info during standard
	"make check".

	common: Avoid warnings about useless assignments.
	* common/b64enc.c (b64enc_finish): Remove var assignment which is not
	used later.
	* common/iobuf.c (file_filter): Ditto.
	* common/tlv.c (do_find_tlv): Ditto.
	* common/userids.c (classify_user_id): Ditto.

	tests: Use info and error instead of a plain echo.
	* tests/openpgp/4gb-packet.test: Use error and info.

	common: Do not deref vars in tests after a fail().
	* common/t-convert.c (test_bin2hex): Turn if conditions into if-else
	chains to avoid accessing unchecked data.
	(test_bin2hexcolon): Ditto.
	* common/t-mapstrings.c (test_map_static_macro_string): Ditto.
	* common/t-stringhelp.c (test_percent_escape): Ditto.
	(test_make_filename_try): Ditto.
	(test_make_absfilename_try): Ditto.
	* common/t-timestuff.c (test_timegm): Ditto.

2016-01-05  Werner Koch  <wk@gnupg.org>

	gpg: Align notes about minimal keysize with actual checks.
	* g10/keygen.c (ask_keysize): Use 768 for the minimal value for DSA in
	export mode.  Improve readability.

2016-01-05  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Fix RSA verification for card.
	* agent/pksign.c (agent_pksign_do): Use S-exp of public key, instead
	of shadowed key.

2016-01-04  Neal H. Walfield  <neal@g10code.com>

	gpg: Fix double free.
	* g10/getkey.c (get_pubkeys): Fix double free.

2015-12-24  NIIBE Yutaka  <gniibe@fsij.org>

	agent: IMPORT_KEY with --force option fix.
	* agent/cvt-openpgp.c (convert_from_openpgp_main): Add an option not
	to check existing key.
	(convert_from_openpgp): Ditto.
	(convert_from_openpgp_native): Call convert_from_openpgp_main with
	dontcare_exist=0.
	* agent/command.c (cmd_import_key): Call with dontcare_exist=force.

	g10: Use --force when importing key for bkuptocard.
	* g10/call-agent.c (agent_import_key): Add an argument FORCE.
	* g10/import.c (transfer_secret_keys): Likewise.
	(import_secret_one): Call transfer_secret_keys with FORCE=0.
	* g10/keyedit.c (keyedit_menu): Call with FORCE=1.

	g10: Remove subcommand checkbkupkey for --key-edit.
	* g10/keyedit.c (keyedit_menu): Remove cmdCHECKBKUPKEY support.

	g10: Allow relative path for specifying the file for bkuptocard.
	* g10/keyedit.c (keyedit_menu): Assume the file is under GNUPGHOME.
	Also support tilda expansion.

	g10: fix regression of bkuptocard subcommand in --edit-key.
	* g10/keyedit.c (keyedit_menu): Call transfer_secret_keys.
	* g10/import.c (transfer_secret_keys): Make it global function.
	Allow stats==NULL.

	agent: Support --force option for IMPORT_KEY.
	* agent/command.c (cmd_keywrap_key): New option --force.

2015-12-23  Werner Koch  <wk@gnupg.org>

	gpg: Rename struct pubkey to pukey_s and add pubkey_t.
	* g10/keydb.h (struct pubkey): Rename to pubkey_s.
	(pubkey_t): New.  Change all struct pubkey_s to use this type.
	* g10/getkey.c (get_pubkeys): Rename arg keys to r_keys.

	gpg: Simplify status message code from commit b30c15bf.
	* g10/keygen.c (card_write_key_to_backup_file): Simplify by using
	hexfingerprint.

	gpg: Add standard free() semantic to pubkey_free.
	* g10/getkey.c (pubkey_free): Check for NULL arg.

	gpg: Fix use of assert from commit dc417bf0.
	* g10/keydb.c (keydb_update_keyblock): De-ref after the assert.  Use
	%zu for size_t.

	gpg: Do not translate debug output.
	* g10/getkey.c (parse_def_secret_key): Do not make strings passed to
	log_debug translatable.

2015-12-23  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix commit b30c15bf (again).
	* g10/keygen.c (do_generate_keypair): Clear the variable S.

2015-12-22  Neal H. Walfield  <neal@g10code.com>

	gpg: Fix type.
	* g10/keygen.c (card_write_key_to_backup_file): Change n to a size_t.

	gpg: Fix error message.
	* g10/getkey.c (parse_def_secret_key): Fix error message.

	gpg: Don't check for ambiguous keys.
	* g10/gpg.c (struct result): Move from here...
	* g10/keydb.h (struct pubkey): ... to here.  Update users.
	* g10/gpg.c (check_user_ids): Move from here...
	* g10/getkey.c (get_pubkeys): ... to here.  Update users.  Use
	get_pubkey_byname to look up the keys (this also prunes invalid keys).
	(pubkey_free): New function.
	(pubkeys_free): New function.
	* g10/gpg.c (main): Don't check for ambiguous key specifications.

	gpg: Lazily evaluate --default-key.
	* g10/gpg.c (main): If --encrypt-to-default-key is specified, don't
	add --default-key's value to REMUSR here...
	* g10/pkclist.c (build_pk_list): ... do it here.
	* tests/openpgp/Makefile.am (TESTS): Add default-key.test.
	* tests/openpgp/default-key.test: New file.

	gpg: Remove unused parameter.
	* g10/pkclist.c (build_pk_list): Remove parameter use, which is always
	called set to PUBKEY_USAGE_ENC.  Update callers.

	gpg: Improve check for ambiguous keys.
	* g10/gpg.c (check_user_ids): When checking for ambiguous keys, ignore
	encryption-only keys when a signing key is needed and vice-versa.

	gpg: Fix TOCTTOU when updating keyblocks.
	* g10/keydb.c (keydb_update_keyblock): Don't replace the record at the
	current offset.  After taking the lock, extract the fingerprint from
	the keyblock, find it and then replace it.

	Only add the user supplied CFLAGS after running any autoconf tests.
	* configure.ac: Only add the user supplied CFLAGS after running any
	autoconf tests.

	gpg: Suppress a warning.
	* dirmngr/dns-stuff.c (enable_dns_tormode): Reference new_circuit to
	avoid a warning when ADNS is not available.

	gpg: Remove dead code.
	* kbx/keybox-defs.h (struct keybox_found_s): Remove unused fields
	offset and n_packets.

	gpg: Display the key that is invalid, not the search description.
	* g10/getkey.c (parse_def_secret_key): Display the key that is
	invalid, not the search description.

	gpg: Mark more options as coming from the config file (when this holds)
	* g10/gpg.c (main): When --default-key or --encrypt-to-default-key is
	taken from the config file, note this.

	gpg: Use enums instead of defines.
	* g10/keydb.h (PK_LIST_ENCRYPT_TO): Change from a macro to an enum.
	(PK_LIST_HIDDEN): Likewise.
	(PK_LIST_CONFIG): Likewise.
	(PK_LIST_SHIFT): Likewise.n

2015-12-21  NIIBE Yutaka  <gniibe@fsij.org>

	po: Update Japanese translation.

	g10: clean up of headers for card.
	* g10/main.h (save_unprotected_key_to_card): Remove.
	* g10/options.h (ctapi_driver, pcsc_driver, disable_ccid): Remove.

2015-12-21  Werner Koch  <wk@gnupg.org>

	common: New file fwddecl.h.
	* common/util.h (server_control_s, ctrl_t): Move to ...
	* common/fwddecl.h: New file.
	* common/call-gpg.h: Replace typedef by fwddecl.h.  Change include
	protection macro name.
	* common/Makefile.am (common_sources): Add fwddecl.h.

2015-12-18  Werner Koch  <wk@gnupg.org>

	build: Add required macro for pkg-config.
	* configure.ac (PKG_PROG_PKG_CONFIG): New.

2015-12-18  NIIBE Yutaka  <gniibe@fsij.org>

	g10: Remove deprecated internal functions.
	* g10/keygen.c (do_ask_passphrase, generate_raw_key)
	(gen_card_key_with_backup, save_unprotected_key_to_card): Remove.

	g10: Fix a regression for generating card key with backup.
	* g10/main.h (receive_seckey_from_agent): Declare.
	* g10/keygen.c (card_write_key_to_backup_file): New.
	(card_store_key_with_backup): New.
	(do_generate_keypair): Create a key on host for encryption key when
	backup is requested.  Then, call card_store_key_with_backup.

2015-12-17  NIIBE Yutaka  <gniibe@fsij.org>

	g10: factor out a function for secret key retrieval.
	* g10/export.c (receive_seckey_from_agent): New.
	(do_export_stream): Use it.

2015-12-16  Neal H. Walfield  <neal@g10code.com>

	gpg: When checking for ambiguous keys, ignore invalid keys.
	* g10/gpg.c (check_user_ids): When checking for ambiguous keys, ignore
	disabled, revoked and expired keys (if appropriate for the provided
	option).

2015-12-15  Werner Koch  <wk@gnupg.org>

	common: Use default_errsource for call-gpg and exectool.
	* common/call-gpg.c (my_error_from_syserror, my_error_from_errno): New.
	Use these wrappers.
	* common/exectool.c (my_error_from_syserror): New.  Use these
	wrappers.

	gpg: Reduce number of strings to translate.
	* g10/getkey.c (parse_def_secret_key): Do not make debug messages
	translatable.  Make use of print_reported_error.

	gpg: New function to printed a detailed error code.
	* g10/misc.c (print_reported_error): New.

2015-12-15  Neal H. Walfield  <neal@g10code.com>

	gpg: Improve the keyblock cache's transparency.
	* kbx/keybox-search.c (keybox_seek): New function.
	* g10/keydb.c (keydb_search): When reading from the cache, seek to
	just after the cached record.

	gpg: Improve the keyblock cache's transparency.
	* kbx/keybox-search.c (keybox_offset): New function.
	* g10/keydb.c (struct keyblock_cache): Add fields resource and offset.
	(keyblock_cache_clear): Reset HD->KEYBLOCK_CACHE.RESOURCE and
	HD->KEYBLOCK_CACHE.OFFSET.
	(keydb_search): Don't use the cached result if it comes before the
	current file position.  When caching an entry, also record the
	position at which it was found.

	gpg: Use more descriptive names.
	* g10/keyring.c (KR_NAME): Rename this...
	(KR_RESOURCE): ... to this.  Update users.
	(struct keyring_name): Rename this...
	(struct keyring_resource): ... to this.  Update users.
	(struct off_item): Rename this...
	(struct key_present): ... to this.  Update users.
	(OffsetHashTable): Rename this...
	(key_present_hash_t): ... to this.  Update users.
	(kr_offtbl): Rename this...
	(key_present_hash): ... to this.  Update users.
	(kr_offtbl_ready): Rename this...
	(key_present_hash_ready): ... to this.  Update users.
	(KEY_PRESENT_HASH_BUCKETS): New define.  Replace use of literals
	with this.
	(new_offset_item): Rename this...
	(key_present_value_new): ... to this.  Update users.
	(release_offset_items): Drop dead code.
	(new_offset_hash_table): Rename this...
	(key_present_hash_new): ... to this.  Update users.
	(release_offset_hash_table): Drop dead code.
	(lookup_offset_hash_table): Rename this...
	(key_present_hash_lookup): ... to this.  Update users.
	(update_offset_hash_table): Rename this...
	(key_present_hash_update): ... to this.  Drop unused parameter off.
	Update users.
	(update_offset_hash_table_from_kb): Rename this...
	(key_present_hash_update_from_kb): ... to this.  Drop unused parameter
	off.  Update users.

2015-12-15  NIIBE Yutaka  <gniibe@fsij.org>

	sm: Handle gcry_pk_encrypt return value.
	* sm/encrypt.c (encrypt_dek): Don't ignore failure of gcry_pk_encrypt.

2015-12-14  Werner Koch  <wk@gnupg.org>

	common: Change license of isascii.c to all-premissive,
	* common/isascii.c: Change.

	common: Change license of some modules to LGPLv3+/GPLv2+.
	* common/status.c: Change from GPLv3 to LGPLv3+/GPLv2+.
	* common/status.h: Ditto.
	* common/yesno.c: Ditto.
	* common/common-defs.h: Ditto.
	* common/gettime.h: Ditto.
	* common/keyserver.h: Ditto.

	common: Change license for exectool to LGPLv3+/GPLv2+.
	* common/exectool.c, common/exectool.h: Change license.

	common: Rename sh-exectool to exectool.
	* common/sh-exectool.c: Rename to exectool.c.
	* common/sh-exectool.h: Rename to exectool.h.
	* common/Makefile.am (common_sources): Adjust for rename.
	* common/exectool.c (sh_exec_tool_stream): Rename to
	gnupg_exec-tool-stream.
	(sh_exec_tool): Rename to gnupg_exec_tool.
	* tools/gpgtar-create.c (gpgtar_create): Adjust for changes.
	* tools/gpgtar-extract.c: Adjust for changes.
	* tools/gpgtar-list.c: Adjust for changes.

2015-12-14  Damien Goutte-Gattat  <dgouttegattat@incenp.org>

	gpg: Print ownertrust in TOFU+PGP trust model.
	* g10/keyedit.c: Print ownertrust in TOFU+PGP trust model.

2015-12-14  Neal H. Walfield  <neal@g10code.com>

	gpg: Fix --default-key checks.
	* g10/getkey.c (parse_def_secret_key): Don't just check if a secret
	key is available for the public key, also consider subkeys.  Also
	check that the key has the signing capability, is not revoked, is not
	expired and is not disabled.  Print a warning if there was a least one
	value passed to --default-key and all were ignored.

2015-12-14  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix regression for generating RSA keys on card.
	* scd/app-openpgp.c (do_genkey): Strip leading zeros for fingerprint
	computation.

2015-12-12  Werner Koch  <wk@gnupg.org>

	gpg: Use a regular type instead of a void* for import stats.
	* g10/import.c (struct stats_s): Rename to import_stats_s.  Change all
	users.
	* g10/main.h (import_stats_t): New.  Change fucntions to use this
	instead of a void pointer.

	Remove replacements for libgpg-error < 1.21.
	* common/util.h: Remove replacement macros for libgpg-error<1.21.
	* common/types.h: Ditto.
	* common/mischelp.h: Ditto.
	* common/t-mapstrings.c: Include t-support.h before stringhelp.h
	* common/t-stringhelp.c: Ditto.
	* common/t-support.h: Always include gpg-error.h.
	* kbx/keybox-search.c: Do not include stringhelp.h so that keybox-defs
	comes first.

2015-12-11  Neal H. Walfield  <neal@g10code.com>

	gpg: Fix buffer overflow.
	* g10/keydb.c (keydb_search_desc_dump): Fix buffer overflow.

2015-12-11  Justus Winter  <justus@g10code.com>

	agent: Improve error handling.
	* agent/pksign.c (agent_pksign_do): Improve error handling.

	Fix required libgpg-error version.
	* configure.ac (NEED_GPG_ERROR_VERSION): We need version 1.21 for the
	poll interface.

2015-12-11  Neal H. Walfield  <neal@g10code.com>

	gpg: Don't error out if a key occurs multiple times in the keyring.
	* g10/gpg.c (check_user_ids): Don't error out if a key occurs multiple
	times in the keyring.  Instead, print a warning.  When printing out
	fingerprint prints, use format_hexfingerprint to format them.

2015-12-10  Daniel Hoffend  <dh@dotlan.net>

	scd: Fix removal of unplugged usb readers on Windows.
	* scd/apdu.c (pcsc_error_to_sw): map PCSC_E_NO_SERVICE and
	PCSC_E_SERVICE_STOPPED to the internal SW_HOST_NO_READER error code.

2015-12-07  Justus Winter  <justus@g10code.com>

	tests: Add some more gpgtar tests.
	* tests/openpgp/gpgtar.test: Add more tests.

	dirmngr: Initialize http status code.
	* dirmngr/ks-action.c (ks_action_search): Initialize 'http_status' as
	it is unused if LDAP is used to search for keys.

2015-12-04  Daiki Ueno  <ueno@gnu.org>

	gpg: Write ERROR status on delete-key cancellation.
	* g10/delkey.c (do_delete_key): Write ERROR status code with the error
	location "delete_key.secret", when the user cancelled the operation on
	Pinentry.

2015-12-04  Justus Winter  <justus@g10code.com>

	dirmngr: Stricter handling of http error codes.
	* dirmngr/ks-action.c (ks_action_search): Only retry if the keyserver
	responded with a '404 Not Found'.
	* dirmngr/ks-engine-hkp.c (send_request): Return http status code.
	(ks_hkp_search): Likewise.
	(ks_hkp_{get,put}): Adapt call to 'send_request'.
	* dirmngr/ks-engine.h (ks_hkp_search): Update prototype.

	dirmngr: Really search all keyservers for patterns.
	* dirmngr/ks-action.c (ks_action_search): Search all configured
	keyservers for the given patterns.

	GnuPG-bug-id: 1038

	dirmngr: Handle http status '501 Not Implemented'.
	* dirmngr/ks-engine-hkp.c (send_request): Handle status 501 and return
	GPG_ERR_NOT_IMPLEMENTED.

	GnuPG-bug-id: 1221

	tools/gpgtar: Implement symmetric encryption.
	* tests/openpgp/gpgtar.test: Add test case.
	* tools/gpgtar-create.c (gpgtar_create): Pass '--symmetric' flag to
	gpg.
	* tools/gpgtar.c (parse_arguments): We do handle the argument now.

	tools/gpgtar: Implement signing.
	* tests/openpgp/gpgtar.test: Test signing.
	* tools/gpgtar-create.c (gpgtar_create): Add 'sign' option, add the
	appropriate gpg arguments to implement signing and selecting the local
	user.
	* tools/gpgtar.c (parse_options): We do handle '--local-user' now.
	(main): Handle signing, encrypting, and doing both when creating an
	archive.
	* tools/gpgtar.h (gpgtar_create): Update prototype.

	tools/gpgtar: Use the new exectool helper.
	* tools/Makefile.am: gpgtar now requires neither npth nor libassuan.
	* tools/gpgtar-create.c (gpgtar_create): Use the new 'sh-exectool'
	helper.
	* tools/gpgtar-extract.c (gpgtar_extract): Likewise.
	* tools/gpgtar-list.c (gpgtar_list): Likewise.
	* tools/gpgtar.c (main): Set default gpg program.  Drop the
	initialization of npth and libassuan.

	common: Add a stream interface to 'sh-exectool'.
	* common/sh-exectool.c (struct copy_buffer): Add infrastructure for
	copying between streams.
	(copy_buffer_{init,shred,do_copy,flush}): New functions.
	(sh_exec_tool_stream): Rework 'sh_exec_tool' to operate on streams.
	(nop_free): New function.
	(sh_exec_tool): Express this in terms of 'sh_exec_tool_stream'.
	* common/sh-exectool.h (sh_exec_tool_stream): New prototype.

	common: Add header file and build the new code.
	* common/Makefile.am (common_sources): Add new files.
	* common/sh-exectool.h: New file.

2015-12-04  Werner Koch  <wk@gnupg.org>

	common: Add code to execute a helper.
	* common/sh-exectool.c: New file.

	Release 2.1.10.

2015-12-04  NIIBE Yutaka  <gniibe@fsij.org>

	po: Japanese translation.

2015-12-04  Werner Koch  <wk@gnupg.org>

	speedo,w32: Improve installer.
	* build-aux/speedo/w32/inst.nsi (SEC_gnupg): Install dirmngr.conf and
	distsigkey.gpg.
	(un.gnupglast): Stop dirmngr.

	gpg: Do not pre-check keys given on the command line.
	* g10/keydb.h (PK_LIST_ENCRYPT_TO, PK_LIST_HIDDEN, PK_LIST_CONFIG)
	(PK_LIST_SHIFT): New.
	* g10/pkclist.c (build_pk_list): Use them here.
	* g10/gpg.c (check_user_ids, main): Ditto.

	* g10/gpg.c (main): Set PK_LIST_CONFIG for REMUSR and LOCUSR.
	(check_user_ids): Skip check for command line specified options.

	dirmngr: Add command to print the resolver version.
	* dirmngr/server.c (cmd_getinfo): Add sub-command "dnsinfo".

	gpg: Allow "help" as value for --tofu-policy.
	* g10/gpg.c (parse_tofu_policy): Add keyword "help".
	(parse_tofu_db_format): Ditto.

	Do not translate messages printed with log_debug.
	* common/asshelp.c (start_new_gpg_agent): Do not i18n string.
	(start_new_dirmngr): Ditto.
	* g10/mainproc.c (proc_encrypted): Ditto.  Print only if debug is
	enabled.

2015-12-04  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix for removing the prefix.
	* scd/app-openopg.c (do_decipher): Fix the condition.

	scd: Simplify saving application context.
	* scd/app.c (lock_table): Remove LAST_APP field.
	(lock_reader, app_dump_state, application_notify_card_reset)
	(release_application): Follow the change.
	(check_conflict): New.
	(check_application_conflict): Lock the slot and call check_conflict.
	(select_application): Call check_conflict and not use LAST_APP.

	scd: More fix for Curve25519 prefix handling.
	* scd/app-openpgp.c (do_decipher): Handle trancated cipher text.
	Also fix xfree bug introduced.

2015-12-03  Werner Koch  <wk@gnupg.org>

	scd: Another fix for Curve25519 prefix handling.
	* scd/app-openpgp.c (do_decipher): Check 0x02 also for 16+1 byte long
	INDATA.
	(do_decipher): Fix integer arithmetic in void pointer.
	(do_decipher): Add missing memcpy.

	build: Avoid dependecy problems in "make distcheck".
	* doc/Makefile.am (gnupg.texi): Depend on defs.inc.

	build: Change how caller provided CFLAGS are used by configure.
	* configure.ac: Append instead of prepend caller provided CFLAGS.

	gpg: Add variant of 'key "%s" not found: %s' error message.
	* g10/gpg.c (check_user_ids): Change error message.
	* g10/delkey.c (do_delete_key): Ditto.

	gpg: Make keyidlist more robust in case of errors.
	* g10/keyserver.c (keyidlist): Clear *KLIST on error.

	gpg: Take care of keydb_new returning NULL.
	* g10/keydb.c (keydb_new): Print an error message if needed.  Also use
	xtrycalloc because we return an error anyway.
	* g10/delkey.c (do_delete_key): Handle error retruned by keydb_new.
	* g10/export.c (do_export_stream): Ditto.
	* g10/getkey.c (get_pubkey): Ditto.
	(get_pubkey_fast): Ditto.
	(get_pubkeyblock): Ditto.
	(get_seckey): Ditto.
	(key_byname): Ditto.
	(get_pubkey_byfprint): Ditto.
	(get_pubkey_byfprint_fast): Ditto.
	(parse_def_secret_key): Ditto.
	(have_secret_key_with_kid): Ditto.
	* g10/import.c (import_one): Ditto.
	(import_revoke_cert): Ditto.
	* g10/keyedit.c (keyedit_quick_adduid): Ditto.
	* g10/keygen.c (quick_generate_keypair): Ditto.
	(do_generate_keypair): Ditto.
	* g10/trustdb.c (validate_keys): Ditto.
	* g10/keyserver.c (keyidlist): Ditto.
	* g10/revoke.c (gen_desig_revoke): Ditto.
	(gen_revoke): Ditto.
	* g10/gpg.c (check_user_ids): Ditto.
	(main): Do not print an error message for keydb_new error.
	* g10/keylist.c (list_all): Use actual error code returned by
	keydb_new.

	* g10/t-keydb-get-keyblock.c (do_test): Abort on keydb_new error.
	* g10/t-keydb.c (do_test): Ditto.

	* g10/keyring.c (keyring_new): Actually return an error so that the
	existing keydb_new error checking makes sense for a keyring resource.
	(keyring_rebuild_cache): Take care of keyring_new returning an error.

	gpg: Change some error messages.
	* g10/getkey.c (parse_def_secret_key): Change error message.  Replace
	log_debug by log_info.
	* g10/gpg.c (check_user_ids): Make function static.  Change error
	messages.
	(main): Change error messages.
	* g10/revoke.c (gen_revoke): Ditto.

2015-12-03  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix "Conflicting usage" bug.
	* scd/apdu.c (apdu_close_reader): Call CLOSE_READER method even if we
	  got an error from apdu_disconnect.
	* scd/app-common.h (no_reuse): Remove.
	* scd/app.c (application_notify_card_reset): Deallocate APP here.
	(select_application, release_application): Don't use NO_REUSE.

	scd: Fix for Curve25519 prefix handling.
	* scd/app-openpgp.c (do_decipher): More condition for AES decipher.
	  Handle the prefix in cipher text.  Always add the prefix in result.

2015-12-03  Neal H. Walfield  <neal@g10code.com>

	gpg: Use the matching key if the search description is exact.
	* g10/gpg.c (check_user_ids): If the search description is for an
	exact match (a keyid or fingerprint that ends in '!'), then use the
	matching key, not the primary key.
	* tests/openpgp/Makefile.am (TESTS): Add use-exact-key.test.
	(priv_keys): Add privkeys/00FE67F28A52A8AA08FFAED20AF832DA916D1985.asc,
	privkeys/1DF48228FEFF3EC2481B106E0ACA8C465C662CC5.asc,
	privkeys/A2832820DC9F40751BDCD375BB0945BA33EC6B4C.asc,
	privkeys/ADE710D74409777B7729A7653373D820F67892E0.asc and
	privkeys/CEFC51AF91F68A2904FBFF62C4F075A4785B803F.asc.
	(sample_keys): Add
	samplekeys/E657FB607BB4F21C90BB6651BC067AF28BC90111.asc.
	* tests/openpgp/privkeys/00FE67F28A52A8AA08FFAED20AF832DA916D1985.asc:
	New file.
	* tests/openpgp/privkeys/1DF48228FEFF3EC2481B106E0ACA8C465C662CC5.asc:
	New file.
	* tests/openpgp/privkeys/A2832820DC9F40751BDCD375BB0945BA33EC6B4C.asc:
	New file.
	* tests/openpgp/privkeys/ADE710D74409777B7729A7653373D820F67892E0.asc:
	New file.
	* tests/openpgp/privkeys/CEFC51AF91F68A2904FBFF62C4F075A4785B803F.asc:
	New file.
	* tests/openpgp/samplekeys/E657FB607BB4F21C90BB6651BC067AF28BC90111.asc:
	New file.
	* tests/openpgp/use-exact-key.test: New file.
	* tests/openpgp/version.test: Install the new private keys.

2015-12-02  Werner Koch  <wk@gnupg.org>

	build: Require at least Libassuan 2.4.1.
	* configure.ac (NEED_LIBASSUAN_VERSION): Set to 2.4.1.
	* agent/gpg-agent.c (create_server_socket): Remove check for
	libassuan >= 2.3.0 and >= 2.1.4.
	(main): Remove check for libassuan >= 2.1.4.
	* scd/scdaemon.c (create_server_socket): Remove check for
	libassuan >= 2.1.4.
	* dirmngr/dirmngr.c (set_tor_mode): Remove check for
	libassuan >= 2.3.0.
	* dirmngr/http.c (http_raw_connect, send_request): Remove checks for
	libassuan >= 2.3.0.

2015-12-02  Neal H. Walfield  <neal@g10code.com>

	gpg: Improve documentation.
	* g10/tofu.c (initdb): Improve documentation.

	gpg: Fix type mismatch resulting in a buffer overflow.
	* g10/tofu.c (record_binding): Change policy_old's type from an enum
	tofu_policy to a long: this variable is passed by reference and a long
	is expected.

2015-12-02  Werner Koch  <wk@gnupg.org>

	dirmngr: Switch to an onion address if Tor is running.
	* dirmngr/dirmngr.h (opt): Turn field 'keyserver' into an strlist.
	* dirmngr/dirmngr.c (parse_rereadable_options): Allow multiple
	--keyserver options.
	* dirmngr/server.c (server_local_s): Add field 'tor_state'.
	(release_uri_item_list): New.
	(release_ctrl_keyservers): Use it.
	(start_command_handler): Release list of keyservers.
	(is_tor_running): New.
	(cmd_getinfo): Re-implement "tor" subcommand using new fucntion.
	(ensure_keyserver): Rewrite.
	* g10/dirmngr-conf.skel: Add two keyserver options.

	http: Enhance parser to detect .onion addresses.
	* dirmngr/http.h (parsed_uri_s): Add flag 'onion'.
	* dirmngr/http.c (do_parse_uri): Set that flag.
	* dirmngr/t-http.c (main): Print flags.

2015-12-02  Neal H. Walfield  <neal@g10code.com>

	common,gpg: Fix processing of search descriptions ending in '!'.
	* g10/gpg.c (check_user_ids): If the search description describes a
	keyid or fingerprint and ends in a '!', include the '!' in the
	rewritten description.
	* common/userids.c (classify_user_id): Accept keyids and fingerprints
	ending in '!'.

2015-12-01  Justus Winter  <justus@g10code.com>

	dirmngr: Improve error handling.
	* dirmngr/dns-stuff.c (getsrv): Avoid looking at 'header' before
	checking for errors, but silently ignore errors when looking up SRV
	records.

2015-12-01  Werner Koch  <wk@gnupg.org>

	build: Let configure show the the status of Tor support.
	* configure.ac (show_tor_support): New

2015-11-30  Werner Koch  <wk@gnupg.org>

	doc: Make make distcheck work again.
	* doc/Makefile.am (DISTCLEANFILES): Add gpgkey2ssh.1

	yat2m: Add keyword @url.
	* doc/yat2m.c (proc_texi_cmd): Add keyword @url.

	doc: Build man pages with the same date as the info files.
	* doc/Makefile.am (yat2m-stamp): Use option --date.

	yat2m: New option --date.
	* doc/yat2m.c (opt_date): new.
	(isodatestring): Use it if set.
	(main): New option --date.

2015-11-27  Werner Koch  <wk@gnupg.org>

	gpg: Avoid extra translation strings.
	* g10/keyedit.c (menu_expire): Use only one prompt.

	kbx: Include gpg-error prior to mischelp.h.
	* kbx/keybox-init.c: Change order of includes.

	gpg,w32: Fix a format string error.
	* g10/keyring.c (keyring_search): Fix format string for off_t.

	Silence compiler warnings related to not using assuan_fd_t.
	* common/call-gpg.c (start_gpg): Use assuan_fd_t.  Note that the
	declaration was already fixed by a previous change.
	* dirmngr/server.c (cmd_getinfo): Use assuan_fd_t.

	Avoid incompatible pointer assignment warnings on Windows.
	* common/logging.c (fun_writer): Use gpgrt_ssize_t instead of ssize_t.
	* dirmngr/server.c (data_line_cookie_write): Ditto.
	* sm/certdump.c (format_name_writer): Ditto.
	* sm/server.c (data_line_cookie_write): Ditto.
	* dirmngr/http.c (cookie_read, cookie_write): Ditto.

	dirmngr: Avoid a declarations after statements.
	* tools/gpgtar.c (parse_arguments): Use a block for a local varibale
	definition.

	dirmngr: Avoid casting away a const from an char**.
	* dirmngr/ldap.c (start_cert_fetch_ldap): Do not use pointers from
	global variables.

	dirmngr: Allow testing for a running Tor via "getinfo tor".
	* dirmngr/server.c (cmd_getinfo): Print an S line if Tor is not
	running.

2015-11-26  Werner Koch  <wk@gnupg.org>

	g13: Fix commit 1a045b13.
	* g13/g13.c (main): Use existsing function.

	common: Fix off-by-one access in the new format_text.
	* common/stringhelp.c (format_text): Use existsing fucntion to trim
	trailing spaces.  Fix off-by-one access.

	dirmngr: Improve output of "getinfo tor".
	* dirmngr/server.c (cmd_getinfo): Print a message along with OK.

	dirmngr: Let Libassuan employ nPth wrappers for connect.
	* dirmngr/http.c (my_unprotect, my_protect): Remove.
	(connect_server): Do not use these wrappers.

2015-11-26  Justus Winter  <justus@g10code.com>

	tools/gpgtar: Add '--dry-run'.
	* tools/gpgtar-extract.c (extract_{regular,directory}): Honor
	'--dry-run'.
	* tools/gpgtar.c (enum cmd_and_opt_values): New value.
	(opts): Add '--dry-run'.
	(parse_arguments): Handle '--dry-run'.
	* tools/gpgtar.h (opt): Add field 'dry_run'.

	tools/gpgtar: Handle '--gpg-args'.
	* tools/gpgtar-create.c (gpgtar_create): Use given arguments.
	* tools/gpgtar-extract.c (gpgtar_extract): Likewise.
	* tools/gpgtar-list.c (gpgtar_list): Likewise.
	* tools/gpgtar.c (enum cmd_and_opt_values): New value.
	(opts): Add 'gpg-args'.
	(parse_arguments): Handle arguments.
	* tools/gpgtar.h (opt): Add field 'gpg_arguments'.
	* tests/openpgp/gpgtar.test: Simplify accordingly.

	common: Make the GPG arguments configurable in call-gpg.
	* common/call-gpg.c (start_gpg): Add parameter 'gpg_arguments'.
	(_gpg_encrypt, gpg_encrypt_blob, gpg_encrypt_stream): Likewise.
	(_gpg_decrypt, gpg_decrypt_blob, gpg_decrypt_stream): Likewise.
	* common/call-gpg.h: Adapt prototypes.
	* g13/create.c (encrypt_keyblob): Adapt callsite.
	* g13/g13-common.h (opt): Add field 'gpg_arguments'.
	* g13/g13.c (main): Construct default arguments.
	* g13/mount.c (decrypt_keyblob): Adapt callsite.
	* tools/gpgtar-create.c (gpgtar_create): Likewise.
	* tools/gpgtar-extract.c (gpgtar_extract): Likewise.
	* tools/gpgtar-list.c (gpgtar_list): Likewise.

	tools/gpgtar: Handle '--tar-args' for compatibility with gpg-zip.
	* tools/gpgtar.c (enum cmd_and_opt_values): New value.
	(opts): Add new group for tar options, rearrange a little, add
	'--tar-args'.
	(tar_opts): New variable.
	(shell_parse_stringlist): New function.
	(shell_parse_argv): Likewise.
	(parse_arguments): Add option argument, handle '--tar-args'.
	(main): Fix invokation of 'parse_arguments'.
	* tests/openpgp/gpgtar.test: Simplify decryption.

	tools/gpgtar: Rework argument parsing.
	* tools/gpgtar.c (main): Move argument parsing into its own function.

2015-11-25  Justus Winter  <justus@g10code.com>

	tests: Add tests for gpgtar and gpg-zip.
	* tests/openpgp/Makefile.am (TESTS): Add new file.
	* tests/openpgp/gpgtar.test: New file.

	tools/gpgtar: Handle '--directory' argument.
	* tools/gpgtar-extract.c (gpgtar_extract): Only generate a directory
	name if none is given via arguments.
	* tools/gpgtar.c (enum cmd_and_opt_values): New constant.
	(opts): Add argument.
	(main): Parse argument.
	* tools/gpgtar.h (opt): New field 'directory'.

	tools/gpgtar: Handle '--gpg' argument.
	* tools/gpgtar-create.c (gpgtar_create): Use given gpg program.
	* tools/gpgtar-extract.c (gpgtar_extract): Likewise.
	* tools/gpgtar-list.c (gpgtar_list): Likewise.
	* tools/gpgtar.c (enum cmd_and_opt_values): New constant.
	(opts): Add argument.
	(main): Handle argument.
	* tools/gpgtar.h (opt): Add field 'gpg_program'.

	tools/gpgtar: Improve error handling.
	* tools/gpgtar-create.c (gpgtar_create): Return an error code, fix
	error handling.
	* tools/gpgtar-extract.c (gpgtar_extract): Likewise.
	* tools/gpgtar-list.c (read_header): Return an error code.
	(gpgtar_list): Return an error code, fix error handling.
	(gpgtar_read_header): Return an error code.
	* tools/gpgtar.c: Add missing include.
	(main): Print an generic error message if a command failed and no
	error has been printed yet.
	* tools/gpgtar.h (gpgtar_{create,extract,list,read_header}): Fix the
	prototypes accordingly.

	tools: Add encryption and decryption support to gpgtar.
	* tools/Makefile.am: Amend CFLAGS and LDADD.
	* tools/gpgtar-create.c (gpgtar_create): Add encrypt flag and encrypt
	stream if requested.
	* tools/gpgtar-extract.c (gpgtar_extract): Likewise for decryption.
	* tools/gpgtar-list.c (gpgtar_list): Likewise.
	* tools/gpgtar.c (main): Initialize npth and assuan.  Parse recipient
	and local user, and note which flags are currently ignored.  Adapt
	calls to gpgtar_list and friends.
	(tar_and_encrypt): Drop stub function and prototype.
	(decrypt_and_untar): Likewise.
	(decrypt_and_list): Likewise.
	* tools/gpgtar.h (gpgtar_{create,extract,list}): Add encryption or
	decryption argument.

	common: Add stream interface to call-pgp.
	* common/call-gpg.c (struct writer_thread_parms): Add field 'stream'.
	(writer_thread_main): Support reading from a stream.
	(start_writer): Add stream argument.
	(struct reader_thread_parms): Add field 'stream'.
	(reader_thread_main): Support writing to a stream.
	(start_reader): Add stream argument.
	(_gpg_encrypt): Add stream api.
	(gpg_encrypt_blob): Adapt accordingly.
	(gpg_encrypt_stream): New function.
	(_gpg_decrypt): Add stream api.
	(gpg_decrypt_blob): Adapt accordingly.
	(gpg_decrypt_stream): New function.
	* common/call-gpg.h (gpg_encrypt_stream): New prototype.
	(gpg_decrypt_stream): Likewise.

	common: Refactor the call-gpg code.
	* common/call-gpg.c (gpg_{en,de}crypt_blob): Move most of the code
	into two new functions, _gpg_encrypt and _gpg_decrypt.

	g13: Move 'call-gpg.c' to common.
	* common/Makefile.am (common_sources): Add files.
	* g13/call-gpg.c: Move to 'common' and adapt slightly.  Add a
	parameter to let callees override the gpg program to execute.
	* g13/call-gpg.h: Likewise.
	* g13/Makefile.am (g13_SOURCES): Drop files.
	* g13/create.c (encrypt_keyblob): Hand in the gpg program to execute.
	* g13/mount.c (decrypt_keyblob): Likewise.

2015-11-24  Neal H. Walfield  <neal@g10code.com>

	gpg: When comparing keyids, use the keyid, not the fingerprint's suffix.
	* g10/keyedit.c (menu_select_key): Use spacep and hexdigitp instead of
	inline tests.  Don't compare P to the suffix of the fingerprint.  If P
	appears to be a keyid, do an exact compare against the keyid.  If it
	appears to be a fingerprint, do an exact compare against the
	fingerprint.

2015-11-23  Neal H. Walfield  <neal@g10code.com>

	gpg: Reflow long texts.
	* common/stringhelp.c (format_text): New function.
	* common/t-stringhelp.c (stresc): New function.
	(test_format_text): New function.  Test format_text.
	* g10/tofu.c (get_trust): Use format_text to reflow long texts.
	(show_statistics): Likewise.

	common: Extend utf8_charcount to include the string's length.
	* common/stringhelp.c (utf8_charcount): Take additional parameter,
	len.  Process at most LEN bytes.

2015-11-23  Justus Winter  <justus@g10code.com>

	dirmngr: Fix http lookups when libadns is used.
	* dirmngr/dns-stuff.c (resolve_name_adns): Fill in the port.

	dirmngr: Fix SRV record lookups when using the system resolver.
	* dirmngr/dns-stuff.c (getsrv): Fix error handling.

	dirmngr: Honor ports specified in SRV records.
	* dirmngr/ks-engine-hkp.c (struct hostinfo_s): New field 'port'.
	(create_new_hostinfo): Initialize 'port'.
	(add_host): Add host parameter and update the hosttable entry.
	(map_host): Return port if known, adjust calls to 'add_host'.
	(make_host_part): Let 'map_host' specify the port if known.

	dirmngr: Support hkp server pools using SRV records.
	* dirmngr/ks-engine-hkp.c (map_host): Handle SRV records.

	dirmngr: Refactor 'map_host'.
	* dirmngr/ks-engine-hkp.c (add_host): New function.
	(map_host): Use the new function.

	dirmngr: Fix pool detection.
	* dirmngr/ks-engine-hkp (arecords_is_pool): Fix counting IP addresses.

	dirmngr: Refactor 'map_host'.
	* dirmngr/ks-engine-hkp.c (arecords_is_pool): New function.
	(map_host): Use the new function.

	dirmngr: Start dirmngr on demand.
	* common/asshelp.h: Include 'util.h'.
	* dirmngr/dirmngr-client.c (main): Use 'start_new_dirmngr' to connect
	to the dirmngr.
	(start_dirmngr): Drop now unused declaration and function.

2015-11-23  Neal H. Walfield  <neal@g10code.com>

	gpg: If sqlite is not available, don't build things depending on it.
	* configure.ac: Define the automake conditional SQLITE3.
	* tests/openpgp/Makefile.am (TESTS): Move the sqlite3 dependent tests
	to...
	(sqlite3_dependent_tests): ... this new variable.  If SQLITE3 is not
	defined, then clear this variable.

	gpg: Allow updating the expiration time of multiple subkeys at once.
	* g10/keyedit.c (menu_expire): Allow updating the expiration time of
	multiple subkeys at once.

	gpg: Don't crash if key is not passed an argument.
	* g10/keyedit.c (menu_select_key): Don't crash if P is NULL.

2015-11-20  Neal H. Walfield  <neal@g10code.com>

	gpg: Fail if the search description passed to --gen-revoke is ambiguous.
	* g10/revoke.c (gen_revoke): Error out if the search description is
	ambiguous.

	gpg: Refactor print_seckey_info.
	* g10/keylist.c (print_seckey_info): Break formatting functionality
	into...
	(format_seckey_info): ... this new function.

	gpg: Improve an error message.
	* g10/revoke.c (gen_revoke): Provide a more descriptive error message
	if searching for a key fails.

2015-11-19  Justus Winter  <justus@g10code.com>

	dirmngr: Improve error handling.
	* dirmngr/crlcache.c (crl_cache_cert_isvalid): Add missing break.

	dirmngr: Fix memory leak.
	* dirmngr/ldap.c (start_cert_fetch_ldap): Avoid leaking all malloc'ed
	arguments.

	agent: Improve error handling.
	* agent/trustlist.c (istrusted_internal): Initialize 'err'.

	common: Avoid undefined behavior.
	* common/iobuf.c (iobuf_esopen): Initialize 'len' as 'file_es_filter'
	will make use of it.

	g10: Avoid undefined behavior.
	* g10/trust.c (clean_one_uid): Avoid a computation involving an
	uninitialized value.

	scd: Improve error handling.
	* scd/app-openpgp.c (get_public_key): Improve error handling.

2015-11-18  Justus Winter  <justus@g10code.com>

	dirmngr: Gracefully handle premature termination of TLS streams.
	* dirmngr/http.c (close_tls_session): New function.
	(session_unref): Use the new function to close the TLS stream.
	(cookie_read): If the stream terminated prematurely, close it and
	return a short read.

2015-11-17  Neal H. Walfield  <neal@g10code.com>
	    Michael Mönch  <michael.moench@marktjagd.de>

	tools: Fix option parsing for gpg-zip.
	* tools/gpg-zip.in: Correctly set GPG when --gpg is specified.
	Correctly set TAR when --tar is specified.  Pass TAR_ARGS to tar.

2015-11-17  Neal H. Walfield  <neal@g10code.com>

	gpg: Allow selecting subkeys using a keyid.
	* g10/keyedit.c (menu_select_key): Take an additional argument, p.
	Update callers.  If P is a hex string, then assume that P is a key id
	or fingerprint and select subkeys with matching key ids or
	fingerprints.
	* doc/gpg.texi: Update documentation for the key subcommand.

2015-11-17  Justus Winter  <justus@g10code.com>

	dirmngr: Fix specifying keyservers by IP address.
	* dirmngr/ks-engine-hkp.c (map_host): Update the original 'hosttable'
	entry instead of creating another one.

2015-11-17  Neal H. Walfield  <neal@g10code.com>

	gpg: Change keydb_search to not return legacy keys.
	* g10/keyring.c (keyring_search): Take new argument, ignore_legacy.
	If set, skip any legacy keys.  Update callers.
	* g10/keydb.c (keydb_search): Skip any legacy keys.
	(keydb_search_first): Don't skip legacy keys.  Treat them
	as an error.
	(keydb_search_next): Likewise.
	(keydb_search_fpr): Likewise.
	* g10/export.c (do_export_stream): Likewise.
	* g10/getkey.c (lookup): Likewise.
	(have_secret_key_with_kid): Likewise.
	* g10/keylist.c (list_all): Likewise.
	(keyring_rebuild_cache): Likewise.
	* g10/keyserver.c (keyidlist): Likewise.
	* g10/trustdb.c (validate_key_list): Likewise.

	gpg: Correctly handle an error.
	* g10/keyring.c (keyring_search): If a compare function returns an
	error, treat it as an error.

	gpg: Correctly handle keyblocks followed by legacy keys.
	* g10/keyring.c (keyring_get_keyblock): If we encounter a legacy
	packet after already having some non-legacy packets, then treat the
	legacy packet as a keyblock boundary, not as part of the keyblock.
	* g10/t-keydb-get-keyblock.c: New file.
	* g10/t-keydb-get-keyblock.gpg: New file.
	* g10/Makefile.am (EXTRA_DIST): Add t-keydb-get-keyblock.gpg.
	(module_tests): Add t-keydb-get-keyblock.
	(t_keydb_get_keyblock_SOURCES): New variable.
	(t_keydb_get_keyblock_LDADD): Likewise.

	gpg: Make debugging search descriptors easier.
	* g10/keydb.c (dump_search_desc): Rename from this...
	(keydb_search_desc_dump): ... to this.  Only process a single search
	descriptor.  Improve output.  Don't mark as static.  Update callers.

	gpg: Add function format_keyid.
	* g10/options.h (opt.keyid_format): Add new value KF_DEFAULT.
	* g10/keyid.c (format_keyid): New function.
	(keystr): Use it.

	gpg: Use a more appropriate error code.
	* g10/gpg.c (check_user_ids): Return a more appropriate error code if
	a user id is ambiguous.

2015-11-17  Justus Winter  <justus@g10code.com>

	Fix typos found using codespell.
	* agent/cache.c: Fix typos.
	* agent/call-pinentry.c: Likewise.
	* agent/call-scd.c: Likewise.
	* agent/command-ssh.c: Likewise.
	* agent/command.c: Likewise.
	* agent/divert-scd.c: Likewise.
	* agent/findkey.c: Likewise.
	* agent/gpg-agent.c: Likewise.
	* agent/w32main.c: Likewise.
	* common/argparse.c: Likewise.
	* common/audit.c: Likewise.
	* common/audit.h: Likewise.
	* common/convert.c: Likewise.
	* common/dotlock.c: Likewise.
	* common/exechelp-posix.c: Likewise.
	* common/exechelp-w32.c: Likewise.
	* common/exechelp-w32ce.c: Likewise.
	* common/exechelp.h: Likewise.
	* common/helpfile.c: Likewise.
	* common/i18n.h: Likewise.
	* common/iobuf.c: Likewise.
	* common/iobuf.h: Likewise.
	* common/localename.c: Likewise.
	* common/logging.c: Likewise.
	* common/openpgp-oid.c: Likewise.
	* common/session-env.c: Likewise.
	* common/sexputil.c: Likewise.
	* common/sysutils.c: Likewise.
	* common/t-sexputil.c: Likewise.
	* common/ttyio.c: Likewise.
	* common/util.h: Likewise.
	* dirmngr/cdblib.c: Likewise.
	* dirmngr/certcache.c: Likewise.
	* dirmngr/crlcache.c: Likewise.
	* dirmngr/dirmngr-client.c: Likewise.
	* dirmngr/dirmngr.c: Likewise.
	* dirmngr/dirmngr_ldap.c: Likewise.
	* dirmngr/dns-stuff.c: Likewise.
	* dirmngr/http.c: Likewise.
	* dirmngr/ks-engine-hkp.c: Likewise.
	* dirmngr/ks-engine-ldap.c: Likewise.
	* dirmngr/ldap-wrapper.c: Likewise.
	* dirmngr/ldap.c: Likewise.
	* dirmngr/misc.c: Likewise.
	* dirmngr/ocsp.c: Likewise.
	* dirmngr/validate.c: Likewise.
	* g10/encrypt.c: Likewise.
	* g10/getkey.c: Likewise.
	* g10/gpg.c: Likewise.
	* g10/gpgv.c: Likewise.
	* g10/import.c: Likewise.
	* g10/keydb.c: Likewise.
	* g10/keydb.h: Likewise.
	* g10/keygen.c: Likewise.
	* g10/keyid.c: Likewise.
	* g10/keylist.c: Likewise.
	* g10/keyring.c: Likewise.
	* g10/mainproc.c: Likewise.
	* g10/misc.c: Likewise.
	* g10/options.h: Likewise.
	* g10/packet.h: Likewise.
	* g10/parse-packet.c: Likewise.
	* g10/pkclist.c: Likewise.
	* g10/pkglue.c: Likewise.
	* g10/plaintext.c: Likewise.
	* g10/server.c: Likewise.
	* g10/sig-check.c: Likewise.
	* g10/sqlite.c: Likewise.
	* g10/tdbio.c: Likewise.
	* g10/test-stubs.c: Likewise.
	* g10/tofu.c: Likewise.
	* g10/trust.c: Likewise.
	* g10/trustdb.c: Likewise.
	* g13/create.c: Likewise.
	* g13/mountinfo.c: Likewise.
	* kbx/keybox-blob.c: Likewise.
	* kbx/keybox-file.c: Likewise.
	* kbx/keybox-init.c: Likewise.
	* kbx/keybox-search-desc.h: Likewise.
	* kbx/keybox-search.c: Likewise.
	* kbx/keybox-update.c: Likewise.
	* scd/apdu.c: Likewise.
	* scd/app-openpgp.c: Likewise.
	* scd/app-p15.c: Likewise.
	* scd/app.c: Likewise.
	* scd/ccid-driver.c: Likewise.
	* scd/command.c: Likewise.
	* scd/iso7816.c: Likewise.
	* sm/base64.c: Likewise.
	* sm/call-agent.c: Likewise.
	* sm/call-dirmngr.c: Likewise.
	* sm/certchain.c: Likewise.
	* sm/gpgsm.c: Likewise.
	* sm/import.c: Likewise.
	* sm/keydb.c: Likewise.
	* sm/minip12.c: Likewise.
	* sm/qualified.c: Likewise.
	* sm/server.c: Likewise.
	* tools/gpg-check-pattern.c: Likewise.
	* tools/gpgconf-comp.c: Likewise.
	* tools/gpgkey2ssh.c: Likewise.
	* tools/gpgparsemail.c: Likewise.
	* tools/gpgtar.c: Likewise.
	* tools/rfc822parse.c: Likewise.
	* tools/symcryptrun.c: Likewise.

2015-11-16  Neal H. Walfield  <neal@g10code.com>

	gpg: Fix error checking and improve error reporting.
	* g10/gpg.c (check_user_ids): Differentiate between a second result
	and an error.  If the key specification is ambiguous or an error
	occurs, set RC appropriately.

2015-11-14  Werner Koch  <wk@gnupg.org>

	gpg: Use only one fingerprint formatting function.
	* g10/gpg.h (MAX_FORMATTED_FINGERPRINT_LEN): New.
	* g10/keyid.c (hexfingerprint): Add optional args BUFFER and BUFLEN.
	Change all callers.
	(format_hexfingerprint): New.
	* g10/keylist.c (print_fingerprint): Change to use hexfingerprint.
	* g10/tofu.c (fingerprint_format): Remove.  Replace calls by
	format_hexfingerprint.

2015-11-13  Werner Koch  <wk@gnupg.org>

	gpg: Simplify the tofu interface by using the public key packet.
	* g10/tofu.c (fingerprint_str): Remove.
	(tofu_register): Take a public key instead of a fingerprint as arg.
	Use hexfingerprint() to get a fpr from the PK.
	(tofu_get_validity): Ditto.
	(tofu_set_policy, tofu_get_policy): Simplify by using hexfingerprint.
	* g10/trustdb.c (tdb_get_validity_core): Pass the primary key PK to
	instead of the fingerprint to the tofu functions.

	gpg: Make trusted-key override for Tofu robust against swapped tofu.db.
	* g10/tofu.c (get_trust): For the UTK check lookup the key by
	fingerprint.

	gpg: Fix regression in --locate-keys (in 2.1.9).
	* g10/getkey.c (getkey_ctx_s): Add field "extra_list".
	(get_pubkey_byname): Store strings in the context.
	(getkey_end): Free EXTRA_LIST.

2015-11-12  Werner Koch  <wk@gnupg.org>

	gpg: Print a new EXPORTED status line.
	* common/status.h (STATUS_EXPORTED): New.
	* g10/export.c (print_status_exported): New.
	(do_export_stream): Call that function.

	gpg: Print export statistics to the status-fd.
	* common/status.h (STATUS_EXPORT_RES): New.
	* g10/main.h (export_stats_t): New.
	* g10/export.c (export_stats_s): New.
	(export_new_stats, export_release_stats): New.
	(export_print_stats): New.
	(export_pubkeys, export_seckeys, export_secsubkeys)
	(export_pubkey_buffer, do_export): Add arg "stats".
	(do_export_stream): Add arg stats and update it.
	* g10/gpg.c (main) <aExport, aExportSecret, aExportSecretSub>: Create,
	pass, and print a stats object to the export function calls.

	* g10/export.c (export_pubkeys_stream): Remove unused function.

	dirmngr: Do not block during ADNS calls.
	* dirmngr/dns-stuff.c: Include npth.h
	(my_unprotect, my_protect): New wrapper.
	(resolve_name_adns): Put unprotect/protect around adns calls.
	(get_dns_cert): Ditto.
	(getsrv): Ditto.
	(get_dns_cname): Ditto.

	dirmngr: New option --nameserver.
	* dirmngr/dirmngr.c (oNameServer): New.
	(opts): Add --nameserver.
	(parse_rereadable_options): Act upon oNameServer.
	* dirmngr/dns-stuff.c (DEFAULT_NAMESERVER): New.
	(tor_nameserver): New.
	(set_dns_nameserver): New.
	(my_adns_init): Make name server configurable.

2015-11-11  Neal H. Walfield  <neal@g10code.com>

	gpg: Fix cache consistency problem.
	g10/keyring.c (keyring_search): Only mark the cache as completely
	filled if we start the scan from the beginning of the keyring.

2015-11-10  Neal H. Walfield  <neal@g10code.com>

	gpg: Default to the the PGP trust model.
	* g10/trustdb.c (init_trustdb): If we can't read the trust model from
	the trust DB, default to TM_PGP, not TM_TOFU_PGP.

	gpg: Default to the flat TOFU DB format.
	* g10/tofu.c (opendbs): If the TOFU DB format is set to auto and there
	is no TOFU DB, default to the flat format.

2015-11-09  Werner Koch  <wk@gnupg.org>

	dirmngr: Change to new ADNS Tor mode init scheme.
	* dirmngr/dns-stuff.c (tor_credentials): New.
	(enable_dns_tormode): Add arg new_circuit and update tor_credentials.
	(my_adns_init): Rework to set Tor mode using a config file options and
	always use credentials.
	* dirmngr/server.c (cmd_dns_cert): Improve error message.
	* dirmngr/t-dns-stuff.c (main): Add option --new-circuit.

	dirmngr: Improve detection of ADNS.
	* configure.ac (HAVE_ADNS_FREE): New ac_define.

2015-11-09  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Add reder information to --card-status.
	* g10/call-agent.h, g10/call-agent.c (agent_release_card_info)
	g10/card-util.c (card_status): Add READER.
	* scd/apdu.c (close_ccid_reader, open_ccid_reader): Handle RDRNAME.
	(apdu_get_reader_name): New.
	* scd/ccid-driver.c (ccid_open_reader): Add argument to RDRNAME_P.
	* scd/command.c (cmd_learn): Return READER information.

2015-11-06  Werner Koch  <wk@gnupg.org>

	gpg: Avoid new strings.
	* g10/decrypt-data.c (decrypt_data): Use already translated strings.

	common: Fix commit f99830b.
	* common/userids.c (classify_user_id): Avoid underflow.  Use spacep to
	also trim tabs.

2015-11-06  Neal H. Walfield  <neal@g10code.com>

	gpg: Fix formatting string.
	* g10/decrypt-data.c (decrypt_data): Fix formatting string.

	gpg: Add new option --only-sign-text-ids.
	* g10/options.h (opt): Add field only_sign_text_ids.
	* g10/gpg.c (enum cmd_and_opt_values): Add value oOnlySignTextIDs.
	(opts): Handle oOnlySignTextIDs.
	(main): Likewise.
	* g10/keyedit.c (sign_uids): If OPT.ONLY_SIGN_TEXT_IDS is set, don't
	select non-text based IDs automatically.
	(keyedit_menu): Adapt the prompt asking to sign all user ids according
	to OPT.ONLY_SIGN_TEXT_IDS.
	* doc/gpg.texi: Document the new option --only-sign-text-ids.

	common: When classifying keyids and fingerprints, reject trailing junk.
	* common/userids.c (classify_user_id): Trim any trailing whitespace.
	Before assuming that a hexstring corresponds to a key id or
	fingerprint, make sure that it is NUL terminated.

	gpg: Check for ambiguous or non-matching key specs.
	* g10/gpg.c (check_user_ids): New function.
	(main): Check that any user id specifications passed to --local-user
	and --remote-user correspond to exactly 1 user.  Check that any user
	id specifications passed to --default-key correspond to at most 1
	user.  Warn if any user id specifications passed to --local-user or
	--default-user are possible ambiguous (are not specified by long keyid
	or fingerprint).
	* g10/getkey.c (parse_def_secret_key): Don't warn about possible
	ambiguous key descriptions here.

	common: Add new function strlist_rev.
	* common/strlist.c (strlist_rev): New function.
	* common/t-strlist.c: New file.
	* common/Makefile.am (common_sources): Add strlist.c and strlist.h.
	(module_tests): Add t-strlist.
	(t_strlist_LDADD): New variable.

	common: Include required, but not included headers in t-support.h.
	* common/t-support.h: Include <stdlib.h> and <stdio.h>.

2015-11-05  Neal H. Walfield  <neal@g10code.com>

	gpg: Indicate which characters are invalid.
	* g10/keygen.c (ask_user_id): Indicate which characters are invalid.

	gpg: Add support for unwrapping the outer level of encryption.
	* g10/decrypt-data.c (decrypt_data): If OPT.UNWRAP_ENCRYPTION is set,
	copy the data to the output file instead of continuing to process it.
	* g10/gpg.c (enum cmd_and_opt_values): Add new value oUnwrap.
	(opts): Handle oUnwrap.
	(main): Likewise.
	* g10/options.h (opt): Add field unwrap_encryption.
	* g10/plaintext.c (handle_plaintext): Break the output file selection
	functionality into ...
	(get_output_file): ... this new function.

	common: Add a function for copying data from one iobuf to another.
	* common/iobuf.c (iobuf_copy): New function.

	doc: Note that gpgkey2ssh is deprecated.
	* doc/tools.texi (gpgkey2ssh): Note that gpgkey2ssh is deprecated.

	tools: Fix gpgkey2ssh's most gratuitous errors.  Use gpg2, not gpg.
	* tools/gpgkey2ssh.c (main): Add support for --help.  Replace the most
	gratuitous asserts with error messages.  Invoke gpg2, not gpg.

2015-11-05  Neal H. Walfield  <neal@g10code.com>
	    Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	doc: Add documentation for gpgkey2ssh.
	* doc/tools.texi: Add documentation for gpgkey2ssh.

2015-11-04  Neal H. Walfield  <neal@g10code.com>

	gpg: Print a better error message for --multifile --sign --encrypt.
	* g10/gpg.c (main): Print a better error message for --multifile
	--sign --encrypt.

	gpg: Add --encrypt-to-default-key.
	* g10/getkey.c (parse_def_secret_key): Drop the static qualifier and
	export the function.
	* g10/gpg.c (enum cmd_and_opt_values): Add value oEncryptToDefaultKey.
	(opts): Handle oEncryptToDefaultKey.
	(main): Likewise.
	* g10/options.h (opt): Add field encrypt_to_default_key.

	gpg: Allow multiple --default-key options.  Take the last available key.
	* g10/getkey.c (parse_def_secret_key): New function.
	(get_seckey_default): Add parameter ctrl.  Update callers.  Use
	parse_def_secret_key to get the default secret key, if any.
	(getkey_byname): Likewise.
	(enum_secret_keys): Likewise.
	* g10/options.h (opt): Change def_secret_key's type from a char * to a
	strlist_t.
	* g10/gpg.c (main): When processing --default-key, add the key to
	OPT.DEF_SECRET_KEY.
	* g10/gpgv.c (get_session_key): Add parameter ctrl.  Update callers.
	* g10/mainproc.c (proc_pubkey_enc): Likewise.
	(do_proc_packets): Likewise.
	* g10/pkclist.c (default_recipient): Likewise.
	* g10/pubkey-enc.c (get_session_key): Likewise.
	* g10/sign.c (clearsign_file): Likewise.
	(sign_symencrypt_file): Likewise.
	* g10/skclist.c (build_sk_list): Likewise.
	* g10/test-stubs.c (get_session_key): Likewise.

2015-11-04  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix error handling with libusb-compat library.
	* scd/ccid-driver.c (bulk_out): Use LIBUSB_ERRNO_NO_SUCH_DEVICE.

	scd: fix change_keyattr.
	* scd/app-openpgp.c (change_keyattr_from_string): Fix parsing.

2015-11-03  Werner Koch  <wk@gnupg.org>

	gpg: Change out of core error message.
	* g10/tofu.c (fingerprint_str): Die with the error code returned by
	the failed function.
	(time_ago_str): Ditto.  Do not make a comma translatable.
	(fingerprint_format): Use "%zu" for a size_t.

	gpg: Make translation easier.
	* g10/import.c (import_secret_one): Split info string for easier
	translation.

2015-11-03  Neal H. Walfield  <neal@g10code.com>

	gpg: Also show when the most recently signed message was observed.
	* g10/tofu.c (show_statistics): Also show when the most recently
	signed message was observed.

	gpg: Split a utility function out of a large function.
	* g10/tofu.c (show_statistics): Break the time delta to string code
	into...
	(time_ago_str): ... this new function.

	gpg: Fix message formatting.
	* g10/tofu.c (get_trust): Fix message formatting.

	gpg: Don't store formatting fingerprints in the TOFU DB.
	* g10/tofu.c (fingerprint_pp): Split this function into...
	(fingerprint_str): ... this function...
	(fingerprint_format): ... and this function.
	(record_binding): Store the unformatted fingerprint in the DB.  Only
	use the formatting fingerprint when displaying a message to the user.
	(get_trust): Likewise.
	(show_statistics): Likewise.
	(tofu_register): Likewise.
	(tofu_get_validity): Likewise.
	(tofu_set_policy): Likewise.
	(tofu_get_policy): Likewise.

2015-11-02  NIIBE Yutaka  <gniibe@fsij.org>

	g10: notify a user when importing stub is skipped.
	* g10/import.c (transfer_secret_keys): Return GPG_ERR_NOT_PROCESSED
	when stub_key_skipped.
	(import_secret_one): Notify a user, suggesting --card-status.

2015-10-31  Neal H. Walfield  <neal@g10code.com>

	gpg: Consider newlines to be whitespace in an SQL statement.
	* g10/sqlite.c (sqlite3_stepx): When making sure that there is no
	second SQL statement, ignore newlines.

2015-10-30  Werner Koch  <wk@gnupg.org>

	common: Improve t-zb32 to be used for manual encoding.
	* common/t-support.h (no_exit_on_fail, errcount): New.
	(fail): Bump errcount.
	* common/t-zb32.c (main): Add options to allow manual use.

	common: Add separate header for zb32.c.
	* common/util.h (zb32_encode): Move prototype to ...
	* common/zb32.h: new.  Include this for all callers of zb32_encode.

2015-10-29  Neal H. Walfield  <neal@g10code.com>

	gpg: Display the correct error message.
	* g10/trustdb.c (validate_keys): If tdbio_update_version_record fails,
	RC does not contain the error code.  Save the error code in rc2 and
	use that.

	gpg: Eliminate a memory leak.
	* g10/trustdb.c (validate_key_list): Don't leak the keyblocks on
	failure.

	gpg: Remove unused prototype.
	g10/keyring.h (keyring_locate_writable): Remove unused prototype.

	gpg: Eliminate a memory leak.
	* g10/gpg.c (main): Don't leak OPT.DEF_RECIPIENT.

	gpg: Fix keyring support.
	* g10/keydb.c (keydb_rebuild_caches): Only mark the cached as prepared
	if it is actually prepared, which it only is if the resource is a
	keybox.

	gpg: Change sqlite3_stepx to pass the sqlite3_stmt * to the callback.
	* g10/sqlite.h (enum sqlite_arg_type): Add SQLITE_ARG_BLOB.
	(sqlite3_stepx_callback): New declaration.
	(sqlite3_stepx): Change the callback's type to sqlite3_stepx_callback,
	which passes an additional parameter, the sqlite3_stmt *.  Update
	users.

	gpg: Move sqlite helper functions into their own file.
	* g10/tofu.c (sqlite3_exec_printf): Move from here...
	* g10/sqlite.c (sqlite3_exec_printf): ... to this new file.  Don't
	mark as static.
	* g10/tofu.c (sqlite3_stepx): Move from here...
	* g10/sqlite.c (sqlite3_stepx): ... to this new file.  Don't
	mark as static.
	* g10/tofu.c (enum sqlite_arg_type): Move from here...
	* g10/sqlite.h (enum sqlite_arg_type): ... to this new file.

2015-10-29  NIIBE Yutaka  <gniibe@fsij.org>

	doc: Don't install gpg-zip.1.
	* doc/Makefile.am (myman_pages): Remove gpg-zip.1.
	(DISTCLEANFILES): Add gpg-zip.1.

2015-10-28  Werner Koch  <wk@gnupg.org>

	sm: Allow combination of usage flags --gen-key.
	* sm/certreqgen.c (create_request): Re-implement building of the
	key-usage extension.

2015-10-28  Damien Goutte-Gattat  <dgouttegattat@incenp.org>

	doc: Document some changed default options.
	* doc/gpg.texi: Update the description of some options which are
	  now enabled by default.

2015-10-28  Werner Koch  <wk@gnupg.org>

	dirmngr: Fix NULL-deref while loading a CRL.
	* dirmngr/crlcache.c (crl_parse_insert): Set error before leaping to
	failure.

	dirmngr: Minor cleanup of the SRV RR code.
	* dirmngr/dns-stuff.c: Include unistd.h.
	(getsrv): Run srand only once.
	* dirmngr/t-dns-stuff.c (main): Allow passing another name for --srv
	and change output format.

	dirmngr: Add a getaddrinfo wrapper backend using ADNS.
	* dirmngr/dns-stuff.c: Replace all use of default_errsource.
	(my_adns_init): Move to top.
	(resolve_name_adns): New.
	(resolve_dns_name) [USE_ADNS]: Divert to new func.

2015-10-26  Werner Koch  <wk@gnupg.org>

	gpg: Do not call an extra get_validity if no-show-uid-validity is used.
	* g10/mainproc.c (check_sig_and_print): Do not call the informational
	get_validity if we are not going to use it.

2015-10-26  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	gpg: Ensure all weak digest rejection notices are shown.
	* g10/main.h: Add rejection_shown flag to each weakhash struct
	* g10/misc.c (print_digest_algo_note, additional_weak_digest): Do not
	treat MD5 separately; (print_digest_rejected_note): Use
	weakhash.rejection_shown instead of static shown.
	* g10/options.h (opt): Change from additional_weak_digests to
	weak_digests.
	* g10/sig-check.c: Do not treat MD5 separately.
	* g10/gpg.c (main): Explicitly set MD5 as weak.
	* g10/gpgv.c (main): Explicitly set MD5 as weak.

2015-10-26  Werner Koch  <wk@gnupg.org>

	w32: Make it build again if Tofu support is not available.
	* g10/keylist.c (public_key_list) [!USE_TOFU]: Do not call tofu
	functions.

	dirmngr: Support Tor hidden services.
	* dirmngr/dns-stuff.c (is_onion_address): New.
	* dirmngr/ks-engine-hkp.c (hostinfo_s): Add field "onion".
	(map_host): Special case onion addresses.
	(ks_hkp_print_hosttable): Print an 'O' for an onion address.
	* dirmngr/http.c (connect_server): Special case onion addresses.

	dirmngr,w32: Remove gethostbyname hack and make it build again.
	* dirmngr/http.c (connect_server) [W32]: Remove gethostbyname hack;
	we require getaddrinfo anyway.
	* dirmngr/dns-stuff.c (AI_ADDRCONFIG): Add replacement if not defined.
	(map_eai_to_gpg_error) [W32]: Take care of unsupported codes.

2015-10-26  Neal H. Walfield  <neal@g10code.com>

	gpg: Make sure we only have a single SQL statement.
	* g10/tofu.c (sqlite3_stepx): Make sure SQL only contains a single SQL
	statement.

	gpg: When the TOFU DB is in batch mode, periodically drop the locks.
	* g10/tofu.c: Include <sched.h>.
	(batch_update_started): New variable.
	(begin_transaction): If we've been in batch mode for a while, then
	commit any extant batch transactions.
	(tofu_begin_batch_update): If we are not in batch mode, initialize
	batch_update_started.

2015-10-25  Werner Koch  <wk@gnupg.org>

	dirmngr: Add workaround for broken getaddrinfo.
	* dirmngr/dns-stuff.c (resolve_name_standard): On failure retry by
	first resolving the CNAME.
	(get_dns_cname): New.

	* dirmngr/t-dns-stuff.c (main): Add option --cname.

	dirmngr: Better handle systems without IPv6 or IPv4.
	* dirmngr/dns-stuff.c (resolve_name_standard): Use AI_ADDRCONFIG.

	dirmngr: Replace use of getnameinfo by resolve_dns_addr.
	* dirmngr/ks-engine-hkp.c (my_getnameinfo): Remove.
	(map_host): Use resolve_dns_addr.

	dirmngr: Implement a getnameinfo wrapper.
	* dirmngr/dns-stuff.h (DNS_NUMERICHOST): New.
	(DNS_WITHBRACKET): New.
	* dirmngr/dns-stuff.c (resolve_name_standard): Factor code out to...
	(map_eai_to_gpg_error): new.
	(resolve_addr_standard): New.
	(resolve_dns_addr): New.

	* dirmngr/ks-engine-hkp.c (is_ip_address): Move to ...
	* dirmngr/dns-stuff.c (is_ip_address): here.  Add support for non
	bracketed v6 addresses.

	* dirmngr/t-dns-stuff.c: Remove header netdb.h.
	(main): Add option --bracket.  Use resolve_dns_name instead of
	getnameinfo.

2015-10-23  Neal H. Walfield  <neal@g10code.com>

	gpg: Provide an interface to patch TOFU updates.
	* g10/tofu.c (struct db): Rename begin_transaction to savepoint_batch.
	Rename end_transaction to savepoint_batch_commit.  Update users.
	Remove field rollback.  Add fields savepoint_inner and
	savepoint_inner_commit.  Add field batch_update.
	(dump_cache): New function.
	(batch_update): New variable.
	(begin_transaction). New function.
	(end_transaction): New function.
	(rollback_transaction): New function.
	(tofu_begin_batch_update): New function.
	(tofu_end_batch_update): New function.
	(closedb): End any pending batch transaction.
	(closedbs): Assert that none of the DBs have a started batch
	transaction if we not in batch mode.
	(record_binding): Use the begin_transaction, end_transaction and
	rollback_transaction functions instead of including the SQL inline.
	Also start a batch mode transaction if we are using the flat format.
	(tofu_register): Use the begin_transaction, end_transaction and
	rollback_transaction functions instead of including the SQL inline.
	* g10/gpgv.c (tofu_begin_batch_update): New function.
	(tofu_end_batch_update): New function.
	* g10/test-stubs.c (tofu_begin_batch_update): New function.
	(tofu_end_batch_update): New function.

	gpg: Cache prepared SQL queries and open DB connections.
	* g10/tofu.c: Include <stdarg.h>.
	(prepares_saved) [DEBUG_TOFU_CACHE]: New variable.
	(queries) [DEBUG_TOFU_CACHE]: New variable.
	(struct db): Add fields prevp, begin_transaction, end_transaction,
	rollback, record_binding_get_old_policy, record_binding_update,
	record_binding_update2, get_policy_select_policy_and_conflict,
	get_trust_bindings_with_this_email, get_trust_gather_other_user_ids,
	get_trust_gather_other_keys, register_already_seen, and
	register_insert.
	[DEBUG_TOFU_CACHE]: Add field hits.
	(STRINGIFY): New macro.
	(STRINGIFY2): New macro.
	(enum sqlite_arg_type): New enum.
	(sqlite3_stepx): New function.
	(combined_db): Remove variable.
	(opendb): Don't cache the combined db.
	(struct dbs): New struct.  Update users to use this as the head of the
	local DB list rather than overloading struct db.
	(unlink_db): New function.
	(link_db): New function.
	(db_cache): New variable.
	(db_cache_count): New variable.
	(DB_CACHE_ENTRIES): Define.
	(getdb): If the dbs specific cache doesn't include the DB, look at
	DB_CACHE.  Only if that also doesn't include the DB open the
	corresponding DB.
	(closedb): New function.
	(opendbs): Don't open the combined DB.  Just return an initialized
	struct dbs.
	(closedbs): Don't close the dbs specific dbs.  Attach them to the
	front of DB_CACHE.  If DB_CACHE contains more than DB_CACHE_ENTRIES,
	close enough dbs from the end of the DB_CACHE list such that DB_CACHE
	only contains DB_CACHE_ENTRIES.  Don't directly close the dbs, instead
	use the new closedb function.
	[DEBUG_TOFU_CACHE]: Print out some statistics.
	(record_binding): Use sqlite3_stepx instead of sqlite3_exec or
	sqlite3_exec_printf.
	(get_policy): Likewise.
	(get_trust): Likewise.
	(tofu_register): Likewise.

	gpg: Return the DBs meta-handle rather than the sqlite3 handle.
	* g10/tofu.c (getdb): Return a struct db * instead of an sqlite *.
	Update users.

	gpg: Use the proper type.
	* g10/options.h: Include "tofu.h".
	(opt.tofu_default_policy): Change type to enum tofu_policy.
	* g10/gpgv.c (enum tofu_policy): Don't redeclare.
	* g10/test-stubs.c (enum tofu_policy): Likewise.

2015-10-22  Werner Koch  <wk@gnupg.org>

	dirmngr: Implement Tor mode for SRV RRs.
	* dirmngr/dns-stuff.c (get_dns_cert): Factor adns init out to...
	(my_adns_init): new.
	(getsrv)[USE_ADNS]: Use my_adns_init.
	(getsrv)[!USE_ADNS]: Return an error if Tor mode is active.

	* dirmngr/t-dns-stuff.c: Add option --use-tor.

	dirmngr: Do not use MAXDNAME.
	* dirmngr/dns-stuff.c (getsrv): Replace MAXDNAME.
	* dirmngr/dns-stuff.h (MAXDNAME): Remove.
	(struct srventry): Use a fixed value instead of MAXDNAME.
	* dirmngr/http.c (connect_server): Use DIMof instead of MAXDNAME.
	Malloc a helper array.

	Move SRV RR code from common/ to dirmngr/.
	* common/srv.c: Merge into dirmngr/dns-stuff.c.  Delete file.
	* common/srv.h: Merge into dirmngr/dns-stuff.h.  Delete file.
	* common/Makefile.am (common_sources): Remove srv.c and srv.h.
	* g10/keyserver.c: Do not include srv.h.  The code using it is anyway
	disabled.
	* dirmngr/http.c: Remove header srv.h and stubs.
	* dirmngr/t-dns-stuff.c: Add option --srv.

2015-10-21  Werner Koch  <wk@gnupg.org>

	dirmngr: Use the new DNS wrapper for the HTTP module.
	* dirmngr/t-http.c (main): Init assuan sockets.
	* dirmngr/http.c: Include dns-stuff.h.
	(connect_server)[!HAVE_GETADDRINFO]: Remove all code.
	(connect_server): Change to use resolve_dns_name.

	dirmngr: Allow use of http.c if USE_NPTH is not defined.
	* dirmngr/http.c (send_request): Always set the gnutls pull/push
	functions.
	(my_npth_read): Rename to ...
	(my_gnutls_read) .. this.  Use system read if !USE_NPTH.
	(my_npth_write): Rename to ...
	(my_gnutls_write) .. this.  Use system write if !USE_NPTH.

	dirmngr: Check that getaddrinfo is available.
	* dirmngr/Makefile.am (t_http_SOURCES): Add dns-stuff.c.
	(t_ldap_parse_uri_SOURCES): Ditto.
	* dirmngr/dns-stuff.c: Bail out if neither ADNS nor getaddrinfo is
	available.

	dirmngr: Use the new DNS wrapper for the HKP engine.
	* dirmngr/ks-engine-hkp.c (my_getnameinfo): Change arg type to
	dns_addrinfo_t.
	(map_host): Replace getaddrinfo by resolve_dns_name.

	dirmngr: Implement a getaddrinfo wrapper.
	* dirmngr/dns-stuff.h: Include some header files.
	(dns_addinfo_t, dns_addrinfo_s): New.
	* dirmngr/dns-stuff.c: Always include DNS related headers.
	(free_dns_addrinfo): New.
	(resolve_name_standard): New.
	(resolve_dns_name): New.

	* dirmngr/t-dns-stuff.c: Include netdb.h.
	(main): Keep old default mode with no args but else print outout of
	resolve_dns_name.  Revamp option parser.

	common: Add more replacement error codes.
	* common/util.h (GPG_ERR_SERVER_FAILED): New.
	(GPG_ERR_NO_KEY): New.
	(GPG_ERR_NO_NAME): New.

2015-10-21  Neal H. Walfield  <neal@g10code.com>

	gpg: If the saved trust model is unknown, default to tofu+pgp.
	* g10/trustdb.c (init_trustdb): If the saved trust model is unknown,
	default to tofu+pgp instead of pgp.

	gpg: Don't accidentally free UTK_LIST.
	* g10/trustdb.c (validate_keys): Don't free UTK_LIST.

	gpg: When evaluating trust reg exps, treat tofu+pgp like pgp.
	* g10/trustdb.c (validate_one_keyblock): When checking trust regular
	expressions, treat the tofu+pgp trust model the same as the pgp trust
	model.

	gpg: If a key is ultimate trusted, return that in the tofu model.
	* g10/tofu.c (get_trust): If the policy is auto or none, check if the
	key is ultimately trusted.  If so, return that.
	(tofu_register): If the key is ultimately trusted, don't show any
	statistics.
	(tofu_get_validity): Likewise.

	gpg: Keep the trust DB up to date for the tofu and tofu+pgp models.
	* g10/trustdb.c (init_trustdb): Recognize tofu and tofu+pgp as
	possibly saved trust models.  Also register the ultimately trusted
	keys if the trust model is tofu or tofu+pgp.
	(check_trustdb): Don't skip if the trust model is tofu or tofu+pgp.
	(update_trustdb): Likewise.
	(tdb_check_trustdb_stale): Likewise.
	(validate_keys): If the trust model is TOFU, just write out the
	ultimately trusted keys.

	gpg: Factor out code into a standalone function.
	* g10/trustdb.c (tdb_keyid_is_utk): New function.
	(add_utk): Use it.

	dirmngr: Allow building with libassuan < 2.3.
	* dirmngr/http.c (send_request): Use newer assuan function only if
	available.

2015-10-21  Neal H. Walfield  <neal@g10code.com>
	    Andre Heinecke  <aheinecke@intevation.de>

	gpg: Make the tofu DB check and initialization atomic.
	* g10/tofu.c (initdb): Make the version check and the database
	initialization atomic.

2015-10-21  Werner Koch  <wk@gnupg.org>

	build: Make --disable-g13 the default.
	* Makefile.am (DISTCHECK_CONFIGURE_FLAGS): Add --enable-g13.  Remove
	--enable-gpgtar because that is enabled anyway.
	* configure.ac: Do not build g13 by default.

	dirmngr: Rename file dns-cert.c.
	* dirmngr/dns-cert.c: Rename to dirmngr/dns-stuff.c.
	* dirmngr/dns-cert.h: Rename to dirmngr/dns-stuff.h and change
	includers.
	* dirmngr/t-dns-cert.c: Rename to dirmngr/t-dns-stuff.c.
	* dirmngr/Makefile.am: Adjust.

	common: Add status code for use by g13.
	* common/status.h (STATUS_PLAINTEXT_FOLLOWS): New.

2015-10-20  Werner Koch  <wk@gnupg.org>

	dirmngr: Prefer ADNS over system resolver.
	* configure.ac (HAVE_ADNS_IF_TORMODE): New ac_define.
	(USE_DNS_CERT): Prefer ADNS over the system resolver.
	* dirmngr/dns-cert.c (tor_mode): New global var.
	(enable_dns_tormode): New func.
	(get_dns_cert): Use DNS resolver at 8.8.8.8 in tor-mode.
	* dirmngr/server.c (cmd_dns_cert): If supported allow DNS requests.

	w32: Allow building again.
	* dirmngr/http.c (connect_server): Fix called function name.

	build: Allow building without SQLlite support.
	* configure.ac: Add option --dsiable-tofu and --disable-sqlite.
	(NEED_SQLITE_VERSION): New var.
	(USE_TOFU): New ac_define and am_conditional.
	* autogen.sh (build-w32): Add PKG_CONFIG_LIBDIR to configure so that
	pkg-config find the correct .pc file.

	* g10/Makefile.am (tofu_source): New.  Build only if enabled.
	* g10/gpg.c (parse_trust_model)[!USE_TOFU]: Disable tofu models.
	(parse_tofu_policy)[!USE_TOFU]: Disable all.
	(parse_tofu_db_format)[!USE_TOFU]: Disable all.
	(main) <aTOFUPolicy>[!USE_TOFU]: Skip.
	* g10/keyedit.c (show_key_with_all_names_colon)[!USE_TOFU]: Do not
	call tofu functions.
	* g10/keylist.c (list_keyblock_colon)[!USE_TOFU]: Ditto.
	* g10/trustdb.c (tdb_get_validity_core)[!USE_TOFU]: Skip tofu
	processing.

2015-10-20  Neal H. Walfield  <neal@g10code.com>

	gpg: Don't die immediately if the TOFU DB is locked.
	* g10/tofu.c (opendb): Don't die immediately if the DB is locked.

	gpg: Improve output.
	* g10/tofu.c (get_trust): Also show the binding when indicating a
	conflict occurred.

	gpg: Synchronize translation template.
	* g10/tofu.c (show_statistics): Synchronize translation template.

	gpg: When showing conflicts, also show bindings with no recorded sigs.
	* g10/tofu.c (signature_stats_collect_cb): If the time_ago column is
	NULL, then both time_ago and count should be 0.
	(get_trust): Reverse the direction of the join so that we also get
	statistics about bindings without any signatures.

	gpg: Improve text.
	* g10/tofu.c (show_statistics): Improve text.

	gpg: Use the right variable to display the information.
	* g10/tofu.c (get_trust): Use the right variable to display the
	conflicting key.

	gpg: Make failing to create a directory a soft error.
	* g10/tofu.c (getdb): Don't exit if we can't create the directory.
	Just return an error.

	common: Make sure tilde expansion works for the mkdir functions.
	* common/mkdir_p.c (gnupg_amkdir_p): Use make_filename_try on the
	first directory component as well.

	gpg: Remove unused prototype digest_algo_from_sig.
	* g10/packet.h (digest_algo_from_sig): Remove prototype without a
	corresponding implementation.

2015-10-19  Werner Koch  <wk@gnupg.org>

	dirmngr: Allow building with libassuan < 2.3.
	* dirmngr/dirmngr.c (set_tor_mode): Use newer assuan function only if
	available.
	* dirmngr/http.c (http_raw_connect): Ditto.

2015-10-19  Neal H. Walfield  <neal@g10code.com>

	gpg: Fix --desig-revoke.
	* g10/revoke.c (gen_desig_revoke): Add additional parameter ctrl.
	Check that the secret key is available.  If not, display an error
	message.

	gpg: Improve function documentation and some comments.
	* g10/main.h: Improve function documentation.
	* g10/packet.h.h: Improve function documentation.
	* g10/sig-check.c: Improve function documentation and some comments.

	gpg: Improve and regularize naming of signature checking functions.
	* g10/packet.h (signature_check): Rename from this...
	(check_signature): ... to this.  Update users.
	(signature_check2): Rename from this...
	(check_signature2): ... to this.  Update users.
	* g10/sig-check.c (do_check): Rename from this...
	(check_signature_end): ... to this.  Update users.
	(do_check_messages): Rename from this...
	(check_signature_metadata_validity): ... to this.  Update users.

	gpg: Mark local function as static.
	* g10/tdbio.c (put_record_into_cache): Mark as static.

2015-10-19  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	gpg: Print warning when rejecting weak digests.
	* g10/misc.c (print_md5_rejected_note): Rename to ..
	(print_digest_rejected_note): this.  Parameterize function to take an
	enum gcry_md_algos.
	* g10/sig-check.c: Use print_digest_rejected_note() when rejecting
	signatures.

	gpg: Add option --weak-digest to gpg and gpgv.
	* g10/options.h: Add additional_weak_digests linked list to opts.
	* g10/main.h: Declare weakhash linked list struct and
	additional_weak_digest() function to insert newly-declared weak
	digests into opts.
	* g10/misc.c: (additional_weak_digest): New function.
	(print_digest_algo_note): Check for deprecated digests; use proper
	gcry_md_algos type.
	* g10/sig-check.c: (do_check): Reject weak digests in addition to MD5.
	* g10/gpg.c: Add --weak-digest option to gpg.
	* doc/gpg.texi: Document gpg --weak-digest option.
	* g10/gpgv.c: Add --weak-digest option to gpgv.
	* doc/gpgv.texi: Document gpgv --weak-digest option.

2015-10-19  Werner Koch  <wk@gnupg.org>

	dirmngr: Make --use-tor work - still leaks DNS.
	* dirmngr/dirmngr.c (set_tor_mode): New.
	(main, reread_configuration): Call it.
	* dirmngr/http.c (http_raw_connect, send_request): Check whether TOR
	mode is enabled if the FORCE_TOR flag is given.

	dirmngr: Use Assuan socket wrappers for http.c.
	* dirmngr/http.c: Include assuan.h.  Changed all code taking a socket
	descriptor from int to assuan_fd_t.
	(my_unprotect, my_protect): New.
	(my_connect): Remove.
	(_my_socket_new, _my_socket_unref): use assuan_sock_close.
	(connect_server): Use assuan_sock_connect, assuan_sock_new, and
	assuan_sock_close.
	* dirmngr/Makefile.am (t_common_ldadd): Add LIBASSUAN_LIBS.

2015-10-19  Neal H. Walfield  <neal@g10code.com>

	gpg: Fix formatting.
	* g10/tofu.c (get_trust): Fix formatting.

	gpg: Don't forget to free some memory.
	* g10/tofu.c (tofu_register): Free SIG_DIGEST before returning.

	gpg: If a conflict occurs in batch mode, record that.
	* g10/tofu.c (get_trust): If a conflict occurs when MAY_ASK is false,
	set conflict to the key.  When prompting the user, don't show the
	conflicting key if the conflicting key is the current key.

2015-10-18  Werner Koch  <wk@gnupg.org>

	gpg: Silence two more warnings.
	* g10/trustdb.c (tdb_get_validity_core): Silence a warning.
	* g10/tofu.c (tofu_register): Move SIG_DIGEST computation to the top
	so that it is not uninitialized in case of an early error.

	gpg: Fix harmless compiler warnings.
	* g10/tofu.h (_tofu_GET_POLICY_ERROR): New.  This avoids warnings
	about undefined enum values in a switch.
	* g10/trustdb.h (_tofu_GET_TRUST_ERROR): New.
	* g10/tofu.c (TIME_AGO_FUTURE_IGNORE): Move to the top.
	(opendbs): Avoid compiler warning (use braces).
	(GET_POLICY_ERROR): Replace define by enum _tofu_GET_POLICY_ERROR.
	(get_policy): Remove assert.
	(GET_TRUST_ERROR): Replace by _tofu_GET_TRUST_ERROR macro.
	(show_statistics): Undef MIN_SECS et al. after use.

	common: Avoid warning about const char ** assignment.
	* common/mkdir_p.c (gnupg_amkdir_p): Also strdup first item.  Return
	an error on malloc failure.
	(gnupg_mkdir_p): Fix type of dirs and tmp_dirs.

	Move http module from common/ to dirmngr/.
	* common/http.c: Move to ../dirmngr/.
	* common/http.h: Move to ../dirmngr/.
	* common/t-http.c: Move to ../dirmngr/.
	* common/tls-ca.pem: Move to ../dirmngr/.
	* common/Makefile.am: Do not build libcommontls.a libcommontlsnpth.a.
	Remove http.c related stuff.
	* po/POTFILES.in: Move http.c to dirmngr/.
	* dirmngr/Makefile.am (EXTRA_DIST): Add tls-ca.pem.
	(module_maint_tests): New.
	(noinst_PROGRAMS): Add module_maint_tests.
	(dirmngr_SOURCES): Add http.c and http.h.
	(dirmngr_LDADD): Remove libcommontlsnpth.
	(t_common_ldadd): Ditto.
	(t_http_SOURCES, t_http_CFLAGS, t_http_LDADD): New.
	(t_ldap_parse_uri_SOURCES): Add http.c.
	(t_ldap_parse_uri_CFLAGS): Build without npth.
	($(PROGRAMS)): Do not require libcommontls.a libcommontlsnpth.a.
	* dirmngr/dirmngr.h, dirmngr/ks-engine.h: Fix include of http.h.

2015-10-18  Neal H. Walfield  <neal@g10code.com>

	g10: Fix assert.
	* g10/tofu.c (get_trust): Fix assert.

	g10: Add TOFU support.
	* configure.ac: Check for sqlite3.
	(SQLITE3_CFLAGS): AC_SUBST it.
	(SQLITE3_LIBS): Likewise.
	* g10/Makefile.am (AM_CFLAGS): Add $(SQLITE3_CFLAGS).
	(gpg2_SOURCES): Add tofu.h and tofu.c.
	(gpg2_LDADD): Add $(SQLITE3_LIBS).
	* g10/tofu.c: New file.
	* g10/tofu.h: New file.
	* g10/options.h (trust_model): Define TM_TOFU and TM_TOFU_PGP.
	(tofu_db_format): Define.
	* g10/packet.h (PKT_signature): Add fields digest and digest_len.
	* g10/gpg.c: Include "tofu.h".
	(cmd_and_opt_values): Declare aTOFUPolicy, oTOFUDefaultPolicy,
	oTOFUDBFormat.
	(opts): Add them.
	(parse_trust_model): Recognize the tofu and tofu+pgp trust models.
	(parse_tofu_policy): New function.
	(parse_tofu_db_format): New function.
	(main): Initialize opt.tofu_default_policy and opt.tofu_db_format.
	Handle aTOFUPolicy, oTOFUDefaultPolicy and oTOFUDBFormat.
	* g10/mainproc.c (do_check_sig): If the signature is good, copy the
	hash to SIG->DIGEST and set SIG->DIGEST_LEN appropriately.
	* g10/trustdb.h (get_validity): Add arguments sig and may_ask.  Update
	callers.
	(tdb_get_validity_core): Add arguments sig and may_ask.  Update
	callers.
	* g10/trust.c (get_validity) Add arguments sig and may_ask.  Pass them
	to tdb_get_validity_core.
	* g10/trustdb.c: Include "tofu.h".
	(trust_model_string): Handle TM_TOFU and TM_TOFU_PGP.
	(tdb_get_validity_core): Add arguments sig and may_ask.  If
	OPT.TRUST_MODEL is TM_TOFU or TM_TOFU_PGP, compute the TOFU trust
	level.  Combine it with the computed PGP trust level, if appropriate.
	* g10/keyedit.c: Include "tofu.h".
	(show_key_with_all_names_colon): If the trust mode is tofu or
	tofu+pgp, then show the trust policy.
	* g10/keylist.c: Include "tofu.h".
	(public_key_list): Also show the PGP stats if the trust model is
	TM_TOFU_PGP.
	(list_keyblock_colon): If the trust mode is tofu or
	tofu+pgp, then show the trust policy.
	* g10/pkclist.c: Include "tofu.h".
	* g10/gpgv.c (get_validity): Add arguments sig and may_ask.
	(enum tofu_policy): Define.
	(tofu_get_policy): New stub.
	(tofu_policy_str): Likewise.
	* g10/test-stubs.c (get_validity): Add arguments sig and may_ask.
	(enum tofu_policy): Define.
	(tofu_get_policy): New stub.
	(tofu_policy_str): Likewise.
	* doc/DETAILS: Describe the TOFU Policy field.
	* doc/gpg.texi: Document --tofu-set-policy, --trust-model=tofu,
	--trust-model=tofu+pgp, --tofu-default-policy and --tofu-db-format.
	* tests/openpgp/Makefile.am (TESTS): Add tofu.test.
	(TEST_FILES): Add tofu-keys.asc, tofu-keys-secret.asc,
	tofu-2183839A-1.txt, tofu-BC15C85A-1.txt and tofu-EE37CF96-1.txt.
	(CLEANFILES): Add tofu.db.
	(clean-local): Add tofu.d.
	* tests/openpgp/tofu.test: New file.
	* tests/openpgp/tofu-2183839A-1.txt: New file.
	* tests/openpgp/tofu-BC15C85A-1.txt: New file.
	* tests/openpgp/tofu-EE37CF96-1.txt: New file.
	* tests/openpgp/tofu-keys.asc: New file.
	* tests/openpgp/tofu-keys-secret.asc: New file.

2015-10-16  Neal H. Walfield  <neal@g10code.com>

	common: Prefix the mkdir functions with gnupg_.  Make args const.
	* common/mkdir_p.h (mkdir_p): Rename from this...
	(gnupg_mkdir_p): ... to this.  Change directory_component's type from
	char * to const char *.
	(amkdir_p): Rename from this...
	(gnupg_amkdir_p): ... to this.  Change directory_component's type from
	char * to const char *.
	* common/mkdir_p.c (mkdir_p): Rename from this...
	(gnupg_mkdir_p): ... to this.  Change directory_component's type from
	char * to const char *.
	(amkdir_p): Rename from this...
	(gnupg_amkdir_p): ... to this.  Change directory_component's type from
	char * to const char *.

2015-10-14  NIIBE Yutaka  <gniibe@fsij.org>

	cleanup: Fix confusion between gpg_error_t and gpg_err_code_t.
	* dirmngr/crlcache.c (hash_dbfile): Use gpg_error_t for ERR.
	* kbx/keybox-update.c (keybox_set_flags): Call
	gpg_err_code_from_syserror.

2015-10-13  NIIBE Yutaka  <gniibe@fsij.org>

	po: Update Japanese translation.

2015-10-12  Werner Koch  <wk@gnupg.org>

	gpg: Try hard to use MDC also for sign+symenc.
	* g10/encrypt.c (use_mdc): Make it a global func.
	* g10/sign.c (sign_symencrypt_file): Use that function to decide
	whether to use an MDC.
	* tests/openpgp/conventional-mdc.test: Add a simple test case.

2015-10-09  Werner Koch  <wk@gnupg.org>

	Release 2.1.9.

2015-10-09  NIIBE Yutaka  <gniibe@fsij.org>

	agent: simplify agent_get_passphrase.
	* agent/call-pinentry.c (agent_get_passphrase): Simplify.

	agent: fix agent_askpin.
	* agent/call-pinentry.c (agent_askpin): Fix off-by-one error.

	agent: Fix function return type for check_cb and agent_askpin.
	* agent/call-pinentry.c (unlock_pinentry): Return gpg_error_t.
	(start_pinentry, setup_qualitybar): Likewise.
	(agent_askpin): Fix return value check of check_cb.
	* agent/command-ssh.c (reenter_compare_cb): Return gpg_error_t.
	(ssh_identity_register): Fix return value check of agent_askpin.
	* agent/cvt-openpgp.c (try_do_unprotect_cb): Return gpg_error_t.
	* agent/findkey.c (try_unprotect_cb): Likewise.
	* agent/genkey.c (reenter_compare_cb): Return gpg_error_t.
	(agent_ask_new_passphrase): Fix return value check of agent_askpin.

2015-10-08  Andre Heinecke  <aheinecke@intevation.de>

	dirmngr: Default to http protocol for http-proxy.
	* common/http.c (send_request): Fix handling for hostname:port string.

2015-10-08  Werner Koch  <wk@gnupg.org>

	common: Allow building of mkdir_p.c for Windows.
	* common/mkdir_p.c: Change license and comment debug statements.
	(amkdir_p, mkdir_p): Fail on malloc error and use default_errsource to
	build an error code.  Change return value to gpg_error_t.
	(amkdir_p): Use gnupg_mkdir.

	* common/membuf.c: Include util.h first to avoid redefined macro
	warnings.

	gpg: Add option --print-dane-records.
	* g10/options.h (opt): Add field "print_dane_records".
	* g10/gpg.c (oPrintDANERecords): new.
	(opts): Add --print-dane-records.
	(main): Set that option.
	* g10/export.c (do_export): Remove EXPORT_DANE_FORMAT handling.
	(do_export_stream): Add EXPORT_DANE_FORMAT handling.
	* g10/keylist.c (list_keyblock_pka): Implement DANE record printing.

	* g10/gpgv.c (export_pubkey_buffer): New stub.
	* g10/test-stubs.c (export_pubkey_buffer): New stub.

	gpg: Pass CTRL parameter to all key listing functions.
	* g10/keylist.c (public_key_list): Add arg CTRL.
	(secret_key_list): Ditto.
	(list_all, list_one): Ditto.
	(locate_one): Ditto.
	(list_keyblock_pka): Ditto.
	(list_keyblock): Ditto.
	(list_keyblock_direct): Ditto.
	* g10/keygen.c (proc_parameter_file): Add arg CTRL.
	(read_parameter_file): Ditto.
	(quick_generate_keypair): Ditto.
	(do_generate_keypair): Ditto.
	(generate_keypair): Pass arg CTRL.
	* g10/gpg.c (main): Pass arg CTRL to quick_generate_keypair.

2015-10-07  Werner Koch  <wk@gnupg.org>

	gpg: Remove unfinished experimental code to export as S-expressions.
	* g10/options.h (EXPORT_SEXP_FORMAT): Remove.
	(EXPORT_DANE_FORMAT): New.
	* g10/export.c (parse_export_options): Remove "export-sexp-format".
	(export_seckeys): Adjust for removed option.
	(export_secsubkeys): Ditto.
	(do_export): Prepare for DANE format.
	(build_sexp, build_sexp_seckey): Remove.
	(do_export_stream): Remove use of removed functions.

2015-10-06  Werner Koch  <wk@gnupg.org>

	gpg: Add new --auto-key-locate mechanism "dane".
	* g10/call-dirmngr.c (gpg_dirmngr_dns_cert): Allow fetching via DANE.
	* g10/keyserver.c (keyserver_import_cert): Add arg "dane_mode".
	* g10/options.h (AKL_DANE): New.
	* g10/getkey.c (get_pubkey_byname): Implement AKL_DANE.
	(parse_auto_key_locate): Ditto.

	dirmngr: Addlow fetching keys using OpenPGP DANE.
	* dirmngr/server.c (cmd_dns_cert): Add option --dane.

	dirmngr: Improve DNS code to retrieve arbitrary records.
	* dirmngr/dns-cert.c (get_dns_cert): Add hack to retrieve arbitrary
	resource records.
	* dirmngr/dns-cert.h (DNS_CERTTYPE_RRBASE): New.
	(DNS_CERTTYPE_RR61): New.

	dirmngr: Change DNS code to make additions easier.
	* dirmngr/dns-cert.c (get_dns_cert) [!USE_ADNS]: Change loop to allow
	adding more resource types.

	dirmngr: Make commands RELOADDIRMNGR and KILLDIRMNGR work properly.
	* dirmngr/server.c (cmd_killdirmngr): Set assuan close flag.
	(cmd_reloaddirmngr): Use check_owner_permission.

	dirmngr: Do tilde expansion for --hkp-cacert.
	* dirmngr/dirmngr.c (parse_rereadable_options): Do tilde expansion and
	check for cert file existance in option --hkp-cacert.

	gpg: Fail decryption for AES etc message w/o MDC.
	* g10/mainproc.c (proc_encrypted): Fail for modern messages w/o MDC.

2015-10-06  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Fix verification of signature for smartcard.
	* agent/pksign.c (agent_pksign_do): Use public key smartcard.

	agent: Fix non-allocation for pinentry_loopback.
	* agent/call-pinentry.c (agent_get_passphrase): Don't allocate, it will
	be allocated by pinentry_loopback.

2015-10-05  Werner Koch  <wk@gnupg.org>

	gpg: Install a dirmngr.conf file.
	* g10/dirmngr-conf.skel: New.
	* g10/Makefile.am (EXTRA_DIST): Add file.
	(install-data-local, uninstall-local): Install that file.
	* g10/openfile.c (copy_options_file): Add arg "name", return a value,
	simplify with xstrconcat, and factor warning message out to:
	(try_make_homedir): here.  Also install dirmngr.conf.
	* g10/options.skel: Remove --keyserver entry.

	gpg: Deprecate the --keyserver option.
	* g10/keyserver.c (keyserver_refresh): Change return type to
	gpg_error_t.  Use gpg_dirmngr_ks_list to print the name of the
	keyserver to use.
	(keyserver_search): Do not print the "no keyserver" error
	message.  The same error is anyway returned from dirmngr.
	* g10/call-dirmngr.c (ks_status_parm_s): Add field "keyword".
	(ks_status_cb): Handle other status keywords.
	(gpg_dirmngr_ks_list): New.
	* tools/gpgconf-comp.c (gc_options_gpg): Deprecate "keyserver".
	(gc_options_dirmngr): Add "Keyserver" group and "keyserver".

	dirmngr: Add option --keyserver.
	* dirmngr/dirmngr.c (oKeyServer): New.
	(opts): Add "keyserver".
	(parse_rereadable_options): Parse that options
	(main): Add option to the gpgconf list.
	* dirmngr/dirmngr.h (opt): Add field "keyserver".
	* dirmngr/server.c (ensure_keyserver): New.
	(make_keyserver_item): New.  Factored out from
	(cmd_keyserver): here.  Call ensure_keyserver.
	(cmd_ks_search): Call ensure_keyserver.
	(cmd_ks_get): Ditto.
	(cmd_ks_fetch): Ditto.
	(cmd_ks_put): Ditto.

	dirmngr: Make clear that --use-tor is not yet ready for use.
	* dirmngr/dirmngr.c (main): Print a warning if --use-tor has been
	given.
	* tools/gpgconf-comp.c (gc_options_dirmngr): Make --use-tor invisible.

	gpgconf: Change displayed name of Dirmngr to "Key Acquirer".
	* tools/gpgconf-comp.c (gc_component): Change printed name.

2015-10-02  Werner Koch  <wk@gnupg.org>

	dirmngr: Fix use-after-free due to a realloc shrinking.
	* dirmngr/ks-engine-hkp.c (map_host): Do not use original pointer
	after realloc.

	agent: Fix alignment problem with the second passphrase struct.
	* agent/genkey.c (agent_ask_new_passphrase): Use a separate malloc for
	PI2.  Check return value of the malloc function.
	* agent/command-ssh.c (ssh_identity_register): Use a separate malloc
	for PI2.  Wipe PI2.

2015-10-01  Werner Koch  <wk@gnupg.org>

	gpg: Fix a practical hang after use of --faked-system-time.
	* g10/sign.c (update_keysig_packet): Bail out if we would need to long
	for a new timestamp.

	gpg: Print more info with "check selfsig".
	* g10/keyedit.c (print_and_check_one_sig): Print more Some sigsub
	packets.

	gpg: Add debug helper to --edit-keys's check sub-command.
	* g10/keyedit.c (print_and_check_one_sig): Add arg "extended" and
	print an asterisk for the chosen selfsig.
	(check_all_keysigs): Add arg "only_selfsig"
	(keyedit_menu) <cmdCHECK>: Add optional arg "selfsig".

2015-10-01  NIIBE Yutaka  <gniibe@fsij.org>

	common: Fix strsplit.
	* common/stringhelp.c (strsplit): Fix arguments order.

2015-09-30  Neal H. Walfield  <neal@g10code.com>

	common: Add mkdir_p.
	* common/mkdir_p.c: New file.
	* common/mkdir_p.h: New file.
	* common/Makefile.am (common_sources): Add mkdir_p.c and mkdir_p.h.

	common: Remove unused files.
	* common/xmalloc.c: Remove file.
	* common/xmalloc.h: Remove file.

	common: Include <gpg-error.h>.
	* common/logging.h: Include <gpg-error.h>.

2015-09-29  Neal H. Walfield  <neal@g10code.com>

	g10: Remove unused struct cmp_help_context_s.
	* g10/sig-check.c (struct cmp_help_context_s) Remove unused struct.

	g10: Avoid an unnecessary copy.
	* g10/sig-check.c (signature_check2): Avoid copying PK to RET_PK.
	Instead, directly use the provided storage.  If none is provided
	allocate some.

2015-09-29  NIIBE Yutaka  <gniibe@fsij.org>

	ssh: Fix fingerprint computation for EdDSA key.
	* common/ssh-utils.c (get_fingerprint): Handle the prefix of 0x40.
	* common/t-ssh-utils.c (sample_keys): Add a new key.

	agent: RSA signature verification by gpg-agent.
	* g10/sign.c (do_sign): Let verify signature by gpg-agent.
	* agent/pksign.c (agent_pksign_do): Call gcry_pk_verify for RSA.

2015-09-28  Werner Koch  <wk@gnupg.org>

	common: Provide two new error code replacements.
	* common/util.h (GPG_ERR_FALSE, GPG_ERR_TRUE): Rew replcements.

	common: Change calling convention for gnupg_spawn_process.
	* common/exechelp.h (GNUPG_SPAWN_NONBLOCK): New.
	(GNUPG_SPAWN_RUN_ASFW, GNUPG_SPAWN_DETACHED): Macro to replace the
	numbers.
	* common/exechelp.h (gnupg_spawn_process): Change function to not take
	an optional stream for stdin but to return one.
	* common/exechelp-posix.c (gnupg_spawn_process): Implement change.
	(create_pipe_and_estream): Add args outbound and nonblock.
	* common/exechelp-w32.c (gnupg_spawn_process): Implement change.

2015-09-28  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Handle error correctly.
	* scd/apdu.c (apdu_connect): Initialize variables and check an error
	of apdu_get_status_internal.

2015-09-22  Werner Koch  <wk@gnupg.org>

	ssh: Add 256, 384 and 521 bit test keys for the fingerprint.
	* common/t-ssh-utils.c (sample_keys): Add 3 new keys.

	ssh: Fix fingerprint computation for 384 bit ECDSA keys.
	* common/ssh-utils.c (get_fingerprint): Fix hashed string.

2015-09-19  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Fix importing ECC key.
	* agent/cvt-openpgp.c (convert_from_openpgp_main): Only encrypted
	parameters are stored as opaque.
	(apply_protection): ARRAY members are all normal, non-opaque MPI.
	(extract_private_key): Get public key as normal, non-opaque MPI.
	Remove support of ECC key with '(flags param)'.
	Remove support of "ecdsa" and "ecdh" keys of our experiment.

	scd: Fix KEYTOCARD handling for ECC key.
	* scd/app-openpgp.c (ecc_writekey): Only public key can be native
	format.

2015-09-19  Neal H. Walfield  <neal@g10code.com>

	common: Add new function strlist_length.
	* common/strlist.c (strlist_length): New function.

2015-09-18  Werner Koch  <wk@gnupg.org>

	gpgconf: Change displayed name of Dirmngr to "Network Manager".
	* tools/gpgconf-comp.c (gc_component): Change printed name.

	dirmngr: Add option --use-tor as a stub.
	* dirmngr/dirmngr.h (opt): Add field "use_tor".
	* dirmngr/dirmngr.c (oUseTor): New.
	(opts): Add --use-tor.
	(parse_rereadable_options): Set option.
	(main): Tell gpgconf about that option.

	* dirmngr/crlfetch.c (crl_fetch): Pass TOR flag to the http module and
	return an error if LDAP is used in TOR mode.
	(ca_cert_fetch): Return an error in TOR mode.
	(start_cert_fetch): Ditto.
	* dirmngr/ks-engine-finger.c (ks_finger_fetch): Pass TOR flag to the
	http module.
	* dirmngr/ks-engine-hkp.c (send_request): Ditto.
	* dirmngr/ks-engine-http.c (ks_http_fetch): Ditto.
	* dirmngr/ks-engine-ldap.c (ks_ldap_get): Return an error in TOR mode.
	(ks_ldap_search): Ditto.
	(ks_ldap_put): Ditto.
	* dirmngr/ocsp.c (do_ocsp_request): Ditto.  Also pass TOR flag to the
	http module.

	* dirmngr/server.c (option_handler): Add "honor-keyserver-url-used".
	(cmd_dns_cert): Return an error in TOR mode.
	(cmd_getinfo): Add subcommand "tor"
	* tools/gpgconf-comp.c (gc_options_dirmngr): Add TOR group.

	gpg: Report a conflict between honor-keyserver-url and TOR.
	* g10/call-dirmngr.c (create_context): Send option and print a verbose
	error.

	http: Add flag to force use of TOR (part 1)
	* common/http.h (HTTP_FLAG_FORCE_TOR): New.
	* common/http.c (http_raw_connect, send_request): Detect flag and
	return an error for now.

2015-09-17  NIIBE Yutaka  <gniibe@fsij.org>

	po: Update Japanese translation.

	scd: Fix ccid-driver timeout for OpenPGPcard v2.1.
	* scd/ccid-driver.c (CCID_CMD_TIMEOUT): New.
	(ccid_transceive_apdu_level, ccid_transceive): Use.

2015-09-16  Werner Koch  <wk@gnupg.org>

	agent: New option --pinentry-invisible-char.
	* agent/gpg-agent.c (oPinentryInvisibleChar): New.
	(opts): Add option.
	(parse_rereadable_options): Set option.
	* agent/agent.h (opt): Add field pinentry_invisible_char.
	* agent/call-pinentry.c (start_pinentry): Pass option to pinentry.

	g13: Move some code to a separate module.
	* g13/g13-common.c, g13/g13-common.h: New.
	* g13/Makefile.am (g13_SOURCES): Add new files.
	* g13/g13.c (g13_errors_seen): Move to g13-common.c.
	(cmdline_conttype): New.
	(main): Use g13_init_signals and g13_install_emergency_cleanup.
	(emergency_cleanup, g13_exit): Move to g13-common.c.
	* g13/g13.h: Move OPT and some other code to g13-common.h.

	gpg: Fix skip function dummy parameter.
	* g10/trustdb.c (search_skipfnc): Fix dummy argument

	gpg: Change last commit to avoid extra translations.
	* g10/keyedit.c (keyedit_menu): Do not print usage hints in expert
	mode.

2015-09-16  Neal H. Walfield  <neal@g10code.com>

	g10: Improve error message.
	* g10/keyedit.c (keyedit_menu): When complaining that a user ID or key
	must be selected, indicate what command to use to do this.

	g10: Be more careful when merging self-signed data.
	* g10/getkey.c (merge_selfsigs_main): Stop looking for self-signed
	data belonging to the public key when we encounter an attribute packet
	or a subkey packet, not just a user id packet.  When looking for
	self-signed data belonging to a user id packet, stop when we see a
	user attribute packet.

	g10: Simplify some complicated boolean expressions.
	* g10/getkey.c (finish_lookup): Simplify logic.

	g10: Also mark revoked and expired keys as unusable.
	* g10/getkey.c (skip_unusable): Also mark the key as unusable if it
	has been revoked or has expired.

	g10: Release resources when returning an error in get_seckey.
	* g10/getkey.c (get_seckey): If the key doesn't have a secret key,
	release *PK.

	g10: Improve documentation and comments for getkey.c.
	* g10/getkey.c: Improve documentation and comments for most
	functions.  Move documentation for public functions from here...
	* g10/keydb.h: ... to here.

	g10: Remove unused function have_any_secret_key.
	* g10/getkey.c (have_any_secret_key): Remove function.

	g10: Bring cache semantics closer to non-cache semantics.
	* g10/getkey.c (get_pubkey_fast): When reading from the cache, only
	consider primary keys.

	g10: Break out of the loop earlier.
	* g10/getkey.c (have_secret_key_with_kid): Once we find the relevent
	key or subkey, stop searching.

	g10: Don't skip legacy keys if the search mode is KEYDB_SEARCH_MODE_NEXT
	* g10/getkey.c (lookup): Also don't skip legacy keys if the search
	mode is KEYDB_SEARCH_MODE_NEXT.

	g10: Remove unused function get_seckeyblock_byfprint.
	* g10/keydb.h (get_seckeyblock_byfprint): Remove prototype.
	* g10/getkey.c (get_seckeyblock_byfprint): Remove function.

	g10: Remove unused function get_seckey_byfprint.
	* g10/keydb.h (get_seckey_byfprint): Remove prototype.
	* g10/getkey.c (get_seckey_byfprint): Remove function.

	g10: Simplify get_seckey_byname: it was never called with NAME not NULL.
	* g10/keydb.h (get_seckey_byname): Rename from this...
	(get_seckey_default): ... to this.  Drop the parameter name.  Update
	users.
	* g10/getkey.c (get_seckey_byname): Rename from this...
	(get_seckey_default): ... to this.  Drop the parameter name.  Drop the
	code which assumed that NAME is not NULL.

	g10: Eliminate the redundant function get_keyblock_byfprint.
	* g10/keydb.h (get_keyblock_byfprint): Remove prototype.  Replace use
	of this function with get_pubkey_byfprint.
	* g10/getkey.c (get_pubkey_byname): Remove function.

	g10: Simplify semantics of get_pubkey_byname.
	* g10/getkey.c (get_pubkey_byname): If R_KEYBLOCK is not NULL, return
	the keyblock in R_KEYBLOCK independent of whether PK is set or not.

	g10: Eliminate the redundant function get_pubkey_byname.
	* g10/getkey.c (get_pubkey_byname): Remove function.
	(lookup): Replace use of get_pubkey_byname by get_pubkey_byfprint.

	g10: Eliminate the redundant function get_pubkey_end.
	* g10/keydb.h (get_pubkey_end): Remove declaration.  Replace use of
	function with getkey_end.
	* g10/getkey.c (get_pubkey_byname): Remove function.

	g10: Eliminate the redundant function get_pubkey_next.
	* g10/keydb.h (get_pubkey_next): Remove prototype.
	* g10/getkey.c (get_pubkey_next): Remove function.
	* g10/keylist.c (locate_one): Use getkey_next instead of
	get_pubkey_next.

	kbx: Change skipfnc's prototype so that we can provide all information.
	* kbx/keybox-search-desc.h (struct keydb_search_desc.skipfnc): Change
	third parameter to be the index of the user id packet in the keyblock
	rather than the packet itself.  Update users.

	g10: Remove unused prototype (get_pubkey_byfpr).
	* g10/keydb.h (get_pubkey_byfpr): Remove unused prototype.

	g10: Remove unused function (get_pubkey_bynames).
	* g10/keydb.h (get_pubkey_bynames): Remove prototype.
	* g10/getkey.c (get_pubkey_bynames): Remove function.

	g10: Simplify code.  Turn struct getkey_ctx_s.found_key into an argument
	* g10/getkey.c (struct getkey_ctx_s): Remove field found_key.
	(lookup): Add argument ret_found_key.  If not NULL, set it to the
	found key.  Update callers.
	(pk_from_block): Add argument found_key.  Use it instead of
	CTX->FOUND_KEY.  Update callers.
	(finish_lookup): Return a KBNODE (the found key) instead of an int.
	Don't set CTX->FOUND_KEY.  Return the found key instead.

	g10: Remove unused field struct getkey_ctx_s.kbpos.
	* g10/getkey.c (struct getkey_ctx_s): Remove field kbpos.
	(getkey_end): Don't clear CTX->KBPOS.

	g10: Simplify code: remove field struct getkey_ctx_s.keyblock.
	* g10/getkey.c (struct getkey_ctx_s): Remove field keyblock.
	(finish_lookup): Add parameter keyblock.  Update caller to pass this.
	(lookup): Add new local variable keyblock.  Use this instead of
	ctx->keyblock for referencing the keyblock.

2015-09-16  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Fix registering SSH Key of Ed25519.
	* agent/command-ssh.c (stream_read_string): Add the prefix of 0x40.

2015-09-15  NIIBE Yutaka  <gniibe@fsij.org>

	po: Update Japanese translation.

2015-09-10  Werner Koch  <wk@gnupg.org>

	Release 2.1.8.

	tests: Silence the 5gb-packet test.
	* tests/openpgp/4gb-packet.test: Send output to /dev/null.

	g10: Fix make distcheck problem.
	* g10/test.c: Include string.h.
	(prepend_srcdir): New.  Taken from Libgcrypt.
	(test_free): New.
	* g10/t-keydb.c (do_test): Malloc the filename.
	* g10/Makefile.am (AM_CPPFLAGS): Remove -DSOURCE_DIR
	(EXTRA_DIST): Add t-keydb-keyring.kbx.

	g10: Improve portability of the new test driver.
	* g10/test.c: Include stdio.h and stdlib.h.
	(verbose): New.
	(print_results): Rename to exit_tests.
	(main): Remove atexit and call exit_tests.  Set verbose.
	(ASSERT, ABORT): Call exit_tests instead of exit.

2015-09-09  Werner Koch  <wk@gnupg.org>

	dirmngr: Allow sending much larger keyblocks.
	* dirmngr/server.c (MAX_CERT_LENGTH): Increase to 16k.
	(MAX_KEYBLOCK_LENGTH): Increase to 20M.

2015-09-07  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Force key attribute change for writekey.
	* scd/app-openpgp.c (change_rsa_keyattr): New.
	(change_keyattr_from_string): Use change_rsa_keyattr.
	(rsa_writekey): Call change_rsa_keyattr when different size.
	(ecc_writekey): Try to change key attribute.

	scd: KEYNO cleanup.
	* scd/app-openpgp.c (get_public_key, send_keypair_info, do_readkey)
	(change_keyattr, change_keyattr_from_string, ecc_writekey, do_genkey)
	(compare_fingerprint, check_against_given_fingerprint): KEYNO starts
	from 0.

2015-09-02  Neal H. Walfield  <neal@g10code.com>

	g10: Remove unused field req_algo.
	* g10/packet.h (PKT_public_key): Remove unused field req_algo.  Remove
	users.
	* g10/getkey.c (struct getkey_ctx_s): Remove unused field req_algo.
	Remove users.

	g10: Use a symbolic constant instead of a literal.
	* g10/trustdb.c (KEY_HASH_TABLE_SIZE): Define.
	(new_key_hash_table): Use KEY_HASH_TABLE_SIZE instead of a literal.
	(release_key_hash_table): Likewise.
	(test_key_hash_table): Likewise.
	(add_key_hash_table): Likewise.

	g10: Add test for keydb as well as new testing infrastructure.
	* g10/Makefile.am (EXTRA_DIST): Add test.c.
	(AM_CPPFLAGS): Add -DSOURCE_DIR="\"$(srcdir)\"".
	(module_tests): Add t-keydb.
	(t_keydb_SOURCES): New variable.
	(t_keydb_LDADD): Likewise.
	* g10/t-keydb.c: New file.
	* g10/t-keydb-keyring.kbx: New file.
	* g10/test-stubs.c: New file.
	* g10/test.c: New file.

	g10: Make the keyblock cache per-handle rather than global.
	* g10/keydb.c (keyblock_cache): Don't declare this variable.  Instead...
	(struct keyblock_cache): ... turn its type into this first class
	object...
	(struct keydb_handle): ... and instantiate it once per database
	handle.  Update all users.
	(keydb_rebuild_caches): Don't invalidate the keyblock cache.

	g10: If iobuf_seek fails when reading from the cache, do a hard read.
	* g10/keydb.c (keydb_get_keyblock): If the iobuf_seek fails when
	reading from the cache, then simply clear the cache and try reading
	from the database.

	iobuf: Reduce verbosity of test.
	* common/t-iobuf.c (main): Reduce verbosity.

	iobuf: Add the IOBUF_INPUT_TEMP type to improve input temp handling.
	* common/iobuf.h (enum iobuf_use): Add new member, IOBUF_INPUT_TEMP.
	* common/iobuf.c (iobuf_temp_with_content): Create the iobuf as an
	IOBUF_INPUT_TEMP, not an IOBUF_INPUT buffer.  Assert that LENGTH ==
	A->D.SIZE.
	(iobuf_push_filter2): If A is an IOBUF_INPUT_TEMP, then make the new
	filter an IOBUF_INPUT filter and set its buffer size to
	IOBUF_BUFFER_SIZE.
	(underflow): If A is an IOBUF_INPUT_TEMP, then just return EOF; don't
	remove already read data.
	(iobuf_seek): If A is an IOBUF_INPUT_TEMP, don't discard the buffered
	data.
	(iobuf_alloc): Allow USE == IOBUF_INPUT_TEMP.
	(pop_filter): Allow USE == IOBUF_INPUT_TEMP.
	(iobuf_peek): Allow USE == IOBUF_INPUT_TEMP.
	(iobuf_writebyte): Fail if USE == IOBUF_INPUT_TEMP.
	(iobuf_write): Fail if USE == IOBUF_INPUT_TEMP.
	(iobuf_writestr): Fail if USE == IOBUF_INPUT_TEMP.
	(iobuf_flush_temp): Fail if USE == IOBUF_INPUT_TEMP.

	iobuf: Rename IOBUF_TEMP to IOBUF_OUTPUT_TEMP.
	* common/iobuf.h (enum iobuf_use): Rename IOBUF_TEMP to
	IOBUF_OUTPUT_TEMP.  Update users.

	iobuf: Use a first-class enum.
	* common/iobuf.h (enum iobuf_use): Name the IOBUF_OUTPUT, etc. enum.
	(struct iobuf_struct): Change the field use's type to it.

	iobuf: Fix test.
	* common/t-iobuf.c (content_filter): If there is nothing to read,
	don't forget to set *LEN to 0.
	(main): Fix checks.

2015-09-01  Werner Koch  <wk@gnupg.org>

	agent: Protect commit 135b1e3 against misbehaving Libgcrypt.
	* agent/command-ssh.c (ssh_key_to_blob): Check DATALEN.

	gpg: Remove option --no-sig-create-check.
	* g10/gpg.c (opts): Remove --no-sig-create-check.
	* g10/options.h (struct opt): Remove field no_sig_create_check.
	* g10/sign.c (do_sign): Always check unless it is RSA and we are using
	Libgcrypt 1.7.

	common: Assume an utf-8 locale on iconv errors.
	* common/utf8conv.c (handle_iconv_error): Use utf-8 as fallback.

	common: Fix regression in building argpase.c standalone.
	* common/argparse.c (is_native_utf8) [GNUPG_MAJOR_VERSION]: New.

2015-08-31  Neal H. Walfield  <neal@g10code.com>

	g10: Don't leak memory if we fail to initialize a new database handle.
	* g10/keydb.c (keydb_new): If we fail to open a keyring or keybox
	correctly release all resources.

	g10: Improve interface documentation of the keydb API.
	* g10/keydb.c: Improve code comments and documentation of internal
	interfaces.  Improve documentation of public APIs and move that to...
	* g10/keydb.h: ... this file.

	g10: Don't cache search results if the search didn't scan the whole DB.
	* g10/keydb.c (struct keydb_handle): Add new field is_reset.
	(keydb_new): Initialize hd->is_reset to 1.
	(keydb_locate_writable): Set hd->is_reset to 1.
	(keydb_search): Set hd->is_reset to 0.  Don't cache a key not found if
	the search started from the beginning of the database.

	g10: Have keydb_search_first call keydb_search_reset before searching.
	* g10/keydb.c (keydb_search_first): Reset the handle before starting
	the search.

	g10: Remove unused parameter.
	* g10/keydb.h (keydb_locate_writable): Remove unused parameter
	reserved.  Update users.

2015-08-31  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Fix SSH public key for EdDSA.
	* agent/command-ssh.c (ssh_key_to_blob): Remove the prefix 0x40.

2015-08-26  Neal H. Walfield  <neal@g10code.com>

	g10: Simplify cache.  Only include data that is actually used.
	* g10/keydb.c (struct kid_list_s): Rename from this...
	(struct kid_not_found_cache_bucket): ... to this.  Update users.
	Remove field state.
	(kid_list_t): Remove type.
	(KID_NOT_FOUND_CACHE_BUCKETS): Define.  Use this instead of a literal.
	(kid_found_table): Rename from this...
	(kid_not_found_cache_bucket): ... to this.  Update users.
	(kid_found_table_count): Rename from this...
	(kid_not_found_cache_count): ... to this.  Update users.
	(kid_not_found_p): Only return whether a key with the specified key id
	is definitely not in the database.
	(kid_not_found_insert): Remove parameter found.  Update callers.
	(keydb_search): Only insert a key id in the not found cache if it is
	not found.  Rename local variable once_found to already_in_cache.

2015-08-25  Werner Koch  <wk@gnupg.org>

	Add configure option --enable-build-timestamp.
	* configure.ac (BUILD_TIMESTAMP): Set to "<none>" by default.

	gpg: Emit ERROR status for key signing failures.
	* g10/keyedit.c (sign_uids): Write an ERROR status for a signing
	failure.
	(menu_adduid, menu_addrevoker, menu_revsig): Ditto.
	(menu_revuid, menu_revkey, menu_revsubkey): Ditto.

	gpg: Print a new FAILURE status after most commands.
	* common/status.h (STATUS_FAILURE): New.
	* g10/cpr.c (write_status_failure): New.
	* g10/gpg.c (main): Call write_status_failure for all commands which
	print an error message here.
	* g10/call-agent.c (start_agent): Print an STATUS_ERROR if we can't
	set the pinentry mode.

2015-08-24  Neal H. Walfield  <neal@g10code.com>

	agent: Raise the maximum password length.  Don't hard code it.
	* agent/agent.h (MAX_PASSPHRASE_LEN): Define.
	* agent/command-ssh.c (ssh_identity_register): Use it instead of a
	hard-coded literal.
	* agent/cvt-openpgp.c (convert_from_openpgp_main): Likewise.
	* agent/findkey.c (unprotect): Likewise.
	* agent/genkey.c (agent_ask_new_passphrase): Likewise.

2015-08-24  Werner Koch  <wk@gnupg.org>

	sm: Support secret key export via the Assuan interface.
	* sm/server.c (cmd_export): Add options --secret, --raw, and --pkcs12.

2015-08-23  Werner Koch  <wk@gnupg.org>

	dirmngr: Allow sending of Zack's key.
	* dirmngr/server.c (MAX_KEYBLOCK_LENGTH): Increase to 1 MiB.

	gpg: Fix regression in packet parser from Aug 19.
	* g10/parse-packet.c (parse): Use an int to compare to -1.  Use
	buf32_to_ulong.

	gpg: Show not found keys with --locate-key --verbose.
	* g10/keylist.c (locate_one): Print a diagnostic for a not-found key.

2015-08-21  Neal H. Walfield  <neal@g10code.com>

	common: Don't incorrectly reject 4 GB - 1 sized packets.
	* g10/parse-packet.c (parse): Don't reject 4 GB - 1 sized packets.
	Add the constraint that the type must be 63.
	* kbx/keybox-openpgp.c (next_packet): Likewise.
	* tests/openpgp/4gb-packet.asc: New file.
	* tests/openpgp/4gb-packet.test: New file.
	* tests/openpgp/Makefile.am (TESTS): Add 4gb-packet.test.
	(TEST_FILES): Add 4gb-packet.asc.

	common: Don't assume on-disk layout matches in-memory layout.
	* g10/packet.h (PKT_signature): Change revkey's type from a struct
	revocation_key ** to a struct revocation_key *.  Update users.

	common: Don't incorrectly copy packets with partial lengths.
	* g10/parse-packet.c (parse): We don't handle copying packets with a
	partial body length to an output stream.  If this occurs, log an error
	and abort.

	common: Check parameters more rigorously.
	* g10/parse-packet.c (dbg_copy_all_packets): Check that OUT is not
	NULL.
	(copy_all_packets): Likewise.

	common: Don't continuing processing on error.
	* g10/parse-packet.c (dbg_parse_packet): Also return if parse returns
	an error.
	(parse_packet): Likewise.
	(dbg_search_packet): Likewise.
	(search_packet): Likewise.

	common: Better respect the packet's length when reading it.
	* g10/parse-packet.c (parse_signature): Make sure PKTLEN doesn't
	underflow.  Be more careful that a read doesn't read more data than
	PKTLEN says is available.

2015-08-20  Werner Koch  <wk@gnupg.org>

	po: Add lost translation of validity strings.
	* po/POTFILES.in (trust.c): Add missing file.
	* po/de.po: Changed German validity strings.
	* doc/help.de.txt: Ditto.

2015-08-20  Neal H. Walfield  <neal@g10code.com>

	g10/parse-packet.c:parse: Try harder to not ignore an EOF.
	* g10/parse-packet.c (parse): Be more robust: make sure to process any
	EOF.

	g10/parse-packet.c: Replace literal with symbolic expression.
	* g10/parse-packet.c (dump_hex_line): Use sizeof rather than the
	buffer's size.

	Add documentation for g10/parse-packet.c.
	* g10/packet.h: Add documentation for functions defined in
	parse-packet.c.
	* g10/parse-packet.c: Improve comments for many functions.

	g10/packet.h: Remove unused argument from enum_sig_subpkt.
	* g10/packet.h (enum_sig_subpkt): Remove argument RET_N.  Update
	callers.
	* g10/parse-packet.c (enum_sig_subpkt): Remove argument RET_N.

	g10/parse-packet.c:mpi_read: Detect EOF and correct boundary conditions.
	* g10/parse-packet.c (mpi_read): Improve documentation.  Correctly
	handle an EOF.  On overflow, correctly return the number of bytes read
	from the pipeline.

	common/iobuf.c: Make control flow more obvious.
	* common/iobuf.c (iobuf_read): Make control flow more obvious.
	(iobuf_get_filelength): Likewise.
	(iobuf_get_fd): Likewise.
	(iobuf_seek): Likewise.

	common/iobuf.c: Add some sanity checks to catch programmer bugs.
	* common/iobuf.c (iobuf_alloc): Check that BUFSIZE is not 0.
	(iobuf_readbyte): Check that A is an input filter.  Check that the
	amount of read data is at most the amount of buffered data.
	(iobuf_read): Check that A is an input filter.
	(iobuf_writebyte): Check that A is not an input filter.
	(iobuf_writestr): Check that A is not an input filter.
	(iobuf_flush_temp): Check that A is not an input filter.

	common/iobuf.c:iobuf_write_temp: Elide redundant code.
	* common/iobuf.c (iobuf_write_temp): Don't repeat iobuf_flush_temp.
	Use it directly.

	common/iobuf.c: Have iobuf_writestr use iobuf_write, not iobuf_writebyte
	* common/iobuf.c (iobuf_write): Don't write a byte at a time.  Use
	iobuf_write.

	common/iobuf: Improve documentation and code comments.
	common/iobuf.h: Improve documentation and code comments.
	common/iobuf.c: Likewise.

	common/iobuf.c: Adjust buffer size of filters in front of temp filters.
	* common/iobuf.c (iobuf_push_filter2): If the head filter is a temp
	filter, use IOBUF_BUFFER_SIZE for the new filter.

	common/iobuf.c: Buffered data should not be processed by new filters.
	* common/iobuf.c (iobuf_push_filter2): If the pipeline is an output or
	temp pipeline, the new filter shouldn't assume ownership of the old
	head's internal buffer: the data was written before the filter was
	added.
	* common/t-iobuf.c (double_filter): New function.
	(main): Add test cases for the above bug.

	common/iobuf.c: Flush the pipeline in iobuf_temp_to_buffer.
	* common/iobuf.c (iobuf_temp_to_buffer): Flush each filter in the
	pipeline and copy the data from the last (not the first) filter's
	internal buffer.

	common/iobuf.c: Combine iobuf_open, iobuf_create and iobuf_openrw.
	* common/iobuf.c (do_open): New function, which is a generalization of
	iobuf_open, iobuf_Create, iobuf_openrw.
	(iobuf_open): Call do_open.
	(iobuf_create): Likewise.
	(iobuf_openrw): Likewise.

	common/iobuf.h: Remove iobuf_open_fd_or_name.
	* common/iobuf.h (iobuf_open_fd_or_name): Remove prototype.  Replace
	use with either iobuf_open or iobuf_fdopen_nc, as appropriate.
	* common/iobuf.c (iobuf_open): Remove function.

	common/iobuf.c: Rename iobuf_flush and make it a static function.
	* common/iobuf.h (iobuf_flush): Remove prototype.
	* common/iobuf.c (filter_flush): New static prototype.
	(iobuf_flush): Rename...
	(filter_flush): ... to this.  Make static.  Simplify code.  Update
	callers.

	common/iobuf.c: Don't abort freeing a pipeline if freeing a filter fails
	* common/iobuf.c (iobuf_cancel): Don't abort freeing a pipeline if
	freeing a filter fails.  This needs to a memory leak.  Instead, keep
	freeing and return the error code of the first filter that fails.

	common/iobuf.c: Improve iobuf_peek.
	* common/iobuf.c (underflow): Take additional parameter
	clear_pending_eof.  If not set, don't clear a pending eof when
	returning EOF.  Update callers.
	(iobuf_peek): Fill the internal buffer, if needed, to be able to
	better satisfy any request.

	common/iobuf.c: When requested, fill the buffer even if it is not empty.
	* common/iobuf.c (underflow): Don't require that the buffer be empty.
	When called, fill any available space.

	common/t-iobuf.c: Add a test case for multiple EOFs.
	common/t-iobuf.c (main): Add a test case for multiple EOFs in an INPUT
	pipeline.

	common/iobuf.c: Better respect boundary conditions in iobuf_read_line.
	* common/iobuf.c (iobuf_read_line): Be more careful with boundary
	conditions.
	* common/iobuf.h: Include <gpg-error.h>.
	* common/t-iobuf.c: New file.
	* common/Makefile.am (module_tests): Add t-iobuf.
	(t_mbox_util_LDADD): New variable.

	common/iobuf.c: Fix filter type for iobuf_temp_with_content.
	* common/iobuf.c (iobuf_temp_with_content): Set the filter type to
	IOBUF_INPUT, not IOBUF_TEMP, which is only for output filters that
	write into a dynamic buffer.

	common/iobuf.h: Remove unimplemented prototypes.
	* common/iobuf.h (iobuf_unread): Remove unimplemented prototype.
	(iobuf_clear_eof): Likewise.
	(iobuf_append): Likewise.

	common/iobuf.c: Refactor code to not need the desc field.
	* common/iobuf.h (struct iobuf_struct): Remove field desc.
	* common/iobuf.c (iobuf_desc): New function.  When a filter's
	description is needed, use this instead of the filter's desc field.

	common/iobuf.h: Clarify semantics of nofast.  Simplify implementation.
	* common/iobuf.h (struct iobuf_struct): Clarify semantics of nofast.
	Simplify use of nofast to implement just these semantics.

	common/iobuf.c: Remove dead code (directfp).
	* common/iobuf.h (struct iobuf_struct): Remove field directfp.  Remove
	all uses of it.

	common/iobuf.c: Remove dead code (opaque).
	* common/iobuf.h (struct iobuf_struct): Remove field opaque.  Remove
	all uses of it.

	common/iobuf.h: Replace further use of literals with symbolic constants.
	* common/iobuf.c: Move BLOCK_FILTER_INPUT,
	BLOCK_FILTER_OUTPUT_BLOCK_FILTER_TEMP from here...
	* common/iobuf.h: ... to here and rename to IOBUF_INPUT, IOBUF_OUTPUT
	and IOBUF_TEMP, respectively.  Where appropriate, use these macros
	instead of a literal.

2015-08-17  Werner Koch  <wk@gnupg.org>

	gpg: Avoid linking to Libksba.
	* kbx/keybox.h (KEYBOX_WITH_X509): Do not define.
	* sm/Makefile.am (AM_CPPFLAGS): Define it here.
	(common_libs): Change to libkeybox509.a
	* g10/Makefile.am (AM_CFLAGS): remove KSBA_CFLAGS.
	(gpg2_LDADD, gpgv2_LDADD): Remove KSBA_LIBS
	* kbx/Makefile.am (noinst_LIBRARIES): Add libkeybox509.a.
	(libkeybox509_a_SOURCES): New.
	(libkeybox_a_CFLAGS): New.
	(libkeybox509_a_CFLAGS): New.
	(kbxutil_CFLAGS): New.
	* kbx/keybox-search.c (has_keygrip) [!KEYBOX_WITH_X509]: Declare args
	as unused.

2015-08-16  Ben Kibbey  <bjk@luxsci.net>

	Fix pinentry loopback and passphrase contraints.
	* agent/command.c (cmd_get_passphrase): Don't repeat passphrase for
	pinentry loopback mode.
	* agent/genkey.c (check_passphrase_constraints): Immediately return when
	pinentry mode is loopback.

	Fix sending INQUIRE_MAXLEN for symmetric data.
	* g10/passphrase.c (passphrase_to_dek_ext): Write the status message.

2015-08-15  Ben Kibbey  <bjk@luxsci.net>

	Inform a user about inquire length limit.
	* common/status.h (INQUIRE_MAXLEN): New.
	* g10/call-agent.c (default_inquire_cb): Send STATUS_INQUIRE_MAXLEN.
	client when inquiring a passphrase over pinentry-loopback.

	Allow --gen-key to inquire a passphrase.
	* g10/gpg.c (main): test for --command-fd during --gen-key parse.

	When --command-fd is set then imply --batch to let gpg inquire a
	passphrase rather than requiring a pinentry.

2015-08-11  Werner Koch  <wk@gnupg.org>

	Release 2.1.7.

2015-08-10  NIIBE Yutaka  <gniibe@fsij.org>

	agent: fix ECC key handling.
	* agent/cvt-openpgp.c (get_keygrip, convert_secret_key)
	(convert_transfer_key): CURVE is the name of curve.

2015-08-08  Neal H. Walfield  <neal@g10code.com>

	common/iobuf.c: Replace use of literals with symbolic constants.
	* common/iobuf.c (BLOCK_FILTER_INPUT): Define.  Where appropriate, use
	this instead of a literal.
	(BLOCK_FILTER_OUTPUT): Likewise.
	(BLOCK_FILTER_TEMP): Likewise.

2015-08-07  Werner Koch  <wk@gnupg.org>

	gpg: Allow gpgv to work with a trustedkeys.kbx file.
	* g10/keydb.h (KEYDB_RESOURCE_FLAG_GPGVDEF): New.
	* g10/keydb.c (keydb_add_resource): Take care of new flag.
	* g10/gpgv.c (main): Use new flag.

	agent: Add option --force to the DELETE_KEY command.
	* agent/findkey.c (agent_delete_key): Add arg "force".
	* agent/command.c (cmd_delete_key): Add option --force.

	common: Change alias for Curve25519 to "cv25519".
	* common/openpgp-oid.c (oidtable): Change alias.

2015-08-06  Werner Koch  <wk@gnupg.org>

	gpg: Remove duplicated printing of the curve name in "sub" lines.
	* g10/keylist.c (list_keyblock_print): Do not print extra curve name.

	gpg: Add commands "fpr *" and "grip" to --edit-key.
	* g10/keyedit.c (cmdGRIP): New.
	(cmds): Add command "grip".
	(keyedit_menu) <cmdFPR>: Print subkeys with argument "*".
	(keyedit_menu) <cmdGRIP>: Print keygrip.
	(show_key_and_fingerprint): Add arg "with_subkeys".
	(show_key_and_grip): New.
	* g10/keylist.c (print_fingerprint): Add mode 4.

	gpg: Adjust UID line indentation for common key algos.
	* g10/keylist.c (list_keyblock_print): Change UID line indentation
	* g10/mainproc.c (list_node): Ditto.

2015-08-06  NIIBE Yutaka  <gniibe@fsij.org>

	Curve25519 support.
	* agent/cvt-openpgp.c (get_keygrip): Handle Curve25519.
	(convert_secret_key, convert_transfer_key): Ditto.
	* common/openpgp-oid.c (oidtable): Add Curve25519.
	(oid_crv25519, openpgp_oid_is_crv25519): New.
	* common/util.h (openpgp_oid_is_crv25519): New.
	* g10/ecdh.c (pk_ecdh_encrypt_with_shared_point): Handle the case
	with Montgomery curve which uses x-only coordinate.
	* g10/keygen.c (gen_ecc): Handle Curve25519.
	(ask_curve): Change the API and second arg is to return subkey algo.
	(generate_keypair, generate_subkeypair): Follow chage of ask_curve.
	* g10/keyid.c (keygrip_from_pk): Handle Curve25519.
	* g10/pkglue.c (pk_encrypt): Handle Curve25519.
	* g10/pubkey-enc.c (get_it): Handle the case with Montgomery curve.
	* scd/app-openpgp.c (ECC_FLAG_DJB_TWEAK): New.
	(send_key_attr): Work with general ECC, Ed25519, and Curve25519.
	(get_public_key): Likewise.
	(ecc_writekey): Handle flag_djb_tweak.

	common: extend API of openpgp_oid_to_curve for canonical name.
	* common/openpgp-oid.c (openpgp_oid_to_curve): Add CANON argument.
	* common/util.h: Update.
	* g10/import.c (transfer_secret_keys): Follow the change.
	* g10/keyid.c (pubkey_string): Likewise.
	* g10/keylist.c (list_keyblock_print, list_keyblock_colon): Likewise.
	* parse-packet.c (parse_key): Likewise.
	* scd/app-openpgp.c (send_key_attr, get_public_key): Likewise.

2015-08-05  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix ecc_oid.
	* scd/app-openpgp.c (ecc_oid): Call with OIDBUF.

	scd: Fix ECC support.
	* scd/app-openpgp.c (send_key_attr): Send KEYNO.
	(get_public_key): Fix SEXP composing.
	(ecc_writekey): Fix OID length calculation.
	(ecc_oid): Prepend the length before query.
	(parse_algorithm_attribute): Handle the case the curve is not available.

2015-08-04  Werner Koch  <wk@gnupg.org>

	gpg: Fix duplicate key import due to legacy key in keyring.
	* g10/keydb.c (keydb_search_fpr): Skip legacy keys.

	gpg: Properly handle legacy keys while looking for a secret key.
	* g10/getkey.c (have_secret_key_with_kid): Skip legacy keys.

2015-07-31  Werner Koch  <wk@gnupg.org>

	gpg: Fix endless loop for expired keys given by fpr.
	* g10/getkey.c (lookup): Disable keydb caching when continuing a
	search.

2015-07-29  Werner Koch  <wk@gnupg.org>

	gpg: Do not return "Legacy Key" from lookup if a key is expired.
	* g10/getkey.c (lookup): Map GPG_ERR_LEGACY_KEY.

	gpg: Indicate secret keys and cards in a key-edit listing.
	* g10/keyedit.c (sign_uids): Add arg "ctrl".
	(show_key_with_all_names_colon): Ditto.
	(show_key_with_all_names): Ditto.

	* g10/keyedit.c (show_key_with_all_names): Print key record
	indicators by checking with gpg-agent.
	(show_key_with_all_names): Ditto.  May now also print sec/sbb.

2015-07-28  Werner Koch  <wk@gnupg.org>

	gpg: Remove the edit-key toggle command.
	* g10/keyedit.c (cmds): Remove helptext from "toggle".
	(keyedit_menu): Remove "toggle" var and remove the sub/pub check
	against toggle.

	common,w32: Avoid unused var warning about msgcache.
	* common/i18n.c (USE_MSGCACHE): New.
	(msgcache) [!USE_MSGCACHE]: Do not define.
	(i18n_localegettext): Repalce #if conditions by USE_MSGCACHE.

	w32: Try more places to find an installed Pinentry.
	* common/homedir.c (get_default_pinentry_name): Re-implement to
	support several choices for Windows.

2015-07-26  Werner Koch  <wk@gnupg.org>

	scd: Fix size_t/unsigned int mismatch.
	* scd/app-openpgp.c (ecc_writekey): Use extra var n.

	Replace GNUPG_GCC_A_ macros by GPGRT_ATTR_ macros.
	* common/util.h: Provide replacement for GPGRT_ATTR_ macros when using
	libgpg-error < 1.20.
	* common/mischelp.h: Ditto.
	* common/types.h: Ditto.

2015-07-25  NIIBE Yutaka  <gniibe@fsij.org>

	scd: support any curves defined by libgcrypt.
	* g10/call-agent.h (struct agent_card_info_s): Add curve field.
	* g10/call-agent.c (learn_status_cb): Use curve name.
	* g10/card-util.c (card_status): Show pubkey name.
	* scd/app-openpgp.c (struct app_local_s): Record OID and flags.
	(store_fpr): Use ALGO instead of key type.
	(send_key_attr): Use curve name instead of OID.
	(get_public_key): Clean up by OID to curve name.
	(ecc_writekey): Support any curves in libgcrypt.
	(do_genkey, do_auth, ): Follow the change.
	(ecc_oid): New.
	(parse_algorithm_attribute): Show OID here.

2015-07-23  Peter Wu  <peter@lekensteyn.nl>

	build: ignore scissor line for the commit-msg hook.
	* build-aux/git-hooks/commit-msg: Stop processing more lines when the
	  scissor line is encountered.

2015-07-23  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Format change to specify "rsa2048" for KEY-ATTR.
	* g10/card-util.c (do_change_keysize): Put "rsa".
	* scd/app-openpgp.c (change_keyattr, change_keyattr_from_string):
	Change the command format.
	(rsa_writekey): Check key type.
	(do_writekey): Remove "ecdh" and "ecdsa" support which was available
	in experimental libgcrypt before 1.6.0.

2015-07-22  Werner Koch  <wk@gnupg.org>

	Avoid a leading double slash in make_filename.
	* common/stringhelp.c (do_make_filename): Special case leading '/'.

2015-07-21  NIIBE Yutaka  <gniibe@fsij.org>

	scd: change_keyattr_from_string for ECC.
	* scd/app-openpgp.c (change_keyattr, change_keyattr_from_string):
	Support ECC.
	(rsa_writekey): Don't change key attribute.

2015-07-17  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Use openpgpdefs.h for constants.
	* scd/app-openpgp.c: Include openpgpdefs.h.

2015-07-16  Neal H. Walfield  <neal@g10code.com>

	Don't segfault if the first 'auto-key-locate' option is 'clear'.
	* g10/getkey.c (free_akl): If AKL is NULL, just return.

2015-07-10  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Support non-NLS build.
	* agent/agent.h: Use ENABLE_NLS and define L_() macro.

2015-07-09  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Remove unused files.
	* scd/Makefile.am (sc_copykeys_*): Remove.
	* scd/sc-copykeys.c: Remove.
	* scd/pcsc-wrapper.c: Remove.
	* scd/{card-common.h,card-dinsig.c,card-p15.c,card.c}: Remove.

2015-07-08  NIIBE Yutaka  <gniibe@fsij.org>

	g10: Use canonical name for curve.
	* g10/import.c (transfer_secret_keys): Use canonical name.
	* common/openpgp-oid.c (openpgp_curve_to_oid): Return NULL on error.
	* g10/keyid.c (pubkey_string): Follow change of openpgp_curve_to_oid.
	* g10/keylist.c (list_keyblock_print, list_keyblock_colon): Ditto.
	* g10/parse-packet.c (parse_key): Ditto.

2015-07-03  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	drop long-deprecated gpgsm-gencert.sh.
	 * tools/gpgsm-gencert.sh: remove deprecated script entirely.  It is
	   fully replaced by gpgsm --gen-key
	 * doc/tools.texi: remove gpgsm-gencert.sh documentation
	 * .gitignore: no longer ignore gpgsm-gencert.sh manpage
	 * doc/Makefile.am: quit making the manpage
	 * tools/Makefile.am: quit distributing the script
	 * doc/howto-create-a-server-cert.texi: overhaul documentation to use
	   gpgsm --gen-key and tweak explanations

2015-07-02  NIIBE Yutaka  <gniibe@fsij.org>

	po: Update Japanese translation.

	scd: Support AES decryption for OpenPGPcard v3.0.
	* scd/app-openpgp.c (do_decipher): Support AES decryption.

2015-07-01  Werner Koch  <wk@gnupg.org>

	Release 2.1.6.

2015-07-01  Daiki Ueno  <ueno@gnu.org>

	agent: Unset INSIDE_EMACS on gpg-agent startup.
	* agent/gpg-agent.c (main): Unset INSIDE_EMACS envvar.

2015-07-01  Werner Koch  <wk@gnupg.org>

	common: Implement i18n_localegettext.
	* common/i18n.c (msg_cache_s, msg_cache_head_s): New.
	(msgcache): New.
	(i18n_localegettext): Implement locale dependent lookup.

2015-06-30  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	Pass DBUS_SESSION_BUS_ADDRESS for gnome3.
	* common/session-env.c (stdenvnames): Add DBUS_SESSION_BUS_ADDRESS.

2015-06-30  Werner Koch  <wk@gnupg.org>

	Flag the L_() function with attribute format_arg.
	* agent/agent.h (LunderscorePROTO): New.
	* common/util.h (GNUPG_GCC_ATTR_FORMAT_ARG): New.
	* common/i18n.h (GNUPG_GCC_ATTR_FORMAT_ARG): New. Use for
	i18n_localegettext.  Expand LunderscorePROTO.
	* agent/genkey.c (check_passphrase_constraints): Use xtryasprintf
	again to keep the old translations.

	agent: Use different translation func for Pinentry strings.
	* po/Makevars (XGETTEXT_OPTIONS): Add keyword "L_".
	* common/i18n.c (i18n_localegettext): New stub.
	* common/i18n.h: Expand the LunderscoreIMPL macro.
	* agent/agent.h (L_): New.
	(LunderscoreIMPL): New.
	* agent/call-pinentry.c (setup_qualitybar): Add arg ctrl anc change
	caller.
	* agent/findkey.c (try_unprotect_cb): Add local var ctrl.
	* agent/genkey.c (check_passphrase_constraints): Replace xtryasprintf
	by xtrystrdup to avoid gcc warning.  Unfortinately this changes the
	string.
	(agent_ask_new_passphrase): Cleanup the use of initial_errtext.

	gpg: Make show-sig-subpackets work again.
	* g10/gpg.c (parse_list_options): Fix offset for subpackets.

2015-06-29  Werner Koch  <wk@gnupg.org>

	agent: Prepare for Libassuan with Cygwin support.
	* agent/gpg-agent.c (create_server_socket): Add arg "cygwin".  Call
	assuan_sock_set_flag if Assuan version is recent enough.
	(main): Create ssh server socket with Cygwin flag set.

2015-06-29  Neal H. Walfield  <neal@gnu.org>

	Show passphrase constraints errors as password prompt errors.
	* agent/agent.h (check_passphrase_constraints): Add parameter
	failed_constraint and remove parameter silent.  Update callers.
	* agent/genkey.c (check_passphrase_constraints): Add parameter
	failed_constraint and remove parameter silent.  If FAILED_CONSTRAINT
	is not NULL and OPT.ENFORCE_PASSPHRASE_CONSTRAINTS is FALSE, save the
	error text in *FAILED_CONSTRAINT and don't call take_this_one_anyway
	or take_this_one_anyway2.  If FAILED_CONSTRAINT is NULL, act as if
	SILENT was set.
	(agent_ask_new_passphrase): Change initial_errtext's type from a const
	char * to a char *.  Pass it to check_passphrase_constraints.  If it
	contains malloc's memory, free it.

2015-06-29  Neal H. Walfield  <neal@g10code.com>

	Improve documentation for default-cache-ttl and default-cache-ttl-ssh.
	* doc/gpg-agent.texi (Agent Options): Improve documentation for
	default-cache-ttl and default-cache-ttl-ssh.

	Don't raise max-cache-ttl to default-cache-ttl.
	* agent/gpg-agent.c (finalize_rereadable_options): Don't raise
	max-cache-ttl to default-cache-ttl.  Likewise for max-cache-ttl-ssh
	and default-cache-ttl-ssh.

	Improve the description of old packets with an indeterminate length.
	* g10/parse-packet.c (parse): Make the description more accurate when
	listing packets: old format packets don't support partial lengths,
	only indeterminate lengths (RFC 4880, Section 4.2).

2015-06-29  Werner Koch  <wk@gnupg.org>

	agent: Add --verify to the PASSWD command.
	* agent/command.c (cmd_passwd): Add option --verify.

	agent,w32: Do not create a useless socket with --enable-putty-support.
	* agent/agent.h (opt): Remove field ssh_support.
	* agent/gpg-agent.c (ssh_support): New.  Replace all opt.ssh_support
	by this.
	(main): Do not set ssh_support along with setting putty_support.

	gpgsm: Add command option "offline".
	* sm/server.c (option_handler): Add "offline".
	(cmd_getinfo): Ditto.
	* sm/certchain.c (is_cert_still_valid):
	(do_validate_chain):
	* sm/gpgsm.c (gpgsm_init_default_ctrl): Default "offline" to the value
	of --disable-dirmngr.
	* sm/call-dirmngr.c (start_dirmngr_ext): Better also check for
	ctrl->offline.

2015-06-26  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Support button flag and AES key data for OpenPGPcard v3.0.
	* scd/app-openpgp.c (do_getattr, show_caps, app_select_openpgp):
	Support button and symmetric decryption.
	(do_setattr): Support setting AESKEY.

2015-06-25  Andre Heinecke  <aheinecke@intevation.de>

	sm: Fix cert storage for ephemeral certs.
	* sm/keydb.c (keydb_store_cert): Clear ephemeral flag for
	existing certs if store should not be ephemeral.

2015-06-23  Werner Koch  <wk@gnupg.org>

	Allow use of debug flag names for all tools.
	* g13/g13.c: Make use of debug_parse_flag.
	* scd/scdaemon.c: Ditto.
	* sm/gpgsm.c: Ditto
	* agent/gpg-agent.c: Ditto.  But do not terminate on "help"
	* dirmngr/dirmngr.c: Ditto.

	common: Improve fucntion parse_debug_flag.
	* common/miscellaneous.c (parse_debug_flag): Add hack not to call
	exit.  Add "none" and "all" flags.

2015-06-23  NIIBE Yutaka  <gniibe@fsij.org>

	scd: pinpad workaround for PC/SC implementations.
	* scd/adpu.c (pcsc_pinpad_verify, pcsc_pinpad_modify): Bigger buffer
	for TPDU card reader.

2015-06-22  Werner Koch  <wk@gnupg.org>

	gpg: Allow debug flag names for --debug.
	* g10/gpg.c (opts): Change arg for oDebug to a string.
	(debug_flags): New; factored out from set_debug.
	(set_debug): Remove "--debug-level help".  Use parse_debug_flag to
	print the used flags.
	(main): Use parse_debug_flag for oDebug.

	common: Add function parse_debug_flag.
	* common/miscellaneous.c (parse_debug_flag): New.
	* common/util.h (struct debug_flags_s): New.

	common: Add function strtokenize.
	* common/stringhelp.c: Include assert.h.
	(strtokenize): New.
	* common/t-stringhelp.c (test_strtokenize): New.

	gpg: Fix regression due to recent commit 6500f33.
	* g10/keydb.c (kid_list_s): Keep a state in the table.
	(kid_not_found_table): Rename to kid_found_table.
	(n_kid_not_found_table): Rename to kid_found_table_count.
	(kid_not_found_p): Return found state.
	(kid_not_found_insert): Add arg found.
	(keydb_search): Store found state in the table.

2015-06-22  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix Cherry ST-2000 support for pinpad input.
	* scd/apdu.c (pcsc_vendor_specific_init): Set pinmax to 15.
	* scd/ccid-driver.c (ccid_transceive_secure): Add zero for the
	template of APDU.

2015-06-20  Werner Koch  <wk@gnupg.org>

	gpg: Print number of good signatures with --check-sigs.
	* g10/keylist.c (keylist_context): Add field good_sigs.
	(list_keyblock_print): Updated good_sigs.
	(print_signature_stats): Print number of good signatures and use
	log_info instead of tty_printf.

	gpg: Improve speed of --check-sigs and --lish-sigs.
	* g10/keydb.c (kid_list_t): New.
	(kid_not_found_table, n_kid_not_found_table): New.
	(kid_not_found_p, kid_not_found_insert, kid_not_found_flush): New.
	(keydb_insert_keyblock): Flush the new cache.
	(keydb_delete_keyblock): Ditto.
	(keydb_update_keyblock): Ditto.
	(keydb_search): Use the new cache.
	(keydb_dump_stats): New.
	* g10/gpg.c (g10_exit): Dump keydb stats.

2015-06-19  Werner Koch  <wk@gnupg.org>

	gpg: Add more log_clock calls to keydb.c.
	* g10/keydb.c (keydb_get_keyblock): Add log_clock calls.

	gpg: Print available debug flags using "--debug-level help".
	* g10/gpg.c (set_debug): Add "help" option and use a table for the
	flags.

	gpg: Fix export problem in case an old keyring has PGP-2 keys.
	* g10/export.c (do_export_stream): Skip legacy keys.

2015-06-18  Werner Koch  <wk@gnupg.org>

	dirmngr: Fix the cleanup zombies fix (685b782).
	* dirmngr/ldap-wrapper.c (ldap_wrapper_thread): Do not close the
	stdout reader after EOF from read_log_data.
	* dirmngr/crlcache.c (crl_cache_reload_crl): Close the reader before
	the next iteration.

2015-06-17  Werner Koch  <wk@gnupg.org>

	agent: Print a warning for obsolete options.
	* g10/misc.c (obsolete_scdaemon_option): Move to
	* common/miscellaneous.c (obsolete_option): ... here.
	* agent/gpg-agent.c (main): Use obsolete_option for the 3 obsolete
	options.

2015-06-16  Werner Koch  <wk@gnupg.org>

	dirmngr: Cleanup zombies and fix hang on shutdown.
	* dirmngr/ldap-wrapper.c (ldap_wrapper_thread): Move nfds computation
	into the loop.  Check the queue also on timeout.  Close log_fd and
	reader context on EOF or error.

	dirmngr: Avoid accessing uninitialized memory in log callback.
	* dirmngr/dirmngr.c (pid_suffix_callback): Clear int_and_ptr_u before
	use.
	(start_connection_thread): Ditto.
	(handle_connections): Ditto.

2015-06-16  Neal H. Walfield  <neal@g10code.com>

	Don't prompt for the password multiple times in pinentry loopback mode.
	* g10/gpg.c (main): If OPT.PINENTRY_MODE is PINENTRY_MODE_LOOPBACK,
	clear OPT.PASSPHRASE_REPEAT.

2015-06-16  NIIBE Yutaka  <gniibe@fsij.org>

	po: Update Japanese Translation.

2015-06-15  Werner Koch  <wk@gnupg.org>

	doc: Add defs.inc to BUILT_SOURCES.

2015-06-11  Werner Koch  <wk@gnupg.org>

	Release 2.1.5.

	agent: Fix --extra-socket on Windows.
	* agent/gpg-agent.c (start_connection_thread): Rename to ...
	(do_start_connection_thread): this.  Factor nonce checking out to ...
	(start_connection_thread_std): this,
	(start_connection_thread_extra): this,
	(start_connection_thread_browser): and this.

	agent: Add experimental option --browser-socket.
	* agent/agent.h (opt): Add field "browser_socket".
	* agent/command.c (cmd_setkeydesc): Use a different message for
	restricted==2.
	* agent/gpg-agent.c (oBrowserSocket): New.
	(opts): Add --browser-socket.
	(socket_name_browser, redir_socket_name_browser): New.
	(socket_nonce_browser): New.
	(cleanup): Cleanup browser socket.
	(main): Implement option.
	(start_connection_thread_browser): New.
	(handle_connections): Add arg listen_fd_browser and use it.

2015-06-10  Daiki Ueno  <ueno@gnu.org>

	agent: Add option --allow-emacs-pinentry.
	* agent/agent.h (opt): Add field allow_emacs_pinentry.
	* agent/call-pinentry.c (start_pinentry): Act upon new var.
	* agent/gpg-agent.c (oAllowEmacsPinentry): New.
	(opts): Add option --allow-emacs-pinentry.
	(parse_rereadable_options): Set this option.
	* tools/gpgconf-comp.c (gc_options_gpg_agent): Add new option.

2015-06-09  Werner Koch  <wk@gnupg.org>

	doc: Do not used fixed file names in the manuals.
	* doc/mkdefsinc.c: New.
	* doc/Makefile.am: Include cmacros.am.
	(EXTRA_DIST): Add mkdefsinc.c defsincdate.
	(BUILT_SOURCES): Add defsincdate
	(CLEANFILES): Add mkdefsinc and defs.inc.
	(mkdefsinc): New rule.
	(yat2m-stamp): Depend on defs.inc.
	($(myman_pages) gnupg.7): Ditto.
	(gnupg.texi): Remove rule to touch itself.
	(dist-hook): New.
	(defsincdate): New.
	(defs.inc): New.
	* doc/gnupg.texi: Remove inclusion of version.texi.  Include defs.inc.
	Also include defs.inc in all files used to build man files.  Change
	fixed directory names to those from defs.inc.

	dirmngr: Avoid crash due to an empty crls.d/DIR.txt.
	* dirmngr/crlcache.c (check_dir_version): Avoid segv.

2015-06-08  Werner Koch  <wk@gnupg.org>

	doc: Change the manual source to be only for GnuPG 2.1.

	Convey envvar INSIDE_EMACS to the pinentry.
	* common/session-env.c (stdenvnames): Add it.

	agent: Add command "getinfo std_env_names".
	* agent/command.c (cmd_getinfo): Add new sub-command.

2015-06-05  NIIBE Yutaka  <gniibe@fsij.org>

	scd: do_decipher change for OpenPGPcard v3.0.
	* scd/app-openpgp.c (do_decipher): Add a header for ECDH.

2015-06-04  Werner Koch  <wk@gnupg.org>

	gpg: Replace -1 by GPG_ERR_NOT_FOUND in tdbio.c.
	* g10/tdbio.c (lookup_hashtable): Return GPG_ERR_NOT_FOUND.
	* g10/tdbdump.c (import_ownertrust): Test for GPG_ERR_NOT_FOUND.
	* g10/trustdb.c (read_trust_record): Ditto.
	(tdb_get_ownertrust, tdb_get_min_ownertrust): Ditto.
	(tdb_update_ownertrust, update_min_ownertrust): Ditto.
	(tdb_clear_ownertrusts, update_validity): Ditto.
	(tdb_cache_disabled_value): Ditto.

	gpg: Cleanup error code path in case of a bad trustdb.
	* g10/tdbio.c (tdbio_read_record): Fix returning of the error.

	gpg: Fix output in case of a corrupted trustdb.
	* g10/tdbdump.c (list_trustdb): Add arg FP and change callers to pass
	es_stdout.
	* g10/tdbio.c (upd_hashtable): On a corrupted trustdb call
	list_trustdb only in verbose > 1 mode and let it dump to stderr.

2015-05-29  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix key template of ECC.
	* scd/app-openpgp.c (build_ecc_privkey_template): Use correct value.

2015-05-28  NIIBE Yutaka  <gniibe@fsij.org>

	g10: Fix a race condition initially creating trustdb.
	* g10/tdbio.c (take_write_lock, release_write_lock): New.
	(put_record_into_cache, tdbio_sync, tdbio_end_transaction): Use
	new lock functions.
	(tdbio_set_dbname): Fix the race.
	(open_db): Don't call dotlock_create.

2015-05-27  NIIBE Yutaka  <gniibe@fsij.org>

	g10: Remove g10/signal.c.
	* g10/signal.c: Remove.
	* g10/main.h: Remove old function API.
	* g10/tdbio.c: Use new API, even in the dead code.

2015-05-20  Werner Koch  <wk@gnupg.org>

	agent: Cleanup caching code for command GET_PASSPHRASE.
	* agent/command.c (cmd_get_passphrase): Read from the user cache.

2015-05-19  Neal H. Walfield  <neal@g10code.com>

	agent: When the password cache is cleared, also clear the ext. cache.
	* agent/agent.h (agent_clear_passphrase): New declaration.
	* agent/call-pinentry.c (agent_clear_passphrase): New function.
	* agent/command.c (cmd_clear_passphrase): Call agent_clear_passphrase.

	agent: Modify agent_clear_passphrase to support an ext. password cache.
	* agent/agent.h (agent_get_passphrase): Add arguments keyinfo and
	cache_mode.  Update callers.
	* agent/call-pinentry.c (agent_get_passphrase): Add arguments keyinfo
	and cache_mode.  If KEYINFO and CACHE_MODE describe a cachable key,
	then send SETKEYINFO to the pinentry.

2015-05-19  NIIBE Yutaka  <gniibe@fsij.org>

	g10: detects public key encryption packet error properly.
	g10/mainproc.c (proc_pubkey_enc): Only allow relevant algorithms for
	encryption.

2015-05-15  Werner Koch  <wk@gnupg.org>

	build: Make --disable-gpgsm work.
	* Makefile.am: Always build kbx/
	* g10/Makefile.am (AM_CFLAGS): Include KSBA_CFLAGS.

2015-05-12  Werner Koch  <wk@gnupg.org>

	Release 2.1.4.

	speedo: Add make option SELFCHECK=0 to build a new release.
	* build-aux/getswdb.sh: Add option --skip-selfcheck.
	* build-aux/speedo.mk: Add option SELFCHECK.

2015-05-11  Werner Koch  <wk@gnupg.org>

	common: Cope with AIX problem on number of open files.
	* common/exechelp-posix.c: Limit returned value for too hight values.

	gpg-connect-agent: Fix quoting of internal percent+ function.
	* tools/gpg-connect-agent.c (get_var_ext) <percent, percent+): Also
	escape '+'.

	agent: Add option --no-allow-external-cache.
	* agent/agent.h (opt): Add field allow_external_cache.
	* agent/call-pinentry.c (start_pinentry): Act upon new var.
	* agent/gpg-agent.c (oNoAllowExternalCache): New.
	(opts): Add option --no-allow-external-cache.
	(parse_rereadable_options): Set this option.

	agent: Add strings for use by future Pinentry versions.
	* agent/call-pinentry.c (start_pinentry): Add more strings.

	agent: Add option --debug-pinentry.
	* agent/gpg-agent.c (oDebugPinentry): New.
	(opts): Add --debug-pinentry.
	(parse_rereadable_options): Set that option.
	* agent/call-pinentry.c (start_pinentry): Pass option to
	assuan_set_flag.

2015-05-08  Werner Koch  <wk@gnupg.org>

	gpg: Avoid cluttering stdout with trustdb info in verbose mode.
	* g10/trustdb.c (validate_keys): Call dump_key_array only in debug
	mode.

	gpg: Fix wrong output in list mode.
	* g10/parse-packet.c (parse_gpg_control): Replace puts by es_fputs to
	LISTFP.

	gpg: New command --quick-adduid.
	* g10/keygen.c (ask_user_id): Factor some code out to ...
	(uid_already_in_keyblock): new.
	(generate_user_id): Add arg UIDSTR.  Fix leaked P.
	* g10/keyedit.c (menu_adduid): Add new arg uidstring.  Adjust caller.
	(keyedit_quick_adduid): New.
	* g10/gpg.c (aQuickAddUid): New.
	(opts):  Add command --quick-adduid.
	(main): Implement that.

	gpg: Add push/pop found state feature to keydb.
	* g10/keydb.c (keydb_handle): Add field saved_found.
	(keydb_new): Init new field.
	(keydb_push_found_state, keydb_pop_found_state): New.
	* g10/keyring.c (kyring_handle): Add field saved_found.
	(keyring_push_found_state, keyring_pop_found_state): New.

	gpg: Minor code merging in keyedit.
	* g10/keyedit.c (fix_keyblock): Rename to fix_key_signature_order.
	(fix_keyblock): New.  Call fix_key_signature_order and other fix
	functions.
	(keyedit_menu): Factor code out to new fix_keyblock.
	(keyedit_quick_sign): Ditto.  Check for primary fpr before calling
	fix_keyblock.

2015-05-07  Werner Koch  <wk@gnupg.org>

	agent: Minor change for 56b5c9f.
	* agent/call-pinentry.c (agent_askpin): Move option setting to ...
	(start_pinentry): here.  Fix error code check.

2015-05-07  Kristian Fiskerstrand  <kf@sumptuouscapital.com>

	dirmngr: Fix segfault in ldap engine.
	(ks-engine-ldap.c) Fix segfault caused by missing check whether uri is
	initialized

2015-05-07  Neal H. Walfield  <neal@g10code.com>

	agent: Improve support for externally cached passwords.
	* agent/call-pinentry.c (PINENTRY_STATUS_PASSWORD_FROM_CACHE): New
	constant.
	(pinentry_status_cb): Add it to *FLAGS if PASSWORD_FROM_CACHE was
	provided.
	(agent_askpin): Pass "OPTION allow-external-password-cache" to the
	pinentry.  Always pass SETKEYINFO to the pinentry.  If there is no
	stable identifier, then use "--clear".  If the password is incorrect
	and PINENTRY_STATUS_PASSWORD_FROM_CACHE is set in *PINENTRY_STATUS,
	then decrement PININFO->FAILED_TRIES.

	agent: Or in the value; don't overwrite the variable.
	* agent/call-pinentry.c (pinentry_status_cb): Or in
	PINENTRY_STATUS_CLOSE_BUTTON; don't overwrite *FLAG.

	agent: Avoid magic numbers.  Use more accurate names.
	* agent/call-pinentry.c (PINENTRY_STATUS_CLOSE_BUTTON): New constant.
	(PINENTRY_STATUS_PIN_REPEATED): Likewise.
	(close_button_status_cb): Rename from this...
	(pinentry_status_cb): ... to this.  Use the constants.
	(agent_askpin): Rename local variable from close_button to
	pinentry_status.  Use symbolic constants rather than magic numbers.

2015-05-07  Werner Koch  <wk@gnupg.org>

	gpg: Improve 'General key info' line of --card-status.
	* g10/keylist.c (print_pubkey_info): Print either "pub" or "sub".

	* g10/getkey.c (get_pubkey_byfprint): Add optional arg R_KEYBLOCK.
	* g10/keyid.c (keyid_from_fingerprint): Adjust for change.
	* g10/revoke.c (gen_desig_revoke): Adjust for change.
	* g10/card-util.c (card_status): Simplify by using new arg.  Align
	card-no string.

	* g10/card-util.c (card_status): Remove not used GnuPG-1 code.

	gpg: Fix regression not displaying the card serial number.
	* g10/call-agent.c (keyinfo_status_cb): Detect KEYINFO.

2015-05-06  Werner Koch  <wk@gnupg.org>

	speedo,w32: Install a native pinentry.
	* build-aux/speedo.mk: Always build pinentry for w32.
	(speedo_pkg_pinentry_configure): Adjust to modern pinentry.
	* build-aux/speedo/w32/inst.nsi: Install native pinentry under the
	name pinentry-basic.exe.

2015-05-01  NIIBE Yutaka  <gniibe@fsij.org>

	g10: fix cmp_public_key.
	* g10/free-packet.c (cmp_public_keys): Compare opaque
	data at the first entry of the array when it's unknown algo.

2015-04-30  NIIBE Yutaka  <gniibe@fsij.org>

	scd: PC/SC reader selection by partial string match.
	* scd/apdu.c (open_pcsc_reader_direct): Partial string match.

2015-04-24  Werner Koch  <wk@gnupg.org>

	common: Remove JNLIB from boiler plate (jnlib merge).
	* common/README.jnlib: Remove.

	common: Rename log and gcc attribute macros (jnlib merge).
	* common/logging.h: Rename JNLIB_LOG_* to GPGRT_LOG_*.
	* common/mischelp.h: Rename JNLIB_GCC_* to GPGRT_GCC_*.

	common: Remove two JNLIB_ macros (jnlib merge).
	* configure.ac: Merge seperate jnlib checks.
	(HAVE_JNLIB_LOGGING): Remove.
	* common/logging.c, common/simple-pwquery.c (JNLIB_NEED_AFLOCAL):
	Rename to GNUPG_COMMON_NEED_AFLOCAL.  Change all tests.

	common: Remove libjnlib-config.h (jnlib merge).
	* common/libjnlib-config.h: Remove.
	* common/common-defs.h (getenv) [HAVE_GETENV]: New.  From removed
	header.
	(getpid) [HAVE_W32CE_SYSTEM]: New.  From removed header.
	* common/argparse.c: Include util.h and common-defs.h.  Replace
	jnlib_ macro names for non-GNUPG builds by x* names.
	* common/dotlock.c: Ditto.
	* common/logging.c: Include util.h and common-defs.h.  Replace jnlib_
	symbol names by x* names.
	* common/strlist.c: Ditto.
	* common/utf8conv.c: Ditto.
	* common/w32-reg.c: Ditto.
	* common/mischelp.c: Ditto.  Also remove _jnlib_free.
	* common/stringhelp.c: Ditto.
	(JNLIB_LOG_WITH_PREFIX): Do not depend on this macro.
	* common/logging.h (JNLIB_LOG_WITH_PREFIX): Do not depend on this
	macro.

2015-04-23  Werner Koch  <wk@gnupg.org>

	gpg: Move all DNS access to Dirmngr.
	* common/dns-cert.h: Move to ../dirmngr/.
	* common/dns-cert.c: Move to ../dirmngr/.  Change args to return the
	key as a buffer.
	* common/t-dns-cert.c: Move to ../dirmngr/.
	* common/pka.c, common/pka.h, common/t-pka.c: Remove.

	* dirmngr/server.c (data_line_cookie_write): Factor code out to
	data_line_write and make it a wrapper for that.
	(data_line_write): New.
	(cmd_dns_cert): New.
	(register_commands): Register new command.

	* g10/Makefile.am (LDADD): Remove DNSLIBS.
	* g10/call-dirmngr.c (dns_cert_parm_s): New.
	(dns_cert_data_cb, dns_cert_status_cb): New.
	(gpg_dirmngr_dns_cert): New.
	(gpg_dirmngr_get_pka): New.
	* g10/gpgv.c (gpg_dirmngr_get_pka): New dummy function.
	* g10/keyserver.c (keyserver_import_cert): Replace get_dns_cert by
	gpg_dirmngr_dns_cert.
	(keyserver_import_pka): Replace get_pka_info by gpg_dirmngr_get_pka.
	* g10/mainproc.c: Include call-dirmngr.h.
	(pka_uri_from_sig): Add CTX arg. Replace get_pka_info by
	gpg_dirmngr_get_pka.

	common: Minor change of hex2str to allow for embedded nul.
	* common/convert.c (hex2str): Set ERRNO.  Return adjusted COUNT.

2015-04-23  NIIBE Yutaka  <gniibe@fsij.org>

	common: removal of t-support.c from t_jnlib_src.
	* common/Makefile.am (t_jnlib_src): Remove t-support.c.

2015-04-21  Werner Koch  <wk@gnupg.org>

	gpg: Make keyserver-option http_proxy work.
	* g10/options.h (opt): Add field keyserver_options.http_proxy.
	* g10/keyserver.c (warn_kshelper_option): Add arg noisy.
	(parse_keyserver_options): Parse into new http_proxy field.
	* g10/call-dirmngr.c (create_context): Send the http-proxy option.

	common: Make proper use of http proxy parameter.
	* common/http.c (is_hostname_port): New.
	(send_request): Fix proxy name parsing.

	dirmngr: Add http proxy support for keyservers.
	* dirmngr/dirmngr.h (server_control_s): Add field http_proxy.
	* dirmngr/dirmngr.c (dirmngr_init_default_ctrl): Copy http_proxy value
	from OPT.
	(dirmngr_deinit_default_ctrl): New.
	(main): Call dirmngr_deinit_default_ctrl.
	* dirmngr/server.c (start_command_handler): Ditto.
	(option_handler): Add option "http-proxy".
	* dirmngr/crlfetch.c (crl_fetch): Take http_proxy from CTRL.
	* dirmngr/ocsp.c (do_ocsp_request): Ditto.
	* dirmngr/ks-engine-hkp.c (send_request): Add proxy support.
	* dirmngr/ks-engine-http.c (ks_http_fetch): Ditto.

	gpg: Do not use honor-keyserver-url sub-option by default.

	gpg: Make preferred keyservers work.
	* g10/call-dirmngr.c (dirmngr_local_s): Add field set_keyservers_done.
	(create_context): Move keyserver setting to ...
	(open_context): here.
	(clear_context_flags): New.
	(gpg_dirmngr_ks_get): Add arg override_keyserver.
	* g10/keyserver.c (keyserver_refresh): Improve diagnostics.
	(keyserver_get_chunk): Ditto.  Pass OVERRIDE_KEYSERVER to ks_get.

	gpg: Update sub-options of --keyserver-options.
	* g10/options.h (KEYSERVER_HTTP_PROXY): New.
	(KEYSERVER_USE_TEMP_FILES, KEYSERVER_KEEP_TEMP_FILES): Remove.
	(KEYSERVER_TIMEOUT): New.
	* common/keyserver.h (KEYSERVER_TIMEOUT): Remove.
	* g10/keyserver.c (keyserver_opts): Remove obsolete "use-temp-files"
	and "keep-temp-files". Add "http-proxy" and "timeout".
	(parse_keyserver_options): Remove 1.2 compatibility option
	"honor-http_proxy".  Remove "use-temp-files" and "keep-temp-files"
	code.

2015-04-14  Werner Koch  <wk@gnupg.org>

	agent: Send the new SETKEYINFO command to the Pinentry.
	* agent/call-pinentry.c (agent_askpin): Add args keyinfo and
	cache_mode.  Change all callers to pass (NULL,0) for them.  Send
	SETKEYINFO command.
	* agent/findkey.c (unprotect): Pass the keygrip and the cache_mode for
	the new args.

2015-04-14  NIIBE Yutaka  <gniibe@fsij.org>

	scd: better handling of extended APDU.
	* scd/apdu.c (send_le): Bug fix for not append Z when lc<0&&le<0.
	* scd/app-common.h (struct app_ctx_s): Use bit fields for flags.
	* scd/ccid-driver.c (CCID_MAX_BUF): New.  Only for OpenPGPcard.
	(struct ccid_driver_s): New field of max_ccid_msglen.
	 Remove ifsd field.
	(parse_ccid_descriptor): Initialize max_ccid_msglen.
	(ccid_transceive_apdu_level): Implement sending extended APDU in
	chain of CCID message.

2015-04-13  Werner Koch  <wk@gnupg.org>

	gpg: Fix NULL-segv due to invalid imported data.
	* g10/free-packet.c (my_mpi_copy): New.
	(copy_public_key, copy_signature): Use instead of mpi_copy.

2015-04-13  Neal H. Walfield  <neal@g10code.com>

	dirmngr: If LDAP is not enable, don't build the LDAP bits.
	* dirmngr/Makefile.am (dirmngr_SOURCES): Only include
	ks-engine-ldap.c, ldap-parse-uri.c and ldap-parse-uri.h if USE_LDAP
	is TRUE.
	(module_tests): Only add t-ldap-parse-uri if USE_LDAP is TRUE.
	* dirmngr/ks-action.c: Only include "ldap-parse-uri.h" if USE_LDAP is
	TRUE.
	(ks_action_help): Don't invoke LDAP functionality if USE_LDAP is not
	TRUE.
	(ks_action_search): Likewise.
	(ks_action_get): Likewise.
	(ks_action_put): Likewise.
	* dirmngr/server.c: Only include "ldap-parse-uri.h" if USE_LDAP is
	TRUE.
	(cmd_keyserver): Don't invoke LDAP functionality if USE_LDAP is not
	TRUE.

2015-04-13  Werner Koch  <wk@gnupg.org>

	common: Do without nested fucntions to support non-gcc.
	* common/t-stringhelp.c (test_strsplit): Remove nested function.

2015-04-11  Werner Koch  <wk@gnupg.org>

	Release 2.1.3.

2015-04-11  Yuri Chornoivan  <yurchor@ukr.net>

	po: Update Ukrainian translation.

2015-04-11  Ineiev  <ineiev@gnu.org>

	po: Update and review Russian translation.

2015-04-10  Werner Koch  <wk@gnupg.org>

	dirmngr,w32: Make it build for Windows.
	* dirmngr/Makefile.am (t_common_ldadd): Add missing libs.

	Remove obsolete directories from AM_CPPFLAGS.

	dirmngr,w32: Replace functions not available under Windows.
	* dirmngr/ks-engine-ldap.c (extract_attributes): Replace isoptime and
	gmtime_r.

	common: Add new function gnupg_gmtime.
	* common/gettime.c (gnupg_gmtime): New.
	(gnupg_get_isotime): Use it.  Also take care of an gmtime_t returning
	an error.

	common: Add new function isodate_human_to_tm.
	* common/gettime.c (isotime_human_p): Add arg date_only.
	(isodate_human_to_tm): New.
	* common/t-gettime.c (test_isodate_human_to_tm): New.
	(main): Call new test.

	dirmngr,w32: Avoid name clash with existing function.
	* dirmngr/ks-engine-ldap.c (ldap_connect): Rename to my_ldap_connect.

	gpgparsemail: Fix last commit (3f2bdac)
	* tools/rfc822parse.c (parse_field): Replace break by goto.

2015-04-09  Werner Koch  <wk@gnupg.org>

	gpgparsemail: Fix case of zero length continuation lines.
	* tools/rfc822parse.c (parse_field): Loop after continuation line.

2015-04-08  Werner Koch  <wk@gnupg.org>

	sm: Fix certificate lookup in dirmngr cache.
	* sm/call-dirmngr.c (get_cached_cert): Fix typo in LOOKUP command.

2015-04-06  Werner Koch  <wk@gnupg.org>

	gpg: Print the user id in --fast-list-mode.
	* g10/keylist.c (list_keyblock_print, list_keyblock_colon): Change.

	gpg: Prepare to pass additional context to the list functions.
	* g10/keylist.c (struct sig_stats): Rename to keylist_context and add
	field check_sigs.
	(keylist_context_release): New.
	(list_all): Set listctx.check_sigs and call release func.
	(list_one): Ditto.
	(locate_one): Ditto.
	(list_keyblock_print): Use .check_sigs field.  Repalce arg opaque by
	listctx.
	(list_keyblock): Ditto.  Make static.
	(list_keyblock_direct): New.
	* g10/keygen.c (do_generate_keypair): Replace list_keyblock by
	list_keyblock_direct.

	gpg: Merge duplicated code for get_user_id et al.
	* g10/getkey.c (get_user_id_string): Add args mode and r_LEN.
	(get_user_id_string_native): Add new args.
	(get_long_user_id_string, get_user_id): Rewrite using
	get_user_id_string.

	gpg: Add new option --debug-iolbf.
	* g10/gpg.c (oDebugIOLBF): new.
	(opts): Add --debug-iolbf.
	(main): Set option.

	Rename DBG_ASSUAN to DBG_IPC and add separate DBG_EXTPROG.
	* g10/options.h (DBG_EXTPROG_VALUE): Separate from DBG_IPC_VALUE.

	Fix use of DBG_CACHE and DBG_LOOKUP.
	* dirmngr/dirmngr.h (DBG_LOOKUP_VALUE): Change to 8192.
	* g10/options.h (DBG_LOOKUP_VALUE, DBG_LOOKUP): New.
	* g10/getkey.c: Use DBG_LOOKUP instead of DBG_CACHE at most places.

	gpg: Rename a debug macro.
	* g10/options.h (DBG_CIPHER_VALUE): Rename to DBG_CRYPTO_VALUE.
	(DBG_CIPHER): Rename to DBG_CRYPTO.

2015-04-05  Werner Koch  <wk@gnupg.org>

	gpg: Fix DoS while parsing mangled secret key packets.
	* g10/parse-packet.c (parse_key): Check PKTLEN before calling mpi_read
	et al.

2015-04-03  NIIBE Yutaka  <gniibe@fsij.org>

	g10: Fix keytocard.
	g10/call-agent.h (agent_scd_learn): Add FORCE option.
	g10/call-agent.c (agent_scd_learn): Implement FORCE option.
	g10/keygen.c (gen_card_key): Follow the change of option.
	g10/card-util.c (change_pin, card_status, factory_reset): Likewise.
	g10/keyedit.c (keyedit_menu): Update private key storage by
	agent_scd_learn.

	agent: Add --force option for LEARN.
	* agent/command.c (cmd_learn): Handle --force option.
	(cmd_keytocard): Don't update key storage file.
	* agent/agent.h (agent_handle_learn): Add FORCE.
	* agent/learncard.c (agent_handle_learn): Implement FORCE to update
	key stroage file.

2015-03-31  Neal H. Walfield  <neal@g10code.com>

	dirmngr: Don't use alloca.
	* dirmngr/ks-engine-ldap.c (ks_ldap_put): Replace use of alloca with
	xmalloc and xfree.

	dirmngr: Simplify truncation of long strings in debug code.
	* dirmngr/ks-engine-ldap.c (modlist_dump): Simplify truncation of long
	strings.

	dirmngr: Use a better error code.
	* dirmngr/ldap-parse-uri.c (ldap_parse_uri): On error, return
	GPG_ERR_GENERAL, not GPG_ERR_ASS_GENERAL.

	dirmngr: Better encapsulate the keyservers variable.
	* dirmngr/dirmngr.h (struct server_control_s): Move field keyservers
	from here...
	* dirmngr/server.c (struct server_local_s): ... to here.  Update
	users.
	* dirmngr/ks-action.h (ks_action_resolve): Add argument keyservers.
	(ks_action_search): Likewise.
	(ks_action_get): Likewise.
	(ks_action_put): Likewise.
	* dirmngr/ks-action.c (ks_action_resolve): Add argument keyservers.
	Use it instead of ctrl->keyservers.
	(ks_action_search): Likewise.
	(ks_action_get): Likewise.
	(ks_action_put): Likewise.

2015-03-28  Neal H. Walfield  <neal@g10code.de>

	gpg: Only use the last specified keyserver.
	* g10/gpg.c (main): Only use the last specified keyserver.

2015-03-25  Werner Koch  <wk@gnupg.org>

	dirmngr: Fix resource leaks and check rare errors.
	* dirmngr/ks-engine-ldap.c (keyspec_to_ldap_filter): Fix resource
	leak.
	(ks_ldap_search): Check error from es_fopenmem.  Use LDAP_ERR where
	required.
	(modlist_dump): Check error from es_fopenmem.
	(uncescape): s/int/size_t/.  Use existing macros.
	(extract_attributes): Use existing trim function.
	(ks_ldap_put): Do not segv on error from modlist_dump.

	dirmngr: Minor cleanups.
	* dirmngr/ks-engine-ldap.c [__riscos__]: Remove doubled util.h.
	(ldap_to_gpg_err): s/GPG_ERR_GENERAL/GPG_ERR_INTERNAL/.
	(tm2ldaptime): Use snprintf.
	(ldap_connect): Get error code prior to log_error and and use modern
	function.   Use xfree, xtrustrdup etc.
	(modlist_lookup): Use GNUPG_GCC_A_USED.
	(modlist_free): Use xfree.

	common: Add macro GNUPG_GCC_A_USED.
	* common/util.h (GNUPG_GCC_A_USED): New.

	sm: Change default algos to SHA256 (CSR) and AES128 (bulk encryption).
	* sm/certreqgen.c (create_request): Change default hash algo.
	* sm/gpgsm.c (DEFAULT_CIPHER_ALGO): Change default bulk cipher algo.

2015-03-24  Werner Koch  <wk@gnupg.org>

	gpg,w32: Handle forward slash in --keyring option.
	* g10/keydb.c (keydb_add_resource): Allow forward slash under Windows.

2015-03-23  Neal H. Walfield  <neal@g10code.de>

	Improve documentation for ks_hkp_get.
	* dirmngr/ks-engine-hkp.c (ks_hkp_get): Improvement documentation.

	Improve documenation of http_parse_uri.
	* common/http.c (http_parse_uri): Improve documentation.

	Add support to talking to LDAP key servers.
	* g10/call-dirmngr.c (record_output): New function.
	(ks_put_inq_cb): Use it here to generate a --with-colons like output
	instead of a custom format.
	* dirmngr/ks-action.c: Include "ldap-parse-uri.h".
	(ks_action_help): If the provided URI is an LDAP URI, then use
	ldap_parse_uri to parse.  Call ks_ldap_help.
	(ks_action_search): If passed an LDAP URI, then call ks_ldap_search.
	(ks_action_get): Likewise.
	(ks_action_put): Likewise.  Also, change data from a 'const void *' to
	a 'void *' and add info and infolen parameters.  Add note that
	function may modify DATA.
	* dirmngr/ks-action.h (ks_action_put): Update declaration accordingly.
	* dirmngr/server.c: Include "ldap-parse-uri.h".
	(cmd_keyserver): If ITEM->URI is an LDAP URI, parse it using
	ldap_parse_uri.
	(hlp_ks_put): Improve documentation.
	(cmd_ks_put): Also pass info and infolen to ks_action_put.  Improve
	documentation.
	* dirmngr/ks-engine.h (ks_ldap_help): New declaration.
	(ks_ldap_search): Likewise.
	(ks_ldap_get): Likewise.
	(ks_ldap_put): Likewise.
	* dirmngr/ks-engine-ldap.c: New file.
	* dirmngr/Makefile.am (dirmngr_SOURCES): Add ks-engine-ldap.c,
	ldap-parse-uri.c and ldap-parse-uri.h.
	(dirmngr_LDADD) [USE_LDAP]: Add $(ldaplibs).

	Import _gpgme_parse_timestamp from gpgme as parse_timestamp.
	* common/gettime.h (parse_timestamp): New declaration.
	* common/gettime.c (_win32_timegm): New function imported from
	gpgme/src/conversion.c:_gpgme_timegm.
	(parse_timestamp): New function imported from
	gpgme/src/conversion.c:_gpgme_parse_timestamp.

	Move copy_stream function to misc.c.
	* dirmngr/ks-action.c (copy_stream): Move function from here...
	* dirmngr/misc.c (copy_stream): ... to here and drop the static
	qualifier.
	* dirmngr/misc.h (copy_stream): Add declaration.

	Move armor_data to misc.c.
	* dirmngr/ks-engine-hkp.c (armor_data): Move function from here...
	* dirmngr/misc.c (armor_data): ... to here and drop static qualifier.
	* dirmngr/misc.h: New declaration.

	Add new LDAP utility functions.
	* dirmngr/Makefile.am (module_tests): New variable.
	(noinst_PROGRAMS): New primary.  Set it to $(module_tests).
	(TESTS): New variable.  Set it to $(module_tests).
	(t_common_src): New variable.
	(t_common_ldadd): Likewise.
	(t_ldap_parse_uri_SOURCES): New primary.
	(t_ldap_parse_uri_LDADD): Likewise.
	* dirmngr/ldap-parse-uri.c: New file.
	* dirmngr/ldap-parse-uri.h: Likewise.
	* dirmngr/t-ldap-parse-uri.c: Likewise.
	* dirmngr/t-support.h: Likewise.

	Add new function uri_query_lookup.
	* common/http.h (uri_query_lookup): New declaration.
	* common/http.c (uri_query_lookup): The corresponding implementation.

	Add new function strlist_find.
	* common/strlist.h (strlist_find): New declaration.
	* common/strlist.c (strlist_find): New function.

	common: Add new helper function, strsplit.
	* common/stringhelp.h (strsplit): New declaration.
	* common/stringhelp.c (strsplit): New function.
	* common/t-stringhelp.c (test_strsplit): New function.
	(main): Call it here.

2015-03-20  Werner Koch  <wk@gnupg.org>

	gpg: Consider a mailbox only userid in mail search mode.
	* kbx/keybox-search.c: Include mbox-util.h.
	(blob_cmp_mail): Improve OpenPGP uid parsing.

	common: Add function is_valid_mailbox_mem.
	* common/mbox-util.c (mem_count_chr): New.
	(my_memstr): New.
	(has_invalid_email_chars): Change args to work on a buffer.
	(is_valid_mailbox_mem): New.
	(is_valid_mailbox): Rewrite to use is_valid_mailbox_mem.

	gpg: Find keys using mail addresses with garbage after the '>'
	* kbx/keybox-search.c (blob_cmp_mail): Stop comparing at the '>'.

	common: Fix syntax error when building with gnutls.
	* common/http.c (send_request): Add missing comma.

2015-03-19  Werner Koch  <wk@gnupg.org>

	gpg: Emit status line NEWSIG before signature verification starts.
	* g10/mainproc.c (check_sig_and_print): Emit STATUS_NEWSIG.

	agent: Compute correct MPI length header for protected ECC keys.
	* agent/cvt-openpgp.c (apply_protection): Strip leading zeroes from
	opaque MPIs to comply with the OpenPGP spec.

	hkps: Fix host name verification when using pools.
	* common/http.c (send_request): Set the requested for SNI.
	* dirmngr/ks-engine-hkp.c (map_host): Return the poolname and not
	the selecting a host.

	Define replacement error codes from libgpg-error 1.19.
	* common/util.h: Add GPG_ERR_LDAP codes for libgpg-error < 1.19.

2015-03-17  Andre Heinecke  <aheinecke@intevation.de>

	gpgtar: Fix extracting files with !(size % 512)
	* tools/gpgtar-extract.c (extract_regular): Handle size multiples
	  of RECORDSIZE.

2015-03-17  Werner Koch  <wk@gnupg.org>

	common: Add feature to ease using argparse's usage().
	* common/argparse.c (show_help): Take care of flag value
	(usage): Ditto.

	common: Allow standalone build of argparse.c.
	* common/argparse.h: Remove types.h - not required.
	* common/argparse.c: Change to allow standalone use.

2015-03-16  Werner Koch  <wk@gnupg.org>

	gpg: Create all MPIs with RFC-4880 correct length headers.
	* g10/build-packet.c (gpg_mpi_write): Strip leading zeroes.

	gpg: Allow printing of MPI values in --list-mode.
	* g10/parse-packet.c (set_packet_list_mode): Set mpi_print_mode.
	* g10/misc.c (mpi_print): Do not print an extra leading zero.

	gpg: Fix broken write of opaque MPI length header.
	* g10/build-packet.c (gpg_mpi_write): Use a char array for the length.

2015-03-15  Werner Koch  <wk@gnupg.org>

	gpg: Fix possible dead code elimination.
	* g10/encrypt.c: Change condition for detecting a real file.

	g13: Fix pointer wrap check.
	* g13/utils.c (find_tuple, next_tuple): Cast pointer to size_t before
	doing an overflow check.

	agent: Remove useless conditions in command.c.
	* agent/command.c (cmd_setkeydesc): Remove NULL check.
	(cmd_get_passphrase): Ditto.
	(cmd_clear_passphrase): Ditto.
	(cmd_get_confirmation): Ditto.
	(cmd_getval): Ditto.
	(cmd_putval): Ditto.

	agent: Fix length test in sshcontrol parser.
	* agent/command-ssh.c (ssh_search_control_file): Check S before
	upcasing it.

	agent: Remove useless conditions.
	* agent/genkey.c (agent_ask_new_passphrase): Remove useless condition.
	* agent/command-ssh.c (ssh_identity_register): Ditto.

	gpg: Remove useless condition.
	* g10/keylist.c (list_keyblock_colon): Remove useless condition (PK).
	(list_keyblock_print):  Likewise.

	scd: Fix possible NULL deref in apdu.c.
	* scd/apdu.c (control_pcsc_direct): Take care of BUFLEN being NULL.
	(control_pcsc_wrapped): Ditto.

	common: Make openpgp_oid_to_str more robust.
	* common/openpgp-oid.c (openpgp_oid_to_str): Take care of
	gcry_mpi_get_opaque returning NULL.  Remove useless condition !BUF.

2015-03-11  Werner Koch  <wk@gnupg.org>

	agent: Improve error reporting from Pinentry.
	* agent/call-pinentry.c (unlock_pinentry): Add error logging.  Map
	error source of uncommon errors to Pinentry.

2015-03-10  Werner Koch  <wk@gnupg.org>

	gpg: Change --print-pka-records into an option.
	* g10/gpg.c (aPrintPKARecords): Rename to oPrintPKARecords and do not
	use it as a command.
	* g10/keylist.c (list_keyblock): List PKA rceords also for secret
	keys.

	gpg: Add --list-gcrypt-config and "curve" item for --list-config.
	* common/openpgp-oid.c (curve_supported_p): New.
	(openpgp_enum_curves): New.
	* common/t-openpgp-oid.c (test_openpgp_enum_curves): New.
	(main): Add option --verbose.
	* g10/gpg.c (opts): Add --list-gcrypt-config.
	(list_config): Add items "curve" and "curveoid".  Remove unused code.

2015-03-09  NIIBE Yutaka  <gniibe@fsij.org>

	scd: fix for 64-bit arch.
	* agent/pksign.c (agent_pksign_do): Use int.
	* scd/app-openpgp.c (get_public_key): Likewise.

2015-03-04  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	gpg: avoid chatter about trustdb when --quiet.
	* g10/trustdb.c (tdb_check_trustdb_stale): avoid log_info() when
	  opt.quiet

2015-02-26  Werner Koch  <wk@gnupg.org>

	gpg: Lowercase mailbox for PKA lookups.
	* common/stringhelp.c (ascii_strlwr): New.
	* common/mbox-util.c (mailbox_from_userid): Downcase result.

	gpg: Fix memory leak due to PKA lookup.
	* g10/keyserver.c (keyserver_import_pka): Move the xfree.

2015-02-25  Werner Koch  <wk@gnupg.org>

	gpg: Switch to a hash and CERT record based PKA system.
	* common/dns-cert.c (get_dns_cert): Make r_key optional.
	* common/pka.c: Rewrite for the new hash based lookup.
	* common/t-pka.c: New.
	* configure.ac: Remove option --disable-dns-pka.
	(USE_DNS_PKA): Remove ac_define.
	* g10/getkey.c (parse_auto_key_locate): Always include PKA.

	common: Allow requesting a specific certtype with get_dns_cert()
	* common/dns-cert.c (get_dns_cert): Add arg want_certtype.  Change all
	callers.
	(CERTTYPE_): Move constants to ...
	* common/dns-cert.h: here as DNS_CERTTYPE_.

	Move new mailbox.c source file to common/.
	* g10/mailbox.c: Move to ...
	* common/mbox-util.c: new file.
	* common/mbox-util.h: New. Include where needed.
	* g10/t-mailbox.c: Move to ...
	* common/t-mbox-util.c: new file.

2015-02-24  Werner Koch  <wk@gnupg.org>

	gpg: Add command --print-pka-records.
	* g10/gpg.c (main): Add command --print-pka-records.
	* g10/options.h (struct opt): Add field "print_pka_records".
	* g10/keylist.c (list_keyblock_pka): New.
	(list_keyblock): Call it if new option is set.
	(print_fingerprint): Add mode 10.

	gpg: Add function to extract the mailbox.
	* g10/misc.c (has_invalid_email_chars, is_valid_mailbox)
	(is_valid_user_id): Move to ...
	* g10/mailbox.c: new file.
	(string_has_ctrl_or_space, has_dotdot_after_at): New.
	(has_invalid_email_chars): New.

	* g10/t-mailbox.c: New.
	* g10/Makefile.am (module_tests): Add t-mailbox.
	(t_mailbox_SOURCES, t_mailbox_LDADD): New.

2015-02-23  Werner Koch  <wk@gnupg.org>

	gpg: Add option to print fingerprints in ICAO spelling.
	* g10/gpg.c: Add option --with-icao-spelling.
	* g10/options.h (struct opt): Add with_icao_spelling.
	* g10/keylist.c (print_icao_hexdigit): New.
	(print_fingerprint): Print ICAO spelling.

	gpg: Skip legacy keys while searching keyrings.
	* g10/getkey.c (search_modes_are_fingerprint): New.
	(lookup): Skip over legacy keys.

	common: Fix regression due to commit 2183683b.
	* common/dns-cert.c (get_dns_cert): Remove cruft.

2015-02-19  Werner Koch  <wk@gnupg.org>

	gpg: Replace remaining uses of stdio by estream.
	* g10/sign.c (sign_file):  Use log_printf instead of stderr.
	* g10/tdbdump.c (export_ownertrust): Use estream fucntions.
	(import_ownertrust): Ditto.
	* g10/tdbio.c (tdbio_dump_record): Ditto.  Change arg to estream_t.

	gpg: Fix segv due to NULL value stored as opaque MPI.
	* g10/build-packet.c (gpg_mpi_write): Check for NULL return from
	gcry_mpi_get_opaque.
	(gpg_mpi_write_nohdr, do_key): Ditto.
	* g10/keyid.c (hash_public_key): Ditto.

2015-02-12  Werner Koch  <wk@gnupg.org>

	scd: Fix regression in 2.1.2 (due to commit 2183683)
	* scd/apdu.c (pcsc_vendor_specific_init): Replace use of
	bufNN_to_uint by direct code.

2015-02-12  Andre Heinecke  <aheinecke@intevation.de>

	dirmngr: Initialize cache from sysconfig dir.
	* dirmngr/certcache.c (cert_cache_init): Load certificates
	from sysconfig dir instead of the homeidr.
	* dirmngr/dirmngr.c (main): Removed parsing of obsolete
	homedir_data option.
	* dirmngr/dirmngr.h (opt): Removed homedir_data.
	* doc/dirmngr.texi: Update and clarify certs directory doc.

2015-02-11  Werner Koch  <wk@gnupg.org>

	Release 2.1.2.

	dirmngr: Avoid warning about unused function.
	* dirmngr/dirmngr.c (my_gnutls_log): Build only if gnutls is used.

	build: Update standard build-aux files.

	Use inline functions to convert buffer data to scalars.
	* common/host2net.h (buf16_to_ulong, buf16_to_uint): New.
	(buf16_to_ushort, buf16_to_u16): New.
	(buf32_to_size_t, buf32_to_ulong, buf32_to_uint, buf32_to_u32): New.

2015-02-09  Werner Koch  <wk@gnupg.org>

	gpg: Prevent an invalid memory read using a garbled keyring.
	* g10/keyring.c (keyring_get_keyblock): Whitelist allowed packet
	types.
	* g10/keydb.c (parse_keyblock_image): Ditto.

	gpg: Fix a NULL-deref in export due to invalid packet lengths.
	* g10/build-packet.c (write_fake_data): Take care of a NULL stored as
	opaque MPI.

	gpg: Fix a NULL-deref due to empty ring trust packets.
	* g10/parse-packet.c (parse_trust): Always allocate a packet.

2015-02-04  Werner Koch  <wk@gnupg.org>

	gpg-agent: Use "pinentry-basic" as fallback.
	* common/homedir.c (get_default_pinentry_name): New.
	(gnupg_module_name): Use that for the default pinentry.
	(gnupg_module_name_flush_some): New.
	* agent/gpg-agent.c (agent_sighup_action): Flush some module names.
	* agent/call-pinentry.c (start_pinentry): Do not modify
	opt.pinentry_program.

	w32: Add manifest to gpg.
	* g10/gpg.w32-manifest.in: New.
	* g10/gpg-w32info.rc: Add manifest.
	* g10/Makefile.am (EXTRA_DIST): Add manifest.
	(gpg-w32info.o): Depend on manifest.
	* configure.ac (BUILD_VERSION): New.
	(AC_CONFIG_FILES): Add manifest.

2015-02-03  Werner Koch  <wk@gnupg.org>

	Update copyright years.
	* common/w32info-rc.h.in (W32INFO_COMPANYNAME): Change to "The GnuPG
	Project".

2015-02-02  Werner Koch  <wk@gnupg.org>

	w32: Change default Windows install dir and add bin to PATH.
	* build-aux/speedo.mk (WITH_GUI): New macro.  The Windows installer is
	now build by default without any GUI stuff.
	* build-aux/speedo/w32/inst.nsi: Change standard installation
	directory.
	(AddToPath, un.RemoveFromPath): New.
	(gnupginst): Add bin directory to the PATH.

2015-02-01  Werner Koch  <wk@gnupg.org>

	w32: Allow for Unicocde installation directory.
	* common/homedir.c (w32_rootdir): Use Unicode fucntion not only for
	WinCE.

2015-01-30  Joshua Rogers  <git@internot.info>

	kbx: Fix resource leak.
	* kbx/keybox-update.c (blob_filecopy): Fix resource leak.  On error
	return, 'fp' and 'newfp' was never closed.

2015-01-29  Werner Koch  <wk@gnupg.org>

	agent: Fix use of imported but unprotected openpgp keys.
	* agent/agent.h (PRIVATE_KEY_OPENPGP_NONE): New.
	* agent/command.c (do_one_keyinfo): Implement it.
	* agent/findkey.c (agent_key_from_file): Ditto.
	(agent_key_info_from_file): Ditto.
	(agent_delete_key): Ditto.
	* agent/protect.c (agent_private_key_type): Add detection for openpgp
	"none" method.

2015-01-29  NIIBE Yutaka  <gniibe@fsij.org>

	po: Update Japanese Translation.

2015-01-28  Werner Koch  <wk@gnupg.org>

	gpg: Limit the size of key packets to a sensible value.
	* g10/parse-packet.c (MAX_KEY_PACKET_LENGTH): New.
	(MAX_UID_PACKET_LENGTH): New.
	(MAX_COMMENT_PACKET_LENGTH): New.
	(MAX_ATTR_PACKET_LENGTH): New.
	(parse_key): Limit the size of a key packet to 256k.
	(parse_user_id): Use macro for the packet size limit.
	(parse_attribute): Ditto.
	(parse_comment): Ditto.

	gpg: Fix buffering problem in --list-config.
	* g10/gpg.c (list_config): Replace print_sanitized_string2 by
	es_write_sanitized.

	* common/stringhelp.c (print_sanitized_buffer2): Remove.
	(print_sanitized_buffer, print_sanitized_utf8_buffer): Remove.
	(print_sanitized_utf8_buffer, print_sanitized_utf8_string): Remove.
	(print_sanitized_string): Remove.

	* sm/certdump.c (print_dn_part, print_dn_parts): Remove arg FP.
	(pretty_print_sexp, gpgsm_print_name2, gpgsm_print_name): Remove.

	Add a hook to be called right after main.
	* common/init.c (early_system_init): New stub function.

	gpg: Allow predefined names as answer to the keygen.algo prompt.
	* g10/keygen.c (ask_algo): Add list of strings.

	agent: Add some extra robustness to extract_private_key.
	* agent/cvt-openpgp.c (extract_private_key): Add arg "arraysize".
	Make sure that R_FLAGS and R_CURVE are set to NULL.

2015-01-28  NIIBE Yutaka  <gniibe@fsij.org>

	scd: Fix varargs call for 64-bit arch on ECC keys.
	* scd/app-openpgp.c (store_fpr): Remove CARD_VERSION from the
	arguments.
	(rsa_writekey): Follow the change.
	(do_genkey): Likewise.
	(ecc_writekey): Likewise.  Cast to size_t.

2015-01-27  Werner Koch  <wk@gnupg.org>

	gpg: Fix segv introduced to commit 4d7c9b0.
	* g10/keygen.c (get_parameter_passphrase): Take care of R == NULL.

2015-01-27  NIIBE Yutaka  <gniibe@fsij.org>

	agent: Fix agent_public_key_from_file for ECC.
	* agent/cvt-openpgp.c (extract_private_key): New.
	(convert_to_openpgp): Use extract_private_key.
	* agent/findkey.c (agent_public_key_from_file): Use
	extract_private_key.

2015-01-26  Werner Koch  <wk@gnupg.org>

	sm: Simplify fix ed8383c6.
	* sm/minip12.c (p12_build): Release PWBUF only at the end.

2015-01-25  Joshua Rogers  <git@internot.info>

	ccid: Remove incorrect expression leading to errors.
	* scd/ccid-driver.c (send_escape_cmd): Fix setting of 'rc'.

2015-01-23  Werner Koch  <wk@gnupg.org>

	gpgconf: Fix validity check for UINT32 values.
	* tools/gpgconf-comp.c (option_check_validity): Enable check for
	UINT32.

2015-01-22  Werner Koch  <wk@gnupg.org>

	gpg: Improve skipping of PGP-2 keys.
	* g10/keydb.c (keydb_search_first, keydb_search_next): Skip legacy
	keys.
	* g10/keyring.c (keyring_get_keyblock): Handle GPG_ERR_LEGACY_KEY.
	(prepare_search): Ditto.
	(keyring_rebuild_cache): Skip legacy keys.
	* g10/keyserver.c (keyidlist): Ditto.
	* g10/trustdb.c (validate_key_list): Ditto.

	gpg: Add dedicated error code for PGP-2 keys.
	* g10/parse-packet.c (parse_key): Return GPG_ERR_LEGACY_KEY for PGP2
	keys.
	* g10/import.c (read_block): Simplify by checking GPG_ERR_LEGACY_KEY.
	* g10/getkey.c (lookup): Silence error message for PGP-2 keys.

	* common/util.h (GPG_ERR_LEGACY_KEY): Add replacement for older
	libgpg-error.

	gpg: Replace remaining old error code macros by GPG_ERR_.
	* g10/gpg.h (g10_errstr): Remove macro and change all occurrences by
	gpg_strerror.
	(G10ERR_): Remove all macros and change all occurrences by their
	GPG_ERR_ counterparts.

	gpg: Remove an unused variable.
	* g10/getkey.c (getkey_ctx_s): Remove last_rc.

2015-01-21  Werner Koch  <wk@gnupg.org>

	dirmngr: Fix TLS build problems.
	* dirmngr/Makefile.am (AM_CFLAGS): Add flags for TLS libs.

	gpg: Support --passphrase with --quick-gen-key.
	* g10/keygen.c: Include shareddefs.h.
	(quick_generate_keypair): Support static passphrase.
	(get_parameter_passphrase): New.
	(do_generate_keypair): Use it.

	gpg: Re-enable the "Passphrase" parameter for batch key generation.
	* agent/command.c (cmd_genkey): Add option --inq-passwd.
	* agent/genkey.c (agent_genkey): Add new arg override_passphrase.
	* g10/call-agent.c (inq_genkey_parms): Handle NEWPASSWD keyword.
	(agent_genkey): Add arg optional arg "passphrase".
	* g10/keygen.c (common_gen, gen_elg, gen_dsa, gen_ecc)
	(gen_rsa, do_create): Add arg "passphrase" and pass it through.
	(do_generate_keypair): Make use of pPASSPHRASE.
	(release_parameter_list): Wipe out a passphrase parameter.

2015-01-19  Werner Koch  <wk@gnupg.org>

	kbx: Minor cleanup for the previous fix.
	* kbx/keybox-search.c (blob_get_keyid): Rename to
	blob_get_first_keyid. Check number of keys and remove blob type check.

2015-01-19  Damien Goutte-Gattat  <dgouttegattat@incenp.org>

	kbx: Call skipfnc callback to filter out keys.
	* kbx/keybox-search.c (blob_get_keyid): New.
	(keybox-search): Call skipfnc callback function.

2015-01-13  Andreas Schwier  <andreas.schwier@cardcontact.de>

	scd: Allow for certificates > 1024 with PC/SC.
	* scd/pcsc-wrapper.c (handle_transmit): Enlarge buffer to 4096 too
	allow for larger certificates.

2015-01-08  NIIBE Yutaka  <gniibe@fsij.org>

